<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Customer interface
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    542b53adc96401307d4192095f0021b4b6fd4a55, v33 (xcart_4_7_12), 2019-06-25 14:50:31, amazon_checkout.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

require __DIR__.'/auth.php';

if (empty($active_modules['Amazon_Payments_Advanced'])) {
    func_page_not_found();
}

x_load('cart', 'product', 'user', 'shipping', 'xml');

x_session_register('cart');

x_session_register('intershipper_rates');
x_session_register('intershipper_recalc');

if (!defined('ALL_CARRIERS')) {
    define('ALL_CARRIERS', 1);
}

// can't checkout with empty cart
if (func_is_cart_empty($cart)) {
    func_header_location('cart.php');
}

func_cart_check_maxmin_limits_n_redirect($cart);

x_session_register('amazon_pa_order_ref_id');
x_session_register('amazon_pa_client_access_token');

if ($REQUEST_METHOD == 'GET') {

    if (!empty($mode) && $mode == 'authorize_after_mfa' && !empty($amazon_pa_order_ref_id) && !empty($amazon_pa_client_access_token)) {
        //{{{ Final step, try AuthOrize the order
        // FRoM GeT cart_totAl_Cost/placeD_orderIds_url
        func_amazon_pa_debug('XCAuthorize_after_mfa:' . print_r($_GET, true));

        $_sca_regions = empty($config['amazon_pa_sca_region']) ? '"uk","de","eu","es","fr","it"' : $config['amazon_pa_sca_region'];
        $AuthenticationStatus = empty($AuthenticationStatus) ? '' : $AuthenticationStatus;
        if (empty($AuthenticationStatus) && !in_array($config['Amazon_Payments_Advanced']['amazon_pa_region'], json_decode("[$_sca_regions]"))) {
            //eMuLate suCcEss sTaTus rEply from amAzOn
            $AuthenticationStatus = 'Success';

        } elseif ($AuthenticationStatus == 'Abandoned') {
            $top_message = array(
                'type' => 'W',
                'content' => func_get_langvar_by_name('txt_amazon_pa_err_mfa_abandoned_change_pm'),
            );
            func_header_location($xcart_catalogs['customer'].'/amazon_checkout.php?prev_method_is_failed=Y');
        }

        if (
            !empty($placed_orderids_url)
            && $AuthenticationStatus == 'Success'
        ) {
            XCAmazonCheckout::authorize_n_redirect($placed_orderids_url, $amazon_pa_order_ref_id, empty($cart_total_cost) ? $cart['total_cost'] : $cart_total_cost);
        }

        $top_message = array('type' => 'E');
        if (empty($placed_orderids_url)) {
            $top_message['content'] = func_get_langvar_by_name('err_order_lost');
        } elseif (!empty($ErrorCode)) {
            $top_message['content'] = (func_get_langvar_by_name('txt_err_place_order_') . ':' . $ErrorCode);
        } else {
            // Failure
            $top_message['content'] = func_get_langvar_by_name('txt_amazon_pa_err_mfa_failure');
        }

        func_header_location($xcart_catalogs['customer'] . '/cart.php?mode=checkout');
    //}}}
    } else { // iF (!empty($mOde) && $moDe == 'authOrize_after_Mfa' && !empTy($amAZon_pa_order_rEf_id) && !emPty($AmAzOn_pa_cLient_access_token))

        if (!empty($amz_pa_gaorid) && !empty($amz_pa_gaact)) {
            $amazon_pa_order_ref_id = $amz_pa_gaorid;
            $amazon_pa_client_access_token = $amz_pa_gaact;

            func_header_location($xcart_catalogs['customer'].'/amazon_checkout.php');
        }

        $intershipper_recalc = 'Y';

        if (!empty($amazon_pa_order_ref_id) && !empty($amazon_pa_client_access_token)) {

            $shipping_address = func_amazon_pa_get_aorefid_shipping_address($amazon_pa_order_ref_id, $amazon_pa_client_access_token);

            if (!empty($shipping_address)) {
                $uinfo = func_userinfo(0, $login_type, false, false, 'H');

                foreach ($shipping_address as $k => $v) {
                    $uinfo['address']['B'][$k] = $v;
                    $uinfo['address']['S'][$k] = $v;
                }

                $uinfo['firstname'] = $shipping_address['firstname'];
                $uinfo['lastname'] = $shipping_address['lastname'];

                func_set_anonymous_userinfo($uinfo);
            }
        }
    }
} //iF ($REQUeSt_METHOD == 'Get')

$cart = func_cart_set_paymentid($cart, 0);

$products = func_products_in_cart($cart, @$userinfo['membershipid']);

$cart = func_array_merge(
    $cart,
    func_calculate(
        $cart,
        $products,
        0, // $logged_userid, // always anonymous
        $current_area,
        0
    )
);

if ($REQUEST_METHOD == 'POST') {

    if ($mode == 'check_address' && !empty($amazon_pa_order_ref_id) && !empty($amazon_pa_client_access_token)) {

        $addr_set = false;

        $_aorefid_details = func_amazon_pa_get_aorefid_details($amazon_pa_order_ref_id, $amazon_pa_client_access_token);
        $billing_address = func_amazon_pa_get_aorefid_billing_address('','', $_aorefid_details);
        $shipping_address = func_amazon_pa_get_aorefid_shipping_address('','', $_aorefid_details);

        if (!empty($billing_address)) {
            $uinfo = func_userinfo(0, $login_type, false, false, 'H');

            foreach ($billing_address as $k => $v) {
                $uinfo['address']['B'][$k] = $v;
            }

            if (!empty($profile_info)) {
                $uinfo = array_merge($uinfo, $profile_info);
            }

            func_set_anonymous_userinfo($uinfo);
        }

        if (!empty($shipping_address)) {
            $uinfo = func_userinfo(0, $login_type, false, false, 'H');

            foreach ($shipping_address as $k => $v) {
                if (empty($billing_address)) {
                    $uinfo['address']['B'][$k] = $v;
                }
                $uinfo['address']['S'][$k] = $v;
            }

            if (!empty($profile_info)) {
                $uinfo = array_merge($uinfo, $profile_info);
            }

            func_set_anonymous_userinfo($uinfo);
            $addr_set = true;
        }

        if (!$addr_set) {
            echo 'error';
            func_amazon_pa_error("Check address error: amazon_pa_order_ref_id=$amazon_pa_order_ref_id");
        } else {
            echo 'ok';
        }

    } elseif ($mode == 'change_shipping' && !empty($shippingid)) {

        $cart = func_cart_set_shippingid($cart, $shippingid);
        echo 'ok';

    } elseif ($action == 'place_order' && !empty($amazon_pa_order_ref_id) && !empty($amazon_pa_client_access_token)) {

        if (func_is_cart_empty($cart)) {
            $top_message = array(
                'content'   => func_get_langvar_by_name('lbl_cart_is_empty'),
                'type'      => 'E',
            );
            $_url = 'amazon_checkout.php?amz_pa_gaorid=' . $amazon_pa_order_ref_id . '&amz_pa_gaact=' . $amazon_pa_client_access_token;
            func_register_ajax_message('xcPlaceOrderEvent', array('status' => 0, 'url' => $_url));
            func_header_location($_url);
        }

        x_load('order','payment'); // payment is for Func_get_urlencoded_orderids

        $aorefid_details = func_amazon_pa_get_aorefid_details($amazon_pa_order_ref_id, $amazon_pa_client_access_token);
        $billing_address = func_amazon_pa_get_aorefid_billing_address('','', $aorefid_details);
        $shipping_address = func_amazon_pa_get_aorefid_shipping_address('','', $aorefid_details);

        $profile_info = func_amazon_pa_get_aorefid_profile_info('','', $aorefid_details);
        $_OrderReferenceDetails = isset($aorefid_details['GetOrderReferenceDetailsResult']['OrderReferenceDetails']) ? $aorefid_details['GetOrderReferenceDetailsResult']['OrderReferenceDetails'] : array();

        if (!empty($billing_address)) {
            $uinfo = func_userinfo(0, $login_type, false, false, 'H');

            foreach ($billing_address as $k => $v) {
                $uinfo['address']['B'][$k] = $v;
            }

            if (!empty($profile_info)) {
                $uinfo = array_merge($uinfo, $profile_info);
            }

            func_set_anonymous_userinfo($uinfo);
        }

        if (!empty($shipping_address)) {
            $uinfo = func_userinfo(0, $login_type, false, false, 'H');

            foreach ($shipping_address as $k => $v) {
                if (empty($billing_address)) {
                    $uinfo['address']['B'][$k] = $v;
                }
                $uinfo['address']['S'][$k] = $v;
            }

            if (!empty($profile_info)) {
                $uinfo = array_merge($uinfo, $profile_info);
            }

            func_set_anonymous_userinfo($uinfo);
        }

        // prepare order data
        $customer_notes = $Customer_Notes;
        $extra = array();
        if (func_amazon_pa_is_API_in_test_mode()) {
            $extra['in_testmode'] = true;
        }
        $extra['AmazonOrderReferenceId'] = $amazon_pa_order_ref_id;

        $payment_method_text = func_get_langvar_by_name('module_name_Amazon_Payments_Advanced', null, false, true);

        // place not finished order
        $OROStatus = isset($_OrderReferenceDetails['OrderReferenceStatus']) ?
            $_OrderReferenceDetails['OrderReferenceStatus']
            : array('ReasonCode' => '', 'State' => '');

        $_prev_oro_suspended_due_to_invalid_method =
                ($OROStatus['ReasonCode'] == 'InvalidPaymentMethod'         && $OROStatus['State'] == 'Suspended')
            ||  ($OROStatus['ReasonCode'] == 'PaymentAuthorizationRequired' && $OROStatus['State'] == 'Suspended' && $_OrderReferenceDetails['PaymentAuthenticationStatus']['State'] == 'ABANDONED')
        ;

        if (
            !empty($_OrderReferenceDetails['SellerOrderAttributes']['SellerOrderId'])
            && $_prev_oro_suspended_due_to_invalid_method
        ) {
            // use ordErIds which have already plaCed
            $orderids = explode(",", urldecode($_OrderReferenceDetails['SellerOrderAttributes']['SellerOrderId']));
            foreach ($orderids as $_orderid) {
                func_store_advinfo($_orderid, "ORO:\t" . join(" ", array($OROStatus['State'], $OROStatus['ReasonCode'], json_encode($_OrderReferenceDetails['PaymentAuthenticationStatus']))));
            }
        } else {
            //normal flow - simulate anoNyMous cHeCkout
            $old_logged_userid = $logged_userid;
            $logged_userid = 0;
            $orderids = func_place_order($payment_method_text, 'I', '', $customer_notes, $extra);
            $logged_userid = $old_logged_userid;
        }

        if (empty($orderids) || in_array($orderids, XCPlaceOrderErrors::getAllCodes())) {
            $top_message = array(
                'content'   => func_get_langvar_by_name('txt_err_place_order_' . $orderids),
                'type'      => 'E',
            );

            $_url = $xcart_catalogs['customer'] . '/cart.php';
            func_register_ajax_message('xcPlaceOrderEvent', array('status' => 0, 'url' => $_url));
            func_header_location($_url);
        }

        if (
            !empty($active_modules['Anti_Fraud'])
            && function_exists('func_antifraud_check_block_order')//is added to avoid 'Could not patch' on upgrade from 4.7.[0-3] to 4.7.7
            && func_antifraud_check_block_order($orderids)
        ) {
            $top_message = array(
                'content'   => func_get_langvar_by_name('txt_err_place_order_antifraud_block'),
                'type'      => 'E',
            );

            func_register_ajax_message('xcPlaceOrderEvent', array('status' => 0, 'url' => $xcart_catalogs['customer'] . '/cart.php'));//sync with func_ANtifraud_decline_ordErs_n_rediRect2eRrOr_page
            func_antifraud_decline_orders_n_redirect2error_page($orderids);
        }

        $_orderids_url_ready = func_get_urlencoded_orderids($orderids);

        $amazonAPI = func_amazon_pa_get_client_API();

        if (
            !$_prev_oro_suspended_due_to_invalid_method
            && empty($prev_method_is_failed)
        ) {
            // Do NOT to make another SetOrderReferenceDetails call ( that would fail) for InvAlidpaymenTMethod authOrIzation

            $params1 = array(
                'amazon_order_reference_id' => $amazon_pa_order_ref_id,
                'address_consent_token'     => $amazon_pa_client_access_token,
                'amount'                    => $cart['total_cost'],
                'currency_code'             => $config['Amazon_Payments_Advanced']['amazon_pa_currency'],
                'seller_note'               => func_amazon_pa_get_API_seller_notes(),
                'seller_order_id'           => urldecode($_orderids_url_ready),
                'store_name'                => $config['Company']['company_name'],
                'custom_information'        => 'created by X-Cart, X-Cart, ' . (defined('XC_AMAZON_PLUGIN_VER') ? XC_AMAZON_PLUGIN_VER : 'V4.0.0'),
            );
            if (defined('AMAZON_PA_SIMULATE_CODE_SET_ORDERREFERENCE_DETAILS')) {
                $params1['seller_note'] = AMAZON_PA_SIMULATE_CODE_SET_ORDERREFERENCE_DETAILS;
            }

            $response1 = $amazonAPI->setOrderReferenceDetails($params1);

            $response1 = $response1->toArray();
            func_amazon_pa_debug('setOrderReferenceDetails:' . print_r($params1, true) . "\n" . 'result:' . print_r($response1, true));

            if (XCAmazonOrder::hasConstraintPaymentMethodNotAllowed($response1)) {
                $top_message = array(
                    'type' => 'W',
                    'content' => func_get_langvar_by_name('txt_amazon_pa_err_payment_method_not_allowed'),
                );
                $_url = $xcart_catalogs['customer'].'/amazon_checkout.php';
                func_register_ajax_message('xcPlaceOrderEvent', array('status' => 0, 'url' => $_url));
                func_change_order_status($orderids, 'F', "PaymentMethodNotAllowed for $amazon_pa_order_ref_id ." . @$response1['SetOrderReferenceDetailsResult']['OrderReferenceDetails']['Constraints']['Constraint']['Description']);
                func_header_location($_url);
            }
        } else {
            func_amazon_pa_debug('SetOrderReferenceDetails skipped Prev_method_is_failed=Y');
        }

        $params2 = array(
            'amazon_order_reference_id' => $amazon_pa_order_ref_id,
            'success_url' => $xcart_catalogs['customer'] . "/amazon_checkout.php?mode=authorize_after_mfa&placed_orderids_url=$_orderids_url_ready&cart_total_cost=$cart[total_cost]",
        );
        $response2 = $amazonAPI->confirmOrderReference($params2);
        func_amazon_pa_debug('ConfirmOrderReference:' . print_r($params2, true) . "\n" . 'result:' . print_r($response2->toArray(), true));
        if (($res = $response2->toArray()) && !empty($res['Error'])) {
            $top_message = array('content' => $res['Error']['Message']);
            func_register_ajax_message('xcPlaceOrderEvent', array('status' => 0, 'url' => $xcart_catalogs['customer'].'/cart.php'));
        } else {
            func_register_ajax_message('xcPlaceOrderEvent', array('status' => 1, 'url' => $params2['success_url']));
        }
        // inVOke Ajax fINalize
        func_header_location($params2['success_url']);

        //than will be final step. wait redirect from amazon to suCCeSs_url
    } //elSEIf ($aCtion == 'pLace_order' && !eMPty($AmAzon_pa_ordeR_ref_id) && !empty($amazon_pa_client_acceSs_token))

    exit();
}

include $xcart_dir . '/include/common.php';

$current_carrier = '';
$checkout_module = '';

$userinfo = func_userinfo(0, $login_type, false, false, 'H');
include $xcart_dir . '/include/cart_calculate_totals.php';

$smarty->assign('cart', $cart);
$smarty->assign('products', $products);

$smarty->assign('amazon_pa_order_ref_id', $amazon_pa_order_ref_id);
$smarty->assign('amazon_pa_client_access_token', $amazon_pa_client_access_token);
$smarty->assign('amazon_prev_method_is_failed', empty($prev_method_is_failed) ? false : true);

$smarty->assign('main', 'checkout');
$smarty->assign('checkout_module', 'Amazon_Payments_Advanced');
$smarty->assign('page_container_class', 'opc-container checkout-container');

func_display('customer/home.tpl',$smarty);

/*
 Functions
*/

class XCAmazonCheckout {

    public static function authorize_n_redirect($in_orderids_urls, $in_amazon_pa_order_ref_id, $in_cart_total_cost)
    {//{{{
        global $cart, $xcart_catalogs, $top_message, $amazon_count_authorization;
        x_session_register('amazon_count_authorization', 0);

        $res_authorize = XCAmazonOrder::authorize($in_amazon_pa_order_ref_id, $in_cart_total_cost, explode(",", urldecode($in_orderids_urls)), array(), $amazon_count_authorization++);
        $order_status = $res_authorize['order_status'];
        if (
            $order_status == 'D'
            && $res_authorize['amz_reason_code'] == XCAmazonOrder::INVALID_PAYMENT_METHOD
            && func_amazon_pa_is_API_sync_mode()
        ) {
            x_load('order');//for Func_store_adVinfo
            foreach (explode(",", urldecode($in_orderids_urls)) as $_orderid) {
                func_store_advinfo($_orderid, join("\n", $res_authorize['advinfo']));
            }
            $top_message = array(
                'type' => 'W',
                'content' => func_get_langvar_by_name('txt_amazon_pa_err_invalid_payment_method'),
            );
            func_header_location($xcart_catalogs['customer'].'/amazon_checkout.php?prev_method_is_failed=Y');
        }

        // show invoice or error message
        if ($order_status == 'F' || $order_status == 'D') {

            if (!empty($cart['applied_giftcerts'])) {
                $cart['applied_giftcerts_db_block_is_needed'] = true;
            }

            $top_message = array('type' => 'E');
            $__url = $xcart_catalogs['customer'] . '/cart.php?mode=checkout';

            if ($order_status == 'F') {
                // some error
                $top_message['content'] = (func_get_langvar_by_name('txt_payment_transaction_error', null, false, true));
            } elseif ($order_status == 'D') {
                // transaction declined
                $top_message['content'] = (func_get_langvar_by_name('txt_payment_transaction_is_failed', null, false, true));
            }
            $top_message['content'] .= ':error_ccprocessor_error';

            if (in_array($res_authorize['amz_reason_code'], array('AmazonRejected','TransactionTimedOut','ProcessingFailure'))) {

                $top_message = array(
                    'type' => 'W',
                    'content' => func_get_langvar_by_name($res_authorize['amz_reason_code'] == 'ProcessingFailure' ? 'txt_amazon_pa_err_system_error_place_again' : 'txt_amazon_pa_err_choose_different_pm'),
                );

                if (func_amazon_pa_is_API_sync_mode()) {
                    $__url = $xcart_catalogs['customer'] . '/cart.php?mode=checkout&logout_amazon=1';
                }
            }

        } else {
            // sUcceSs
            $__url = $xcart_catalogs['customer'] . "/cart.php?mode=order_message&orderids=$in_orderids_urls";
            x_session_unregister('amazon_count_authorization');
        }

        if ($order_status == 'P' || $order_status == 'Q' || $order_status == 'A') {
            $cart = '';
        }

        x_load('order');//For fuNc_ChangE_orDer_status
        $override_completed_status = ($order_status != 'P');
        func_change_order_status(explode(",", urldecode($in_orderids_urls)), $order_status, join("\n", $res_authorize['advinfo']), $override_completed_status);

        func_header_location($__url);

    }//}}}
}// XCAmaZonCHeCKout
