<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * REST API controller
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    709ca6dd92799e0f3bd05cc3c5c212bd283ed8e6, v1 (xcart_4_7_12), 2020-02-06 20:05:09, gak_admin.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

#IN: _key _path
require __DIR__.'/top.inc.php';

define('DO_NOT_START_SESSION', 1);
define('SKIP_CHECK_REQUIREMENTS.PHP', true);


if (
    !empty($_GET['_path'])
    && $_GET['_path'] == 'testme'
) {
    echo 'I am alive!';
    header('HTTP/1.0 200 OK');
    exit;
}

if (!empty($_GET['_path']) &&
    (
        preg_match('%order%', $_GET['_path'])
    )
) {
    // Only For Order Path
    define('USE_SIMPLE_SESSION_INTERFACE', true);
    $__load_blowich = true;
} elseif (
    empty($_GET['_path'])
    || (
        !preg_match('%product%', $_GET['_path'])
        && !preg_match('%shop_currency%', $_SERVER['REQUEST_URI'])
    )
) {
    //For All Gets/Puts/Posts Except Get-Product/Get-Shop_currency
    define('USE_SIMPLE_DB_INTERFACE', true);
    define('QUICK_START', true);
}

if (empty($_GET['_path']) || !preg_match('%product%', $_GET['_path'])) {
    //Quick Load For All Except Get-Product
    define('LOAD_ONLY_MODULES_CONFIGS', true);
}

require __DIR__.'/init.php';

if (
    empty($config['Google_Ads_Kliken']['google_adskliken_restkey_write'])
    && empty($config['Google_Ads_Kliken']['google_adskliken_restkey_read'])
) {
    header("HTTP/1.1 403 Forbidden");
    echo 'empty keys';
    exit;
}

if (empty($_path)) {
    header("HTTP/1.1 403 Forbidden");
    echo 'empty path';
    exit;
}

if (empty($_key) || strlen($_key) <= 31) {
    header("HTTP/1.1 403 Forbidden");
    echo empty($_key) ? 'empty key' : 'short key, has to be at least 31';
    exit;
}



if (!empty($__load_blowich)) {
    include_once($xcart_dir . '/include/blowfish.php');
}

include $xcart_dir . '/modules/Google_Ads_Kliken/rest_api_server.php';
