<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Sessions-related functionality
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Lib
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    fc022eafc2b7d381407eb1bb05d3de57fee3086f, v209 (xcart_4_7_11), 2019-04-19 08:20:48, sessions.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

/**
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 * DO NOT CHANGE ANYTHING BELOW THIS LINE UNLESS
 * YOU REALLY KNOW WHAT YOU ARE DOING
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 */

if (defined('XCART_SESSION_START'))
    return;

define('XCART_SESSION_START', 1);

/**
 * Session unknown id limit
 */
define('X_SESSION_UNKNOWN_LIMIT', 3);

/**
 * Session duration (in seconds) for pos operator
 */
define('XC_POS_OPERATOR_SESSION_LENGTH', 39600);

/**
 * PHP build-in sessions tuning (for type '1' & '2')
 */

// PHP 4.3.0 and higher allow to turn off trans-sid using this command:
ini_set('url_rewriter.tags','');
// Let's garbage collection will occurs more frequently
ini_set('session.gc_probability',90);
ini_set('session.gc_divisor',100); // for PHP >= 4.3.0
ini_set('session.use_cookies', false);

/**
 * Anti cache block
 */

if (defined('SET_EXPIRE')) {
    header("Expires: ".gmdate("D, d M Y H:i:s", constant('SET_EXPIRE'))." GMT");
} else {
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
}

header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");

if (defined('SET_EXPIRE')) {
    header("Cache-Control: public");
}
elseif ($HTTPS) {
    header("Cache-Control: private, must-revalidate");
}
else {
    header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
    header("Pragma: no-cache");
}

if (defined('DO_NOT_START_SESSION') && !defined('DEMO_MODE')) {

    return;

}

/**
 * Get session id
 */
if (isset($_POST[$XCART_SESSION_NAME])) {

    $session_source = 'P';

    $XCARTSESSID = $_POST[$XCART_SESSION_NAME];

} elseif (isset($_GET[$XCART_SESSION_NAME])) {

    $session_source = 'G';

    $XCARTSESSID = $_GET[$XCART_SESSION_NAME];

} elseif (isset($_COOKIE[$XCART_SESSION_NAME])) {

    $session_source = 'C';

    $XCARTSESSID = $_COOKIE[$XCART_SESSION_NAME];

} else {

    $session_source = false;

    $XCARTSESSID = false;

}

$md5_REMOTE_ADDR = md5($REMOTE_ADDR);

if (func_session_use_history()) {//{{{

    $session_host = empty($HTTP_HOST) ? "" : $HTTP_HOST;

    // Remembers xid
    if (!empty($XCARTSESSID)) {

        if ($session_source == 'C') {

            // Remembers xid if a user goes to old host
            $remember_xid = func_query_first_cell("SELECT dest_xid FROM $sql_tbl[session_history] WHERE ip = '$md5_REMOTE_ADDR' AND host = '$session_host' AND xid = '$XCARTSESSID'");

            if (
                $remember_xid
                && !func_binary_empty($remember_xid)
                && !func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[sessions_data] WHERE sessid = '$XCARTSESSID'")//!is_session_exists
            ) {
                $XCARTSESSID = $remember_xid;
                $session_source = 'R';
            }

        } elseif (
            isset($_COOKIE[$XCART_SESSION_NAME])
            && in_array($session_source, array('G', 'P'))
//          && func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[sessions_data] WHERE sessid = '" . $_COOKIE[$XCART_SESSION_NAME] . "'") // comment for IN sql query below
//          && !func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[sessions_data] WHERE sessid = '$XCARTSESSID'")//!is_session_exists
        ) {
            $_ids_history = array_flip(func_query_column("SELECT sessid FROM $sql_tbl[sessions_data] WHERE sessid IN ('" . $_COOKIE[$XCART_SESSION_NAME] . "', '$XCARTSESSID')"));
            if (
                isset($_ids_history[$_COOKIE[$XCART_SESSION_NAME]])
                && !isset($_ids_history[$XCARTSESSID])
            ) {
                // Remembers xid if a user goes to cached page with old xid (form / link)
                $XCARTSESSID = $_COOKIE[$XCART_SESSION_NAME];
                $session_source = 'R';
            }
        }
    }
}//}}}

$init_xid = $XCARTSESSID;
x_session_start($XCARTSESSID);

register_shutdown_function('x_session_finish');

// Save current xid for current host
x_session_register('is_robot');

if (empty($is_robot)) {
    $_robot = XCRobots::getRobotName();
    $_is_robot = !empty($_robot);
} else {
    $_is_robot = ($is_robot == 'Y');
}

if (1
    && !empty($HTTP_HOST)
    && !$_is_robot
    && func_session_use_history()
    && func_is_valid_ip($REMOTE_ADDR)
) {//{{{
    $old_xid = func_query_first("SELECT xid, dest_xid FROM $sql_tbl[session_history] WHERE ip = '$md5_REMOTE_ADDR' AND host = '$session_host'");

    if (empty($old_xid)) {

        db_query("REPLACE INTO $sql_tbl[session_history] (`ip`, `host`, `xid`, `dest_xid`) VALUES ('$md5_REMOTE_ADDR', '$session_host', '$XCARTSESSID', '')");

    } elseif(
        $old_xid['xid'] != $XCARTSESSID
        || !func_binary_empty($old_xid['dest_xid'])
    ) {

        func_array2update(
            'session_history',
            array(
                'xid' => $XCARTSESSID,
                'dest_xid' => '',
            ),
            "ip = '$md5_REMOTE_ADDR' AND host = '$session_host'"
        );
    }

    // Update destination xid for other hosts
    if (
        !empty($init_xid)
        && $init_xid != $XCARTSESSID
    ) {
        db_query("UPDATE $sql_tbl[session_history] SET dest_xid = '$XCARTSESSID' WHERE ip = '$md5_REMOTE_ADDR' AND host != '$session_host' AND (xid = '$init_xid' OR dest_xid = '$init_xid')");
    }
}//}}}

/**
 * Remove xid from URL
 */
if (TRUE
    && !empty($REQUEST_METHOD)
    && $REQUEST_METHOD == 'GET'
    && !empty($QUERY_STRING)
    && preg_match("/(?:^|\&)" . preg_quote($XCART_SESSION_NAME, '/') . "=[\d\w]+/", $QUERY_STRING)
) {//{{{
    x_session_register('xid_remove_try', true);

    if (
        $xid_remove_try
        || !empty($_COOKIE)
    ) {

        $xid_remove_try = false;

        $qs = func_qs_remove($QUERY_STRING, $XCART_SESSION_NAME);

        func_header_location($php_url['url'] . (empty($qs) ? "" : ("?" . $qs)), true, 302, true);

    }

    $xid_remove_try = true;
}//}}}

if (defined('NEW_SESSION')) {

    x_session_register('is_new_session', true);

} elseif (x_session_is_registered('is_new_session')) {

    x_session_unregister('is_new_session');

}

#################################################################
//   FUNCTIONS
#################################################################

/**
 * Start session
 */
function x_session_start($sessid = '') { // {{{
    global $XCART_SESSION_VARS, $XCART_SESSION_NAME, $XCARTSESSID, $XCART_SESSION_EXPIRY;
    global $sql_tbl, $config;
    global $top_message;

    // $sessid should contain only '0'..'9' or 'a'..'z' or 'A'..'Z'
    if (
        !is_string($sessid) 
        || strlen($sessid) != 32 //must be md5 value
        || preg_match('/[^0-9a-z]/Ssi', $sessid)
    ) {
        $sessid = '';
    }

    // Always generate unique id for new sessions
    $XCART_SESSION_VARS = array();
    $l = isset($_SERVER['REMOTE_PORT']) ? $_SERVER['REMOTE_PORT'] : 0;
    list($usec, $sec) = explode(' ', microtime());
    srand((float) $sec + ((float) $usec * 1000000) + (float)$l);

    // Delete expired sessions
    if (!mt_rand(0, 60)) { // {{{
        // For performance purposes use mt_rand
        $delete_ids = func_query_column("SELECT sessid FROM $sql_tbl[sessions_data] WHERE expiry < '" . XC_TIME . "'");
        if (!empty($delete_ids)) {
            db_query("DELETE FROM $sql_tbl[sessions_data] WHERE expiry < '" . XC_TIME . "'");
            func_delete_session_related_data($delete_ids);
        }
    } //}}}

    if (empty($sessid)) {
        $sessid = x_session_generateid();
        $sess_data = array();
    } else {
        $sess_data = func_query_first("SELECT * FROM $sql_tbl[sessions_data] WHERE sessid='$sessid'");

        if (empty($sess_data)) {
            // Change $sessid to new for security reason
            $sessid = x_session_generateid();
        }
    }

    if ($sess_data) {
        $XCART_SESSION_VARS = x_session_unserialize($sess_data['data']);
        // Enable only for admin and provider areas because does not work correctly in the IE 8 browser in the customer area.
        if (
            defined('AREA_TYPE')
            && in_array(AREA_TYPE, array('A', 'P'))
            && !func_skip_fingerprint_check()
            && $sess_data['signature'] != x_session_get_fg($sessid, $sess_data['start'], $sess_data['expiry'])
        ) {
            defined('XC_ALLOWED_ASSERT') && assert(false , __FUNCTION__.': Session is dropped, check if you use dynamic IPs');
            // Check session by fingerprint

            // Some users type 'FALSE' as value instead of FALSE
            if (
                XC_TIME - $sess_data['start'] < SECONDS_PER_MIN*40
                && XCSecurity::PROTECT_XID_BY_IP
                && XCSecurity::PROTECT_XID_BY_IP !== 'FALSE'
            ) {
                // Previous session has timelife < 40 min
                $show_warning_about_ip = TRUE;
            }

            $sess_data = FALSE;
            db_query("DELETE FROM $sql_tbl[sessions_data] WHERE sessid='$sessid'");
            $sessid = x_session_generateid();
        } elseif (
            isset($XCART_SESSION_VARS['_session_force_regenerate'])
            || func_check_regen_sess_condition()
        ) {
            // Change session
            unset($XCART_SESSION_VARS['_session_force_regenerate']);
            $new_sessid = x_session_generateid();
            func_session_change($sessid, $new_sessid);

            $new_signature = x_session_get_fg($new_sessid, $sess_data['start'], $sess_data['expiry']);
            db_query("UPDATE $sql_tbl[sessions_data] SET sessid='$new_sessid', signature='$new_signature' WHERE sessid='$sessid'");
            $sessid = $new_sessid;
        }
    }

    if (!empty($sess_data['data'])) {
        $xcart_session_length_add_to_pos_operator = func_get_pos_operator_session_duration($sess_data['data']);
    } else {
        $xcart_session_length_add_to_pos_operator = 0;
    }

    defined('XC_ALLOWED_ASSERT') && assert(defined("XCART_SESSION_LENGTH"), 'XCART_SESSION_LENGTH is not defined');
    $expiry_time = XC_TIME + XCART_SESSION_LENGTH + $xcart_session_length_add_to_pos_operator;
    if (empty($sess_data)) {
        if (!defined('NEW_SESSION')) {
            define('NEW_SESSION', TRUE);
        }

        $XCART_SESSION_VARS = array();
        $_is_external_robot = XCRobots::isExternalRobot(XCRobots::getRobotName());

        if (!$_is_external_robot) {
            func_array2insert(
                'sessions_data',
                array(
                    'sessid' => $sessid,
                    'start'  => XC_TIME,
                    'expiry' => $expiry_time,
                    'data'   => addslashes(serialize($XCART_SESSION_VARS)),
                    'signature' => x_session_get_fg($sessid, XC_TIME, $expiry_time),
                ),
                TRUE);
        }

        if (!empty($show_warning_about_ip)) {

            x_session_register('top_message');
            $top_message = array(
                'content' => func_get_langvar_by_name('txt_session_was_dropped', null, false, true),
                'type' => "E"
            );
        }

    } elseif ($sess_data['expiry'] + 200 < $expiry_time) { // Performance: update expiry every 200 sec
        $new_signature = x_session_get_fg($sessid, $sess_data['start'], $expiry_time);
        db_query("UPDATE $sql_tbl[sessions_data] SET expiry='$expiry_time', signature='$new_signature' WHERE sessid='$sessid'");
    }

    $XCART_SESSION_EXPIRY = $expiry_time;
    $XCARTSESSID = $sessid;
    func_setcookie($XCART_SESSION_NAME, $XCARTSESSID);
} // }}}

/**
 * Change current session to session with specified ID
 */
function x_session_id($sessid = '', $re_register = 're_register_vars') { //{{{
    global $sql_tbl, $XCART_SESSION_VARS, $XCARTSESSID, $XCART_SESSION_UNPACKED_VARS;

    $XCART_SESSION_VARS = array();

    if ($sessid) {

        $sess_data = func_query_first("SELECT * FROM $sql_tbl[sessions_data] WHERE sessid='$sessid'");

        $XCARTSESSID = $sessid;

        if ($sess_data) {

            $XCART_SESSION_VARS = x_session_unserialize($sess_data['data']);

            if (!empty($XCART_SESSION_UNPACKED_VARS)) {

                foreach ($XCART_SESSION_UNPACKED_VARS as $var => $v) {

                    if (isset($GLOBALS[$var]))
                        unset($GLOBALS[$var]);

                    unset($XCART_SESSION_UNPACKED_VARS[$var]);

                }

            }

            $sess_registered_vars = x_session_register_calls();

            if (
                $re_register == 're_register_vars'
                && !empty($sess_registered_vars)
            ) {
                foreach ($sess_registered_vars as $var) {
                    if (
                        isset($GLOBALS[$var])
                        || !isset($XCART_SESSION_VARS[$var])
                    ) {
                        continue;
                    }
                    $GLOBALS[$var] = $XCART_SESSION_VARS[$var];
                }
            }

        } else {

            x_session_start($sessid);

        }

    } else {

        $sessid = $XCARTSESSID;

    }

    return $sessid;
}//}}}

/**
 * Cut off variable if it came from _GET, _POST or _COOKIES
 */
function check_session_var($varname) { // {{{
    return !isset($_GET[$varname]) && !isset($_POST[$varname]) && !isset($_COOKIE[$varname]);
} //}}}

/**
 * Register or return all x_session_register calls in current php static scope
 */
function x_session_register_calls($varname = '') { // {{{
    static $sess_registered_vars = array();
    
    if (empty($varname))
        return array_keys($sess_registered_vars);

    // Register registred variables 
    $sess_registered_vars[$varname] = 1;

    return true;
} //}}}

/**
 * Get session value without changing global, default-null is used to avoid PHP Fatal error: Uncaught Error: Cannot increment/decrement string offsets in PHP7.1
 */
function x_session_get_var($varname, $default = null) { // {{{
    global $XCART_SESSION_VARS;
    $array_session_variables = array(
        'top_message','cart',
    );

    if (!isset($XCART_SESSION_VARS[$varname])) {
        $session_value = isset($GLOBALS[$varname]) && check_session_var($varname)
            ? $GLOBALS[$varname]
            : $default;

    } elseif (isset($GLOBALS[$varname]) && check_session_var($varname)) {
        $session_value = $GLOBALS[$varname];
    } else {
        $session_value = $XCART_SESSION_VARS[$varname];
    }

    if (
        empty($session_value)
        && in_array($varname, $array_session_variables)
    ) {
        //php7.1 compatible hack
        $session_value = array();
    }

    return $session_value;
} //}}}

/**
 * Register variable XCART_SESSION_VARS array from the database, default-null is used to avoid PHP Fatal error: Uncaught Error: Cannot increment/decrement string offsets in PHP7.1
 */
function x_session_register($varname, $default = null) { // {{{
    global $XCART_SESSION_VARS, $XCART_SESSION_UNPACKED_VARS;

    if (empty($varname))
        return false;

    $XCART_SESSION_VARS[$varname] = x_session_get_var($varname, $default);

    // Unpack variable $varname from $XCART_SESSION_VARS array
    $XCART_SESSION_UNPACKED_VARS[$varname] = $XCART_SESSION_VARS[$varname];

    $GLOBALS[$varname] = $XCART_SESSION_VARS[$varname];

    x_session_register_calls($varname);
} //}}}

/**
 * Save the XCART_SESSION_VARS array in the database
 */
function x_session_save() { // {{{
    global $XCARTSESSID, $XCART_SESSION_VARS, $XCART_SESSION_UNPACKED_VARS, $sql_tbl;

    if (empty($XCARTSESSID))
        return false;
    
    $old_data = func_query_first("SELECT data, start FROM $sql_tbl[sessions_data] WHERE sessid = '$XCARTSESSID'");
    $start = $old_data['start'];
    $old_data = $old_data['data'];
    $md5_old_data = md5($old_data);

    if (!empty($old_data))
        $old_data = x_session_unserialize($old_data);

    if (!is_array($old_data)) {
        $old_data = array();
        $md5_old_data = '40cd750bba9870f18aada2478b24840a'; // md5(serialize(array()))
    }

    $varnames = func_get_args();

    if (empty($varnames))
        $varnames = is_array($XCART_SESSION_UNPACKED_VARS) ? array_keys($XCART_SESSION_UNPACKED_VARS) : array();

    $data = array();

    foreach (array_keys($XCART_SESSION_VARS) as $varname) {

        $data[$varname] = in_array($varname, $varnames)
            ? $GLOBALS[$varname]
            : @$old_data[$varname];

    }

    // Save session variables in the database
    $data = serialize($data);

    if (
        defined('BENCH')
        && constant('BENCH')
    ) {

        global $bench_max_session;

        $bench_max_session = max($bench_max_session, strlen($data));

    }

    $_is_robot = XCRobots::isExternalRobot();

    $md5_new_data = md5($data);
    if (
        !$_is_robot
        && $md5_new_data != $md5_old_data
    ) {
        $expiry_time = XC_TIME + XCART_SESSION_LENGTH + func_get_pos_operator_session_duration($data);
        $new_signature = x_session_get_fg($XCARTSESSID, $start, $expiry_time);
        db_query("UPDATE $sql_tbl[sessions_data] SET expiry='$expiry_time', signature='$new_signature', data = '".addslashes($data)."' WHERE sessid = '$XCARTSESSID'");        
    }
} //}}}

/**
 * Unregister variable $varname from $XCART_SESSION_VARS array
 */
function x_session_unregister($varname, $unset_global = false) { // {{{
    global $XCART_SESSION_VARS, $XCART_SESSION_UNPACKED_VARS;

    if (empty($varname))
        return false;

    func_unset($XCART_SESSION_VARS, $varname);

    func_unset($XCART_SESSION_UNPACKED_VARS, $varname);

    if ($unset_global) {

        func_unset($GLOBALS, $varname);

    }

} //}}}

/**
 * Find out whether a global variable $varname is registered in
 * $XCART_SESSION_VARS array
 */
function x_session_is_registered($varname) { // {{{
    global $XCART_SESSION_VARS;

    return !empty($varname) && isset($XCART_SESSION_VARS[$varname]);
} //}}}

/**
 * Generate unique session id
 */
function x_session_generateid() { // {{{
    global $sql_tbl;

    do {

        $sessid = md5(uniqid(mt_rand(), true));

    } while (func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[sessions_data] WHERE sessid = '$sessid'") > 0);

    return $sessid;
} //}}}

/**
 * Get session fingerprint
 */
function x_session_get_fg($sessid, $start, $expiry_time) { // {{{
    global $HTTP_USER_AGENT, $REMOTE_ADDR, $xc_security_key_session;
    static $result = array();

    // Some users type 'FALSE' as value instead of FALSE
    if (
        XCSecurity::PROTECT_XID_BY_IP
        && XCSecurity::PROTECT_XID_BY_IP !== 'FALSE'
    ) {
        if (
            !empty($_SERVER['HTTP_CF_CONNECTING_IP'])
            && func_is_trusted_proxy($REMOTE_ADDR, 'HTTP_CF_CONNECTING_IP')
        ) {
            $ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
        } else {
            $ip = $REMOTE_ADDR;
        }

        if (XCSecurity::PROTECT_XID_BY_IP == 'secure_mask') {
            // Remove only last octet
            $ip = preg_replace('/[\.:][^\.:]*$/s', '', $ip); 
        } else if (XCSecurity::PROTECT_XID_BY_IP == 'mask') {
            // Remove two last octets
            $ip = preg_replace('/[^\.:]*[\.:][^\.:]*$/s', '', $ip); 
        }

    } else {
        $ip = '';
    }
    $str = $HTTP_USER_AGENT . $ip . $sessid . $start . $expiry_time . $xc_security_key_session;

    if (isset($result[$str]))
        return $result[$str];

    $result[$str] = sha1($str);

    return $result[$str];
} //}}}

function func_is_trusted_proxy($_proxy_ip, $proxy2check_header = '', $ip_ranges = array()) { // {{{
    if (
        !empty($proxy2check_header)
        && empty($_SERVER[$proxy2check_header])
    ) {
        // this is not proxy we are looking for
        return true;
    }

    // https://www.cloudflare.com/ips/
    $cf_cidrs = array(
        '103.21.244.0/22',
        '103.22.200.0/22',
        '103.31.4.0/22',
        '104.16.0.0/12',
        '108.162.192.0/18',
        '131.0.72.0/22',
        '141.101.64.0/18',
        '162.158.0.0/15',
        '172.64.0.0/13',
        '173.245.48.0/20',
        '188.114.96.0/20',
        '190.93.240.0/20',
        '197.234.240.0/22',
        '198.41.128.0/17',
        '2400:cb00::/32',
        '2405:8100::/32',
        '2405:b500::/32',
        '2606:4700::/32',
        '2803:f800::/32',
        '2a06:98c0::/29',
        '2c0f:f248::/32',
    );

    if (empty($ip_ranges)) {
        $ip_ranges = $cf_cidrs;
    }

    $cidrMatch_obj = new CIDRmatch();
    foreach ($ip_ranges as $cidr) {
        if ($cidrMatch_obj->match($_proxy_ip, $cidr)) {
            return true;
        }
    }

    return false;

} //}}}

/**
 * Check - regenerate session or not
 */
function func_check_regen_sess_condition() { // {{{
    global $PHP_SELF, $REQUEST_METHOD;

    return $REQUEST_METHOD == 'POST' && preg_match("/login\.php/", $PHP_SELF);
} //}}}

/**
 * Check - skip or not session fingerprint checking procedure
 */
function func_skip_fingerprint_check() { // {{{
    return defined('SKIP_CHECK_SESSGION_FG');
} //}}}

/**
 * Delete session related data
 */
function func_delete_session_related_data($delete_ids, $zone = 'all_zones') { // {{{
    global $sql_tbl;

    if (empty($delete_ids) || !is_array($delete_ids))
        return FALSE;

    $deleteSet = implode("','", $delete_ids);

    if (func_session_use_history()) {
        db_query("DELETE FROM $sql_tbl[session_history] WHERE dest_xid IN ('$deleteSet')");
        db_query("DELETE FROM $sql_tbl[session_history] WHERE xid IN ('$deleteSet')");
    }

    $tables = array(
        'packages_cache',
        'shipping_cache',
        'users_online',
        'cc_pp3_data',
    );

    $admin_zones    = array('A', 'P', 'all_zones');
    $customer_zones = array('C', 'all_zones');
    if (in_array($zone, $admin_zones)) {
        // Erase old service array (Group editing of products functionality)
        $tables[] = 'ge_products';
        // Erase form ids
        $tables[] = 'form_ids';
        // Erase iterations
        $tables[] = 'iterations';
    } elseif (in_array($zone, $customer_zones)) {
        // Erase old service array (3D secure service data)
        $tables[] = 'secure3d_data';
    }

    // Clear cache for TaxCloud module
    if (!empty($sql_tbl['taxcloud_cache']))
        $tables[] = 'taxcloud_cache';

    // Clear cache for Amazon_Checkout module
    if (!empty($sql_tbl['amazon_data']))
        $tables[] = 'amazon_data';

    // Clear for Kayako_Connector module
    if (!empty($sql_tbl['kayako_cache'])) {
        $tables[] = 'kayako_cache';
    }

    // Clear for Facebook_Ecommerce module
    if (!empty($sql_tbl['facebook_ecomm_pending_export']) && in_array($zone, $admin_zones)) {
        $tables[] = 'facebook_ecomm_pending_export';
    }

    // Clear for Froogle module
    if (!empty($sql_tbl['froogle_products_pending_export']) && in_array($zone, $admin_zones)) {
        $tables[] = 'froogle_products_pending_export';
    }

    foreach ($tables as $table) {
        defined('XC_ALLOWED_ASSERT') && assert(!empty($sql_tbl[$table]) , __FUNCTION__. ' ' . $table  . ': table not defined' . $table);
        $xcart_table = $sql_tbl[$table];
        db_query("DELETE FROM $xcart_table WHERE sessid IN ('$deleteSet')");
    }

    // Clear Session_unknown_sid every year
    if (!mt_rand(0, 1000)) {
        func_session_delete_expired_unknown_sid();
    }

    if (!mt_rand(0, 500)) {
        func_session_delete_expired_session_history();
    }

    return TRUE;
} // }}}

/**
 * Change session related data if session id was changed
 */
function func_session_change($old_sessid, $new_sessid) { // {{{
    global $sql_tbl;

    db_query("UPDATE $sql_tbl[form_ids] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[ge_products] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[secure3d_data] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[users_online] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[shipping_cache] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[packages_cache] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[iterations] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    db_query("UPDATE $sql_tbl[cc_pp3_data] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");

    // Amazon_Checkout module
    if (!empty($sql_tbl['amazon_data'])) {
        // $Sql_tbl['Amazon_data'] is defined in Init.php
        db_query("UPDATE $sql_tbl[amazon_data] SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
    }

    // Attention! The column name must be "sessid" in a module's table
    $modules_tables = array(
        'Dont_Miss_Out' => array('dmo_products'),
        'Facebook_Ecommerce' => array('facebook_ecomm_pending_export'),
        'Froogle' => array('froogle_products_pending_export'),
        'Kayako_Connector' => array('kayako_cache'),
        'TaxCloud' => array('taxcloud_cache'),
    );

    foreach ($modules_tables as $module_name=>$tables) {
        if (func_is_module_enabled($module_name)){
            foreach ($tables as $table) {
                // The table name must XC_TBL_PREFIX . $table. Func_is_defined_module_sql_tbl is not used to avoid problems with double included module's config.php
                $table = XC_TBL_PREFIX . $table;
                db_query("UPDATE $table SET sessid = '$new_sessid' WHERE sessid = '$old_sessid'");
            }
        }
    }

    return true;
} //}}}

function x_session_reset() { // {{{
    global $XCART_SESSION_UNPACKED_VARS;

    $XCART_SESSION_UNPACKED_VARS = array();

    return true;
} //}}}

function x_session_finish() { // {{{
    if (!defined('XC_DISABLE_SESSION_SAVE')) {
        x_session_save();
    }
} //}}}

function func_session_process_unknown_xid($sessid) { // {{{
    global $sql_tbl, $robot;

    if (
        !isset($_SERVER['REMOTE_ADDR'])
        || !defined('X_SESSION_UNKNOWN_LIMIT')
        || defined('QUICK_START')
        || defined('ANTIBOT_SKIP_INIT')
        || intval(constant('X_SESSION_UNKNOWN_LIMIT')) <= 0
    ) {
        return false;
    }

    // Patch to HTML catalog work properly bt:84751
    if ($robot == 'X-Cart Catalog Generator')
        return false;

    $ip = $_SERVER['REMOTE_ADDR'];

    if (!func_is_valid_ip($ip))
        return false;

    $md5_ip = md5($ip);
    $cnt = intval(func_query_first_cell("SELECT cnt FROM $sql_tbl[session_unknown_sid] WHERE ip = '$md5_ip' AND sessid = '$sessid'")) + 1;
    db_query("REPLACE INTO $sql_tbl[session_unknown_sid] (`ip`, `sessid`, `cnt`, `expiry_date`) VALUES ('$md5_ip', '$sessid', '$cnt', '" . (XC_TIME+SECONDS_PER_DAY*360) . "')");
    if ($cnt > X_SESSION_UNKNOWN_LIMIT)
        define('X_ERR_UNKNOWN_SESSION_ID', true);

    return true;
} //}}}

function func_session_truncate_unknown_xid() { // {{{
    global $sql_tbl;

    if (!isset($_SERVER['REMOTE_ADDR']))
        return false;

    $ip = $_SERVER['REMOTE_ADDR'];

    if (!func_is_valid_ip($ip))
        return false;

    db_query("DELETE FROM $sql_tbl[session_unknown_sid] WHERE ip = '" . md5($ip) . "'");

    return true;
} //}}}

function x_session_unserialize(&$data) { // {{{
    $result = unserialize($data);
    defined('XC_ALLOWED_ASSERT') && assert(false !== $result, __FUNCTION__ . ': could not unserialize session data');
    if (FALSE === $result) {
        $result = array();
    }

    return $result;
} // }}}

function func_get_pos_operator_session_duration($sess_data) { // {{{
    global $sql_tbl;

    $pos_session_duration = XC_POS_OPERATOR_SESSION_LENGTH; // add 11 hours to the "pos operator" session length

    if (
        defined('XC_IS_POS_SESSION')
        && !empty($sess_data)
    ) {
        return $pos_session_duration;
    }

    $duration = 0;

    $is_module_enabled = func_is_module_enabled('POS_System');

    if (
        !empty($sess_data)
        && $is_module_enabled
    ) {
        $sess_data_unserialized = x_session_unserialize($sess_data);

        if (
            isset($sess_data_unserialized['identifiers']['C']['userid'])
            && $sess_data_unserialized['identifiers']['C']['userid'] > 0
        ) {
            $userid = func_query_first_cell("SELECT c.id FROM $sql_tbl[customers] c INNER JOIN $sql_tbl[memberships] m ON c.membershipid = m.membershipid WHERE c.id = '" . $sess_data_unserialized['identifiers']['C']['userid'] . "' AND m.active = 'Y' AND m.pos_operator = 1 LIMIT 1");

            if (!empty($userid)) {
                $duration = $pos_session_duration; // add 11 hours to the "pos operator" session length
                if (!defined('XC_IS_POS_SESSION')) {
                    define('XC_IS_POS_SESSION', true);
                } else {
                    defined('XC_ALLOWED_ASSERT') && assert(false , __FUNCTION__.': XC_IS_POS_SESSION is defined twice');
                }
            }
        }
    }

    return $duration;
} // }}}

function func_session_use_history() { // {{{
    global $xcart_http_host, $xcart_https_host;

    if (
        !defined('USE_SESSION_HISTORY')
        || !constant('USE_SESSION_HISTORY')
    ) {
        return false;
    }

    // use history only if domains are different
    return !isset($xcart_http_host) || !isset($xcart_https_host) || $xcart_http_host != $xcart_https_host;
} // func_session_use_history}}}

function func_is_module_enabled($module_name) {//{{{
    global $sql_tbl;

    if (
        defined('USE_SIMPLE_SESSION_INTERFACE')
        || defined('USE_SIMPLE_DB_INTERFACE')
    ) {
        // Change this query to check some cookie like !empty($COOKIE['isPOS_SystemEnabled']) on USE_SIMPLE_SESSION_INTERFACE/USE_SIMPLE_DB_INTERFACE constant usage changes
        $_is_module_enabled = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[modules] WHERE module_name = '$module_name' AND active = 'Y'") > 0;
    } else {
        $all_active_modules = func_get_active_modules();
        $_is_module_enabled = !empty($all_active_modules[$module_name]);
    }

    return $_is_module_enabled;
}//}}}

/** CIDR Match
 * ================================================================================
 * IDRmatch is a library to Match an IP to an IP range in CIDR notation (IPv4 and
 * IPv6).
 * {{{
 *  ================================================================================
 * @package     cIDRmatch
 * @author      Thomas Lutz
 * @copyright   Copyright (c) 2015 - present Thomas Lutz
 * @license     http://tholu.mit-license.org
 *  ================================================================================
 */

class CIDRmatch
{
    public function match($ip, $cidr)
    {
        static $ip_versions = array();

        $c = explode('/', $cidr);
        $subnet = isset($c[0]) ? $c[0] : NULL;
        $mask   = isset($c[1]) ? $c[1] : NULL;
        if ($mask === null) {
            $mask = 32;
        }

        if (!isset($ip_versions[$ip])) {
            if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
                // it's valid
                $ip_versions[$ip] = 'v4';
            } else {
                // it's not valid
                if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) {
                    // it's valid
                    $ip_versions[$ip] = 'v6';
                } else {
                    // it's not valid
                    return false;
                }
            }
        }

        switch ($ip_versions[$ip]) {
            case 'v4':
                return $this->IPv4Match($ip, $subnet, $mask);
                break;
            case 'v6':
                return $this->IPv6Match($ip, $subnet, $mask);
                break;
        }
    }

    // inspired by: http://stackoverflow.com/questions/7951061/matching-ipv6-address-to-a-cidr-subnet
    private function IPv6MaskToByteArray($subnetMask)
    {
        $addr = str_repeat("f", $subnetMask / 4);
        switch ($subnetMask % 4) {
            case 0:
                break;
            case 1:
                $addr .= "8";
                break;
            case 2:
                $addr .= "c";
                break;
            case 3:
                $addr .= "e";
                break;
        }
        $addr = str_pad($addr, 32, '0');
        $addr = pack("H*", $addr);

        return $addr;
    }

    // inspired by: http://stackoverflow.com/questions/7951061/matching-ipv6-address-to-a-cidr-subnet
    private function IPv6Match($address, $subnetAddress, $subnetMask)
    {
        static $res = array();

        if (!filter_var($subnetAddress, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) || $subnetMask === NULL || $subnetMask === "" || $subnetMask < 0 || $subnetMask > 128) {
            return false;
        }
        $subnet = inet_pton($subnetAddress);
        $res[$address] = isset($res[$address]) ? $res[$address] : inet_pton($address);

        $binMask = $this->IPv6MaskToByteArray($subnetMask);

        return ($res[$address] & $binMask) == $subnet;
    }

    // inspired by: http://stackoverflow.com/questions/594112/matching-an-ip-to-a-cidr-mask-in-php5
    private function IPv4Match($address, $subnetAddress, $subnetMask)
    {
        static $res = array();

        if (!filter_var($subnetAddress, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) || $subnetMask === NULL || $subnetMask === "" || $subnetMask < 0 || $subnetMask > 32) {
            return false;
        }

        $res[$address] = isset($res[$address]) ? $res[$address] : ip2long($address);
        $subnetAddress = ip2long($subnetAddress);
        $mask = -1 << (32 - $subnetMask);
        $subnetAddress &= $mask; # nb: in case the supplied subnet wasn't correctly aligned
        return ($res[$address] & $mask) == $subnetAddress;
    }
} //cIDRMatch
//}}}
