<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Defer loader plugin.
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Lib
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    2bea61ea7ab8518e5ee3194b3ac72dd689c57e93, v58 (xcart_4_7_11), 2019-02-14 11:56:17, function.load_defer_code.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

// Templater plugin
// -------------------------------------------------------------
// Type:     function
// Name:     load_defer_code
// Input:    none
// -------------------------------------------------------------

if (!defined('XCART_START')) { header("Location: ../../../"); die("Access denied"); }

/**
 * Defer loader plugin.
 *
 * @param array  $params should have 'type' element
 * @param Smarty $smarty Smarty object
 *
 * @return string always empty string
 * @see    ____func_see____
 * @since  1.0.0
 */
// it seems with disabled cache score is better in google.check ttfb before changing
define('XC_DISABLE_CRITICAL_CSS_CACHE', true);
function smarty_function_load_defer_code($params, &$smarty) { // {{{
    global $xcart_dir, $config, $var_dirs, $var_dirs_web, $current_location, $HTTP_USER_AGENT;
    global $smarty_skin_dir, $deferRegistry, $directInfoRegistry;
    static $count = array(
        "css" => 0,
        "js" => 0,
    );

    if (empty($params['type']) || !in_array($params['type'], array('js', 'css'))) {
        return '';
    }

    $type = $params['type'];
    if (empty($deferRegistry[$type]) && empty($directInfoRegistry[$type])) {
        return '';
    }

    if (TRUE
        && isset($config['General']['speedup_' . $type])
        && 'N' != $config['General']['speedup_' . $type]
        && defined('AREA_TYPE')
        && 'C' == constant('AREA_TYPE')
    ) {
        // for live debugging
        $addkey = !empty($_COOKIE['xc_load_defer_code_plain_combine']) ? 'plain' : '';
        if (!empty($_GET['debugjs'])) {
            func_setcookie('xc_load_defer_code_plain_combine', 'Y');//set session cookie
            $addkey = 'plain';
        }
        $use_plain = ($addkey === 'plain');

        $result = array();
        foreach (array('async_load', 'sync_load') as $async_sync) {

            if (empty($deferRegistry[$type][$async_sync]) && empty($directInfoRegistry[$type][$async_sync])) {
                continue;
            }

            $l_deferRegistry = $l_directInfoRegistry = array();

            $l_deferRegistry[$type] = $deferRegistry[$type][$async_sync];
            $l_directInfoRegistry[$type] = $directInfoRegistry[$type][$async_sync];

            $queue = load_defer_code_get_queue($type, $l_deferRegistry, $l_directInfoRegistry);

            $count[$type] ++;
            $maxFtime = 0;
            foreach ($queue as $elem) {
                 if (isset($l_deferRegistry[$type][$elem])) {
                    foreach ($l_deferRegistry[$type][$elem] as $file) {
                        $ftime = filemtime($file);
                        defined('XC_ALLOWED_ASSERT') && assert(false !== $ftime, __FUNCTION__.': cannot get Filemtime');
                        $maxFtime = max($maxFtime, $ftime);
                    }
                }
            }

            $_suffix = md5(
                serialize($l_deferRegistry[$type])
                . (!empty($l_directInfoRegistry[$type]) ? serialize($l_directInfoRegistry[$type]) : '')
                . $maxFtime
                . $smarty_skin_dir
            ) . $addkey . ($async_sync == 'async_load' ? 'async' : '_sync');

            $type_dir = $type . '_dir';
            $label = empty($params['label']) ? '' : $params['label'].'.';
            $label .= $count[$type];
            $cacheFile = $var_dirs['cache'] . XC_DS . $type_dir . XC_DS . $label . '.' . $_suffix . '.' . $type;
            $cacheWebFile = $var_dirs_web['cache'] . '/' . $type_dir . '/' . $label . '.' . $_suffix . '.' . $type;

            if (!is_file($cacheFile)) {
                load_defer_code_restore_service_dir($type_dir);
                $txt_content = '';
                $fp = fopen($cacheFile, 'w');
                foreach ($queue as $elem) {
                    $cache = '';
                    if (!empty($l_deferRegistry[$type][$elem])) {
                        foreach ($l_deferRegistry[$type][$elem] as $web => $file) {
                            $fileSource = file_get_contents($file);
                            // Add file name
                            if (defined('DEVELOPMENT_MODE')) {
                                $_short_file = str_replace($xcart_dir . XC_DS, '', $file);
                                $fileSource = "/***\n * Source: file\n * File: $_short_file\n * Queue: $elem\n * ===================================================================\n ***/\n\n" . $fileSource;
                            }

                            $fn = "load_defer_code_filter_$type";
                            $cache .= $fn($fileSource, $web);
                            $cache .= "\n";
                        }

                        unset($l_deferRegistry[$type][$elem]);
                        unset($deferRegistry[$type][$async_sync][$elem]);
                    }

                    if ('css' == $type && '' !== $cache) {
                        $txt_content .= $cache;
                        fwrite($fp, $cache);
                    }

                    if (!empty($l_directInfoRegistry[$type][$elem])) {
                        foreach ($l_directInfoRegistry[$type][$elem] as $id => $value) {
                            // Add file name
                            if (defined('DEVELOPMENT_MODE')) {
                                fwrite($fp, "/***\n * Source: direct info\n * Tag: $id\n * Queue: $elem\n * ===================================================================\n ***/\n\n");
                            }

                            $value[] = "";
                            $cur_value = implode("\n", $value);
                            $txt_content .= $cur_value;
                            fwrite($fp, $cur_value);
                        }
                        unset($l_directInfoRegistry[$type][$elem]);
                        unset($directInfoRegistry[$type][$async_sync][$elem]);
                    }

                    if ('js' == $type && '' !== $cache) {
                        $txt_content .= $cache;
                        fwrite($fp, $cache);
                    }
                } // foreach ($queue as $elem)
                fclose($fp);

                if (empty($use_plain)) {
                    $is_minified = XCMinifier::minify($cacheFile, $type);
                }
            } // if (!is_file($CacheFile))#nolint

            if (defined('XC_CDN_URL')) {
                $cacheWebFile = str_ireplace($current_location, XC_CDN_URL, $cacheWebFile);
            }

            unset($deferRegistry[$type][$async_sync]);
            unset($directInfoRegistry[$type][$async_sync]);

            if (empty($deferRegistry[$type])) {
                unset($deferRegistry[$type]);
            }

            if (empty($directInfoRegistry[$type])) {
                unset($directInfoRegistry[$type]);
            }

            $async_str = ($async_sync == 'async_load' ? ' async="async"' : '');
            $id_str = ' id="load-defer-code_' . $type . ($async_sync == 'async_load' ? '_async' : '_sync') . $count[$type] . '"';//for https://stackoverflow.com/a/43076418/6700695
            if ('js' == $type) {
                $result[] = '<script type="text/javascript" src="' . $cacheWebFile . '"' . $async_str . $id_str .  '></script>';
            } elseif (
                func_is_ajax_request()
                || strpos($config['General']['speedup_css'], 'asyncload') === false
                || strpos($HTTP_USER_AGENT, 'W3C_Validator') !== false
                || strpos($HTTP_USER_AGENT, 'xc_webtest_build_agent') !== false
                || defined('XCART_INSTALLER')
                || !empty($_GET['is_install_preview'])
            ) {
                // css type in ajax or other cases
                $result[] = '<link rel="stylesheet" type="text/css" href="' . $cacheWebFile . '" />';
            } else {// css type
                $result = array_merge($result, XCCriticalCss::extractCriticalCss($cacheFile, $cacheWebFile, $is_minified, $txt_content, $smarty));
            }
        }// Foreach (array('Async_load', 'Sync_load') as $Async_sync)

    } else {
        $result = array();
    }

    return implode("\n", $result);
} // }}}

function load_defer_code_get_queue($type, $_deferRegistry, $_directInfoRegistry) { // {{{

    $queue = array();
    if (isset($_deferRegistry[$type])) {
        $queue = array_merge(array_keys($_deferRegistry[$type]), $queue);
    }

    if (isset($_directInfoRegistry[$type])) {
        $queue = array_merge(array_keys($_directInfoRegistry[$type]), $queue);
    }

    sort($queue);
    return array_unique($queue);
} // }}}

function func_dev_is_correct_map_file_version($fileSource) { // {{{
    global $smarty_skin_dir, $xcart_dir;

    $res = preg_match('/jQuery v([0-9\.]*) \|/', $fileSource, $match);
    $min_map_file = 'jquery-' . $match[1] . '.min.map';

    return $res && file_exists($xcart_dir . $smarty_skin_dir . '/lib/' . $min_map_file);
} // }}}

function load_defer_code_filter_js($fileSource, $web) { // {{{

    if (strpos($web, 'lib/jquery-min.js') !== FALSE) {
        $min_map_file = 'jquery';
        $dir = '../../..' . dirname($web) . '/';
        defined('XC_ALLOWED_ASSERT') && assert(func_dev_is_correct_map_file_version($fileSource), __FUNCTION__.': jquery-min.js version is changed. Please update jquery-&lt;version&gt;.map file');

        $fileSource = str_replace(
            'sourceMappingURL=' . $min_map_file,
            'sourceMappingURL=' . $dir . $min_map_file,
            $fileSource
        );
    }

    return $fileSource;
} // }}}

function load_defer_code_filter_css($fileSource, $web) { // {{{
    $dir = '../../..' . dirname($web) . '/';

    // Remove " and ' from URI path
    $fileSource = preg_replace('/(url[ ]*\()[\'" ]*([^)\'"]*)[\'" ]*(\))/', '\1\2\3', $fileSource);

    // Add path to var/cache
    $fileSource = preg_replace('/(url[ ]*\()(?!http|\/|ftp:)([^\'")]*)/S', '\1' . $dir . '\2', $fileSource);

    return $fileSource;
} // }}}

function load_defer_code_restore_service_dir($type_dir) { // {{{
    // Inject global vars
    global $var_dirs, $xcart_fs_permissions_map, $var_dirs_rules, $config;
    static $res = array();

    if (isset($res[$type_dir])) {
        return true;
    } else {
        $res[$type_dir] = true;
    }

    // Setup directory permissions (inherit from var)
    $xcart_fs_permissions_map['var'.XC_DS.'cache'.XC_DS.$type_dir] = $xcart_fs_permissions_map['var'.XC_DS.'cache'];
    $var_dirs_rules[$type_dir] = $var_dirs_rules['tmp']; // Inherit index.php with die() content

    // Setup cache directory path
    $var_dirs[$type_dir] = $var_dirs['cache'] . "/$type_dir";
    // Restore cache directory
    $result = func_restore_var_dir($type_dir, $var_dirs[$type_dir]);

    if (
        stripos($type_dir, 'css') !== false
        && strpos($config['General']['speedup_css'], 'asyncload') !== false
    ) {
        //create dir if needed
        XCCriticalCss::registerCache();
    }

    return $result;
} // }}}

class XCMinifier {
    public static function minify($combinedFile, $type) {//{{{
        global $xcart_dir;

        if (defined('XC_USE_OLD_STYLE_MINIFY')) {
            return false;
        }

        require_once $xcart_dir . '/include/lib/vendor/autoload.php';

        $minifierNamespace = '\\MatthiasMullie\\Minify';
        $minifierClassName = strtoupper($type);
        $minifierClass = "{$minifierNamespace}\\{$minifierClassName}";

        $minifier_fp = new $minifierClass($combinedFile);

        try {
            $minifier_fp->minify($combinedFile);
            $res = true;
        } catch (Exception $e) {
            if (!func_is_ajax_request()) {
                if (!x_log_flag('log_tmp', 'critical_problem_on_storefront', $e->getMessage())) {
                    x_log_flag('log_debug_messages', 'critical_problem_on_storefront', $e->getMessage());
                }

                x_log_add('critical_problem_on_storefront', $e->getMessage(), true);
                func_send_http_header('500 Internal Server Error');
                $res = false;
            }
        }

        return $res;
    }//}}}
}

class XCCriticalCss {
    protected static $cacheEnabled = true;
    protected static $loadFullCss = true;
    protected static function parseMediaBlocks($in_css) {//{{{
        $_mediaBlocks = $_mediaBlockCoords = array();

        $start = 0;
        while (($start = strpos($in_css, "@media", $start)) !== false) {
            // stack to manage brackets
            $s = array();

            // Get the first opening bracket
            $i = strpos($in_css, "{", $start);

            // if $i is false, then there is probably a css syntax error
            if ($i !== false) {
                // push bracket onto stack
                array_push($s, $in_css[$i]);

                // move past first bracket
                $i++;

                while (!empty($s)) {
                    // if the character is an opening bracket, push it onto the stack, otherwise pop the stack
                    if ($in_css[$i] == "{") {
                        array_push($s, "{");
                    }
                    elseif ($in_css[$i] == "}") {
                        array_pop($s);
                    }

                    $i++;
                }

                // cut the media block out of the css and store
                $_mediaBlocks[] = substr($in_css, $start, ($i + 1) - $start);
                $_mediaBlockCoords[] = array($start , ($i + 1) - $start);

                // set the new $start to the end of the block
                $start = $i;
            }
        }

        if (!empty($_mediaBlockCoords)) {
            $changed_length = 0;
            foreach ($_mediaBlockCoords as $removedPos) {
                $in_css = substr_replace($in_css, '', $removedPos[0]-$changed_length, $removedPos[1]-1);
                $changed_length += ($removedPos[1]-1);
            }
        }

        return array('mediaBlocks' => $_mediaBlocks, 'rootCss' => $in_css);
    }//}}}

    protected static function inlineCriticalCss($css2parse) {//{{{

        $arr = array();
        preg_match_all('/[^}\*\/]*\b(?:' . implode('|', static::getCriticalCssClasses()) . ')\b[^}{\*]*{[^}]*}/smi', $css2parse, $arr);

        if (!empty($arr[0])) {
            $critical_css = implode('', $arr[0]);
        } else {
            return array();
        }

        $res = "<style type='text/css'>" . static::removeRelatedPath($critical_css) . "</style>";
        return array($res);
    }//}}}

    protected static function inlineMediaCss($in_media_blocks) {//{{{
        if (empty($in_media_blocks)) {
            return array();
        }
        $_result = array();

        foreach ($in_media_blocks as $mb) {
            $first_bracket = strpos($mb, '{');
            $_media = trim(preg_replace('/\s*@media\s*/Ssi', '', substr($mb, 0, $first_bracket)));
            $wo_media = substr($mb, $first_bracket+1);
            $_result[] = "<style type='text/css' media='$_media'>" . static::removeRelatedPath(substr($wo_media, 0, strrpos($wo_media, '}'))) . "</style>";
        }

        return $_result;
    }//}}}

    protected static function hideSomeBlocks($_main) {//{{{
        global $g_hide_css_selectors, $g_abovefold_css;

        $hide_selectors = array('.mobile-header');
        if ($_main == 'product') {
            $hide_selectors[] = '#np-popup-next';
            $hide_selectors[] = '#np-popup-prev';
        }

        if (!empty($g_hide_css_selectors)) {
            foreach ($g_hide_css_selectors as $_module_css) {
                $hide_selectors = array_merge($hide_selectors, $_module_css);
            }
        }

        $hide_css = implode('{display: none;}', $hide_selectors) . '{display: none;}';
        $hide_css .= ".nav { list-style: none; padding-left: 0; }";

        if (!empty($g_abovefold_css)) {
            foreach ($g_abovefold_css as $_module_css) {
                $hide_css .= implode(' ', $_module_css);
            }
        }

        $res = "<style type='text/css'>" . $hide_css . "</style>";
        return array($res);
    }//}}}

    protected static function removeRelatedPath($txt) {//{{{
        return str_replace('(../../../','(', $txt);
    }//}}}

    protected static function getCriticalCssClasses() {//{{{
        global $active_modules, $g_critical_css_classes, $mode, $PHP_SELF, $checkout_module;

        $critical_selectors = array('criticalCSS','h1','body','html','page-container','page-container2','content-container','content-container2','navbar','subcategories','menu-dialog','clearing','center','left-bar','right-bar','header','location','a:link', 'a:visited', 'a:hover', 'a:active','search-sort-bar','dialog','per-page-selector','select','button','bestsellers','offers-cell','item-box','menu-minicart','minicart-button','ul.simple-list-left','search-sort-title','tabs','head-main','minicart-block','headbg','head-links','ajax-minicart','footer .box');

        if (!empty($g_critical_css_classes)) {
            foreach ($g_critical_css_classes as $_module_css) {
                $critical_selectors = array_merge($critical_selectors, $_module_css);
            }
        }

        if (!empty($active_modules['Flyout_Menus'])) {
            $critical_selectors = array_merge($critical_selectors, array('fancycat-icons\S*'));
        }

        if (!empty($active_modules['Demo_Mode'])) {
            $critical_selectors = array_merge($critical_selectors, array('demoModulesBox','demo','switcher-main'));
        }

        if (!empty($active_modules['XMultiCurrency'])) {
            $critical_selectors = array_merge($critical_selectors, array('mc-selector'));
        } else {
            $critical_selectors = array_merge($critical_selectors, array('languages-flags'));
        }

        if (
            !empty($mode)
            && $mode == 'checkout'
            && stripos(basename($PHP_SELF), 'cart.php') !== false
        ) {
            switch ($checkout_module) {
                case 'One_Page_Checkout':
                    $critical_selectors = array_merge($critical_selectors, array('opc-section','opc-sections','registerform'));
                    break;
                case 'Fast_Lane_Checkout':
                    $critical_selectors = array_merge($critical_selectors, array('flc-progress-bar','registerform'));
                    break;
            }
        }


        $critical_selectors = array_unique($critical_selectors);

        return $critical_selectors;
    }//}}}

    public static function registerCache($dir_flag = '') {//{{{
        if (!empty($_GET['debugcss'])) {
            static::$loadFullCss = false;
            func_setcookie('xc_debugcss', 'Y', XC_TIME + 120);//2 minutes for debug
        }

        if (!empty($_COOKIE['xc_debugcss'])) {
            static::$loadFullCss = false;
        }

        if (defined('XC_DISABLE_CRITICAL_CSS_CACHE') || !static::$loadFullCss) {
            static::$cacheEnabled = false;

            return false;
        }

        // Setup directory permissions (inherit from var)
        $_params = array('class' => 'XCCriticalCss', 'hashedDirectoryLevel' => 2, 'ttl' => SECONDS_PER_DAY * 365, 'dir' => 'criticalCSS');

        if ($dir_flag == 'dont_check_dir') {
            $_params['skip_dir_creation'] = true;
        } elseif ($dir_flag  == 'force_create_dir') {
            // hack to avoid static cache in Func_register_cache_function in order to restore dir
            $_params['force_dir_creation'] = true;
        }

        return func_register_cache_function('extractCriticalCss', $_params);
    }//}}}

    public static function extractCriticalCss($_cacheFile, $_cacheWebFile, $_is_minified, $_txt_content, $smarty) {//{{{
        // the name of function is used as cache/dir name
        global $xcart_http_host;

        if (static::$cacheEnabled) {
            static::registerCache('dont_check_dir');

            $cacheKey = basename($_cacheFile) . '_' . md5(implode(static::getCriticalCssClasses()) . $xcart_http_host);
            if (($cacheData = func_get_cache_func($cacheKey, __FUNCTION__))) {
                // Get cache file
                return $cacheData['data'];
            }
        }

        if (!empty($_is_minified) || empty($_txt_content)) {
            // obtain minified content
            $_txt_content = file_get_contents($_cacheFile);
        }

        $blocks = static::parseMediaBlocks($_txt_content);

        $result = array();
        $result = array_merge($result, static::inlineCriticalCss($blocks['rootCss']));

        $result = array_merge($result, static::inlineMediaCss($blocks['mediaBlocks']));

        $result = array_merge($result, static::hideSomeBlocks($smarty->getTemplateVars('main')));


        if (static::$loadFullCss) {
            $ff56fix = 'onerror="this.rel=\'stylesheet\'" ';
            $ff56fix = '';

            $_cacheWebFile = str_ireplace(array('http://','https://'), array('//','//'), $_cacheWebFile);
            $result[] = <<<EOT
            <link rel='preload' href='$_cacheWebFile' as='style' onload="this.onload=null;this.rel='stylesheet'" $ff56fix/>
            <noscript><link rel='stylesheet' href='$_cacheWebFile'></noscript>
            <script type="text/javascript">
            /*! loadCSS. [c]2017 Filament Group, Inc. MIT License */
            (function(a){if(!a.loadCSS){a.loadCSS=function(){}}var b=loadCSS.relpreload={};b.support=(function(){var d;try{d=a.document.createElement("link").relList.supports("preload")}catch(f){d=false}return function(){return d}})();b.bindMediaToggle=function(e){var f=e.media||"all";function d(){e.media=f}if(e.addEventListener){e.addEventListener("load",d)}else{if(e.attachEvent){e.attachEvent("onload",d)}}setTimeout(function(){e.rel="stylesheet";e.media="only x"});setTimeout(d,3000)};b.poly=function(){if(b.support()){return}var d=a.document.getElementsByTagName("link");for(var e=0;e<d.length;e++){var f=d[e];if(f.rel==="preload"&&f.getAttribute("as")==="style"&&!f.getAttribute("data-loadcss")){f.setAttribute("data-loadcss",true);b.bindMediaToggle(f)}}};if(!b.support()){b.poly();var c=a.setInterval(b.poly,500);if(a.addEventListener){a.addEventListener("load",function(){b.poly();a.clearInterval(c)})}else{if(a.attachEvent){a.attachEvent("onload",function(){b.poly();a.clearInterval(c)})}}}if(typeof exports!=="undefined"){exports.loadCSS=loadCSS}else{a.loadCSS=loadCSS}}(typeof global!=="undefined"?global:this));
            </script>
EOT;
        }
        if (static::$cacheEnabled) {
            $res = func_save_cache_func($result, $cacheKey, __FUNCTION__);

            if ($res === false) {
                defined('XC_ALLOWED_ASSERT') && assert(false , __METHOD__ . ': criticalCSS cache dir has been occasionally removed.Restoring...');
                static::registerCache('force_create_dir');
            }
        }

        return $result;
    }//}}}
}
