<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Templater plugin
 * -------------------------------------------------------------
 * Type:     function
 * Name:     resource_url
 * Input:    type
 *           id
 *           query_string
 *           Canonical_url
 *           is_product_page
 * -------------------------------------------------------------
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Lib
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    9420d43903cbe798e4b468f13709aaacf26ac8a2, v35 (xcart_4_7_9), 2018-01-09 16:56:31, function.resource_url.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) { header("Location: ../../../"); die("Access denied"); }

function smarty_function_resource_url($params, $template)
{//{{{
    global $xcart_catalogs, $config;

    if (
        (
            !empty($params['force_url_by_id'])
            || empty($params['canonical_url'])
        )
        && !empty($params['type'])
        && !empty($params['id'])
    ) {
        $params['query_string'] = isset($params['query_string']) ? $params['query_string'] : '';
        $_canonical_url = func_get_resource_url($params['type'], $params['id'], $params['query_string']);
    } else {
        $_canonical_url = empty($params['canonical_url']) ? '' : $params['canonical_url'];
    }

    if (!empty($_canonical_url) && strpos($_canonical_url, '://') === false) {
        $_canonical_url = $xcart_catalogs['customer'] . '/' . $_canonical_url;
    }

    $is_https_canonical = $config['HTTPS_test_passed'] === 'Y';

    if (
        defined('XC_BACKWARD_HTTP_SOCIAL_CANONICAL')
        || (
            defined('ROBOT')
            && stripos(ROBOT, 'Facebo') !== false
            && !empty($params['added_date'])
            && $params['added_date'] < 1517428800//1 feb 2018
            && preg_match('/4\.7\.[3-8]-4\./', $config['upgrade_history'])//force use http for all shops upgraded to 4.7.9 and older
        )
    ) {
        $_canonical_url = str_ireplace('https://', 'http://', $_canonical_url);
    } elseif ($is_https_canonical) {
        $_canonical_url = str_ireplace('http://', 'https://', $_canonical_url);
    }

    return $_canonical_url;
}//}}}
