<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Michael Bugrov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    6db818c0eca89b5775024e99ef25ae2be7433697, v9 (xcart_4_7_10), 2018-09-26 10:31:22, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }

$addons['Amazon_Feeds'] = true;
define('AMAZON_FEEDS', 'Amazon_Feeds');

// Add module specific tables
$sql_tbl['amazon_feeds']            = XC_TBL_PREFIX . 'amazon_feeds';
$sql_tbl['amazon_feeds_catalog']    = XC_TBL_PREFIX . 'product_amazon_feeds_catalog';
$sql_tbl['amazon_feeds_exports']    = XC_TBL_PREFIX . 'product_amazon_feeds_exports';
$sql_tbl['amazon_feeds_results']    = XC_TBL_PREFIX . 'product_amazon_feeds_results';

// Load module specific CSS files
$css_files[AMAZON_FEEDS][] = array('admin' => true); // admin.css

// Enable debugging:
//define('XC_AMAZON_FEEDS_DEBUG', true);

if (defined('IS_IMPORT')) { //{{{
    $modules_import_specification['AMAZON_FEEDS_CATEGORY'] = array(
        'script'        => '/modules/Amazon_Feeds/import.php',
        'permissions'    => 'AP',
        'need_provider'    => true,
        'parent'        => 'PRODUCTS',
        'export_sql'     => "SELECT productid FROM $sql_tbl[amazon_feeds_catalog]",
        'table'         => 'amazon_feeds_catalog',
        'key_field'     => 'productid',
        'parent_key_field' => 'productid',
        'columns'       => array(
            'productid'     => array(
                'type'      => 'N',
                'is_key'    => true,
                'default'   => 0),
            'productcode'   => array(
                'is_key'    => true),
            'product'       => array(
                'is_key'    => true),
            'product_type'  => array(),
        )
    );
}//}}}

if ( !func_amazon_feeds_is_available() ) {
    global $active_modules, $smarty;
    // Skip initialization if not available
    // disable module for customers
    unset($active_modules['Amazon_Feeds']);
    $smarty->assign('active_modules', $active_modules);

    return;
}

// Load module functions
if (!empty($include_func)) {

    require_once $xcart_dir . XC_DS . 'modules' . XC_DS . AMAZON_FEEDS . XC_DS . 'func.php';

    // Initialize module
    if (!empty($include_init)) {
        func_amazon_feeds_init();
    }
}

function func_amazon_feeds_is_available()
{ // {{{
    global $single_mode, $active_modules;

    $area_type = func_constant('AREA_TYPE');

    if (
        $area_type === 'A'
        || (
            (
                $single_mode
                || !empty($active_modules['Simple_Mode'])
            )
            && $area_type === 'P'
        )
    ) {
        return true;
    }

    return false;
} // }}}
