<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * TaxJar Integration Module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage TaxJar
 * @author     Qualiteam software Ltd <info@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    0e3f1c6f2bb7d0aeca7c929faea783695fddeb30, v1 (xcart_4_7_12), 2020-02-05 11:59:16, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) {
    header('Location: ../../');
    die('Access denied');
}

$addons['CSI_TaxJar'] = true;

if (defined('IS_IMPORT')) {//{{{{

    $modules_import_specification['PRODUCTS']['columns']['csi_taxjar_code'] = array('type' => 'S', 'default'  => '00000');// Sync with sql and Func.php

    $modules_import_specification['TAXJAR'] = [
        'script'                => '/modules/CSI_TaxJar/import.php',
        'no_import'             => true,
        'permissions'           => 'AP',
        'parent'                => 'ORDERS',
        'export_sql'            => "SELECT orderid FROM $sql_tbl[orders]",
        'orderby'               => 1000,
        'table'                 => 'orders',
        'key_field'             => 'orderid',
        'allow_fullfillment'    => true,
        'columns'               => [
            'provider'          => [],
            'orderid'           => [
                'required'  => true,
                'is_key'    => true,
                'type'      => 'N'
            ],
            'transaction_type'  => [
                'required'  => true
            ],
            'completed_at'      => [
                'is_key'    => true,
                'type'      => 'D',
                'required'  => true
            ],
            'customer_name'     => [],
            'shiptocity'        => [],
            'shiptostate'       => [],
            'shiptozip'         => [],
            'shiptostreet'      => [],
            'shiptocountrycode' => [],
            'shipping_amount'   => [
                'type'  => 'P'
            ],
            'handling_amount'   => [
                'type'  => 'P'
            ],
            'discount_amount'   => [
                'type'  => 'P'
            ],
            'total_sale'        => [
                'type'      => 'P',
                'required'  => true
            ],
            'sales_tax'         => [
                'type'  => 'P'
            ],
            'from_country'      => [],
            'from_state'        => [],
            'from_city'         => [],
            'from_zip'          => [],
            'from_street'       => [],
        ]
    ];
}//}}}

// Override config tax options
$config['Taxes']['display_taxed_order_totals'] = 'N';
$config['Taxes']['display_cart_products_tax_rates'] = 'N';
$config['Taxes']['tax_operation_scheme'] = 'TAX_SCHEME_GENERAL';
$config['Taxes']['allow_user_modify_tax_number'] = 'N';

$sql_tbl['taxjar_cache'] = XC_TBL_PREFIX . 'taxjar_cache';

define('XC_TAXJAR_REQUEST_CACHE_TTL', min(1, intval($config['CSI_TaxJar']['taxjar_ttl'])));

/**
 * Load module functions
 */
if (!empty($include_func)) {
    // Load module's functions
    require_once __DIR__ . '/func.php';

    // Initialize module
    if (!empty($include_init)) {
        func_taxjar_module_init();
    }
}
