<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * TaxJar Integration Module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage TaxJar
 * @author     Qualiteam software Ltd <info@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    0e3f1c6f2bb7d0aeca7c929faea783695fddeb30, v1 (xcart_4_7_12), 2020-02-05 11:59:16, import.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_SESSION_START') ) { header("Location: ../"); die("Access denied"); }

if ($import_step == 'export') {
    // Export data
    while ($id = func_export_get_row($data)) {
        if (empty($id)) {
            continue;
        }

        // Get data
        if ($single_mode || AREA_TYPE == 'A') {
            $order = func_query_first("SELECT * FROM $sql_tbl[orders] WHERE orderid = '$id'");
        } else {
            $order = func_query_first("SELECT $sql_tbl[orders].*, $sql_tbl[customers].login FROM $sql_tbl[orders], $sql_tbl[order_details] LEFT JOIN $sql_tbl[customers] ON $sql_tbl[orders].userid = $sql_tbl[customers].id WHERE $sql_tbl[orders].orderid = '$id' AND $sql_tbl[orders].orderid = $sql_tbl[order_details].orderid AND $sql_tbl[order_details].provider = '$logged_userid'");
        }

        if (empty($order)) {
            continue;
        }

        list($order['s_address'], $order['s_address_2']) = preg_split("/[\r\n]+/", $order['s_address'], 2);

        $row = [
            'provider'          => 'XCart',
            'orderid'           => $order['orderid'],
            'transaction_type'  => 'Order',
            'completed_at'      => date('Y/m/d', $order['date'] + $config['Appearance']['timezone_offset']),
            'customer_name'     => $order['b_firstname'] . ' ' . $order['b_lastname'],
            'shiptocity'        => $order['s_city'],
            'shiptostate'       => $order['s_state'],
            'shiptozip'         => $order['s_zipcode'],
            'shiptostreet'      => $order['s_address'] . (!empty($order['s_address_2']) ? ', ' . $order['s_address_2'] : ''),
            'shiptocountrycode' => $order['s_country'],
            'shipping_amount'   => $order['shipping_cost'],
            'handling_amount'   => 0,
            'discount_amount'   => $order['discount'] + $order['coupon_discount'],
            'total_sale'        => $order['total'] - $order['tax'],
            'sales_tax'         => $order['tax'],
            'from_country'      => $config['Company']['location_country'],
            'from_state'        => $config['Company']['location_state'],
            'from_city'         => $config['Company']['location_city'],
            'from_zip'          => $config['Company']['location_zipcode'],
            'from_street'       => $config['Company']['location_address'],
        ];

        if ($config['CSI_TaxJar']['taxjar_ship_local'] == $order['shippingid']) {
            $shippingTo = [
                'shiptocountrycode' => $config['Company']['location_country'],
                'shiptozip'         => $config['Company']['location_zipcode'],
                'shiptostate'       => $config['Company']['location_state'],
                'shiptocity'        => $config['Company']['location_city'],
                'shiptostreet'      => $config['Company']['location_address'],
            ];

            $row = array_merge($row, $shippingTo);
        }

        // Export row
        if (!func_export_write_row($row)) {
            break;
        }
    }
}
