<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Classes
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    4a882081b07cb8d8e0b7d0554c68a114a891b11b, v1 (xcart_4_7_10), 2018-09-12 10:14:12, classes.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */
namespace XC\GDPR\Backend;

class AccessLog {
    public static function updateAll() {//{{{
        global $sql_tbl;
        static $already_called = 0;

        if ($already_called) {
            return true;
        }

        static::updateModules();
        static::updateCustomers();
        static::updateShipping();
        static::updatePayment();
        // mark deleted/inactive modules
        db_query("UPDATE $sql_tbl[gdpr_access_log] SET active='N' WHERE update_date<'" . XC_TIME . "'");
        $already_called = 1;
    }//}}}

    public static function updateModules($module_name='', $module_new_state=false) {//{{{
        global $sql_tbl;
        static $already_called  = 0;

        if ($already_called) {
            return true;
        }

        if ($module_name == 'EU_Cookie_Law') {/*EU_GDPR*/
            // this is a first enable for the eU_GDpR module
            static::updateAll();
        } else {
            $curtime = XC_TIME;
            $cat = 'Modules';
            db_query("INSERT INTO $sql_tbl[gdpr_access_log] (service_id,`category`,description,initial_access_date,update_date) SELECT module_name,'$cat',module_descr,'$curtime','$curtime' FROM $sql_tbl[modules] INNER JOIN $sql_tbl[gdpr_modules] USING (module_name) WHERE active='Y' ON DUPLICATE KEY UPDATE update_date = '$curtime'");
            if (!empty($module_name)) {
                //this is a callback from for toggle module
                db_query("UPDATE $sql_tbl[gdpr_access_log] SET active='N' WHERE update_date<'" . XC_TIME . "' AND `category`='$cat'");
            }
            $already_called = 1;
        }

        return true;
    }//}}}

    protected static function updateCustomers() {//{{{
        global $sql_tbl;

        $curtime = XC_TIME;
        db_query("INSERT INTO $sql_tbl[gdpr_access_log] (service_id,`category`,description,initial_access_date,update_date) SELECT CONCAT_WS(' ',email,id),'Admins',CONCAT_WS(' ',firstname, lastname),'$curtime','$curtime' FROM $sql_tbl[customers] WHERE status='Y' AND usertype IN ('A','P') ON DUPLICATE KEY UPDATE update_date = '$curtime', description=CONCAT_WS(' ',firstname, lastname)");
    }//}}}

    protected static function updateShipping() {//{{{
        global $sql_tbl, $config;
        if (
            $config['Shipping']['realtime_shipping'] != 'Y'
            || $config['Shipping']['enable_shipping'] != 'Y'
        ) {
            return false;
        }

        $curtime = XC_TIME;
        db_query("INSERT INTO $sql_tbl[gdpr_access_log] (service_id,`category`,description,initial_access_date,update_date) SELECT code,'Shippings',code,'$curtime','$curtime' FROM $sql_tbl[shipping] WHERE active='Y' AND code!='' GROUP BY code ON DUPLICATE KEY UPDATE update_date = '$curtime'");
    }//}}}

    protected static function updatePayment() {//{{{
        global $sql_tbl;

        $curtime = XC_TIME;
        db_query("INSERT INTO $sql_tbl[gdpr_access_log] (service_id,`category`,description,initial_access_date,update_date) SELECT processor_file,'Payments',payment_method,'$curtime','$curtime' FROM $sql_tbl[payment_methods] WHERE active='Y' AND processor_file!='' ON DUPLICATE KEY UPDATE update_date = '$curtime',description=payment_method");
    }//}}}
}
