<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Classes
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    d6c0a1b7770fbc7688b8a15f1bfe57cca701b326, v3 (xcart_4_7_11), 2019-02-11 15:37:26, consent_classes.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */
namespace XC\GDPR;

class Consents {
    public static function recordUser($user_id, $page_type = 'user', $user_email = '')
    {//{{{
        global $sql_tbl, $CLIENT_IP;

        $curtime = XC_TIME;
        $last_agreement_id = func_query_first_cell("SELECT MAX(agreement_id) FROM $sql_tbl[gdpr_agreement_versions]");
        $update_count_str = empty($user_id) || $page_type == 'popup' ? '' : ", orders_count=orders_count+1";
        db_query("INSERT INTO $sql_tbl[gdpr_user_consents] (id,ip_user,user_email,orders_count,consent_page,initial_date,update_date,agreement_id) VALUES (
            '$user_id',
            '" . addslashes($CLIENT_IP) . "',
            '" . addslashes($user_email) . "',
            '" . (empty($user_id) || $page_type != 'order' ? 0 : 1) . "',
            '$page_type',
            '$curtime',
            '$curtime',
            '$last_agreement_id'
        ) ON DUPLICATE KEY UPDATE update_date='$curtime', agreement_id='$last_agreement_id', user_email='" . addslashes($user_email) . "' $update_count_str");
    }//}}}

    public static function recordOrder($order_id, $userid = 0, $email = '')
    {//{{{
        global $sql_tbl;

        if (empty($userid)) {
            // try to find first Order to work unique index properly
            if (!empty($email)) {
                $first_orderid = func_query_first_cell("SELECT id FROM $sql_tbl[gdpr_user_consents] WHERE user_email = '" . addslashes($email) . "' AND consent_page='order'");
                //db_query("DELETE FROM $sql_tbl[gdpr_user_consents] WHERE user_email = '" . addslashes($email) . "' AND consent_page='popup'");
                return static::recordUser(($first_orderid ?: $order_id), 'order', $email);
            }
        } else {
            return static::recordUser($userid, 'user');
        }
    }//}}}

    public static function recordFromPopup($email)
    {//{{{
        global $sql_tbl;
        $select_cond = "FROM $sql_tbl[gdpr_user_consents] WHERE user_email = '" . addslashes($email) . "' AND consent_page='popup'";
        $userid = func_query_first_cell("SELECT id $select_cond") ?: intval(func_query_first_cell("SELECT MAX(id) FROM $sql_tbl[gdpr_user_consents] WHERE consent_page='popup'")) + 1;
        return static::recordUser($userid, 'popup', $email);
    }//}}}

    public static function deleteOrder($orderid)
    {//{{{
        global $sql_tbl;

        $_user_data = func_query_first("SELECT userid,email FROM $sql_tbl[orders] WHERE orderid='$orderid'");
        if (
            empty($_user_data['userid'])
            && ($_email = addslashes($_user_data['email']))
        ) {
            db_query("UPDATE $sql_tbl[gdpr_user_consents] SET orders_count=orders_count-1 WHERE user_email = '$_email' AND consent_page='order'");
            db_query("DELETE FROM $sql_tbl[gdpr_user_consents] WHERE user_email = '$_email' AND consent_page='order' AND orders_count<=0");
        }
    }//}}}

    public static function showAgreementAgainIfItChanged($_user, $_login_type)
    {//{{{
        global $sql_tbl;

        if (
            $_login_type != 'C'
            || empty($_user)
        ) {
            return false;
        }

        if (is_numeric($_user)) {
            $cond = "id='$_user' AND consent_page='user'";
        } else {
            $cond = "user_email = '$_user' AND consent_page='order'";
        }

        $user_agreement_id = func_query_first_cell("SELECT agreement_id FROM $sql_tbl[gdpr_user_consents] WHERE $cond");
        if (
            !empty($user_agreement_id)
            && ($_last_agreement_id = func_query_first_cell("SELECT MAX(agreement_id) FROM $sql_tbl[gdpr_agreement_versions]"))
            && $_last_agreement_id != $user_agreement_id
        ) {
            db_query("DELETE FROM $sql_tbl[gdpr_user_consents] WHERE $cond");
            return static::showAgreementAgain();
        }

        return false;
    }//}}}

    protected static function showAgreementAgain()
    {//{{{
        global $sql_tbl, $logged_userid;

        if (!empty($logged_userid)) {
            $_cond = "WHERE userid = '$logged_userid'";
            if (version_compare(X_MYSQL_VERSION, '8.0.0') >= 0) {
                db_query("UPDATE $sql_tbl[customer_eu_cookie_accesses] SET eu_cookie_access=REGEXP_REPLACE(eu_cookie_access,'[0-9]+/','0/') $_cond");
            } else {
                $_current = func_query_first_cell("SELECT eu_cookie_access FROM $sql_tbl[customer_eu_cookie_accesses] $_cond") ?: '';
                $_new_current = preg_replace("%^[0-9]+/%", '0/', $_current);
                if (
                    $_new_current != $_current
                    && !empty($_new_current)
                ) {
                    db_query("UPDATE $sql_tbl[customer_eu_cookie_accesses] SET eu_cookie_access='$_new_current' $_cond");
                }
            }
        }

        func_setcookie('eucl_cookie_access', "", XC_TIME - 3600); // clear
    }//}}}
}

class Agreements {
    public static function saveVersion($pageid, $pagecontent)
    {//{{{
        global $sql_tbl, $config;

        if (
            $config['EU_Cookie_Law']['gdpr_static_pageid'] != $pageid
            || empty($pagecontent)
        ) {
            return false;
        }

        db_query("DELETE FROM $sql_tbl[gdpr_agreement_versions] WHERE agreement_id NOT IN (SELECT agreement_id FROM $sql_tbl[gdpr_user_consents])");
        db_query("INSERT INTO $sql_tbl[gdpr_agreement_versions] (agreement_text) VALUES ('" . addslashes($pagecontent) . "')");
        return true;
    }//}}}
}
