<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Configuration options processing.
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7e78a769270b51de1f97dcd34838c4aa984aaeb8, v2 (xcart_4_7_10), 2018-10-08 09:42:30, admin_config_display.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

func_gdpr_assign_tabs_data();

function func_gdpr_assign_tabs_data() {
    global $sql_tbl, $smarty, $xcart_dir;

    $gdpr_integration_type_tabs = array();
    // EU_GDPR
    $gdpr_integration_type_tabs[] = array(
        'title' => func_get_langvar_by_name('lbl_settings'),
        'tpl' => 'modules/EU_Cookie_Law/EU_GDPR/setting_tab.tpl',
        'anchor' => 'settings',
    );

    $gdpr_integration_type_tabs[] = array(
        'title' => func_get_langvar_by_name('lbl_gdpr_access_records'),
        'tpl' => 'modules/EU_Cookie_Law/EU_GDPR/access_log_tab.tpl',
        'anchor' => 'help',
    );

    if (defined('XC_GDPR_ALLOW_ADMIN_CONSENT_TAB')) {
        $gdpr_integration_type_tabs[] = array(
            'title' => func_get_langvar_by_name('lbl_gdpr_consent_records'),
            'tpl' => 'modules/EU_Cookie_Law/EU_GDPR/consents_tab.tpl',
            'anchor' => 'consents',
        );
    }

    //func_get_carriers
    $_carriers = array();
    $_carriers['CPC'] = 'Canada Post';
    $_carriers['FDX'] = 'FedEx';
    $_carriers['USPS'] = 'U.S.P.S';
    $_carriers['DHL'] = 'DHL';
    $_carriers['APOST'] = 'Australia Post';
    $_carriers['1800C'] = '1-800Courier';
    $_carriers['PB'] = 'Pitney Bowes';


    $gdpr_access_rows = func_query_hash("SELECT category,$sql_tbl[gdpr_access_log].* FROM $sql_tbl[gdpr_access_log] ORDER BY initial_access_date DESC",'category');
    foreach ($gdpr_access_rows as $k2 => $row) {
        if ($k2 == 'Shippings') {
            foreach ($row as $k3 => $_shipping) {
                $gdpr_access_rows[$k2][$k3]['description'] = isset($_carriers[$_shipping['service_id']]) ? $_carriers[$_shipping['service_id']] : $_shipping['description'];
            }
        }

        if ($k2 == 'Modules') {
            foreach ($row as $k3 => $_module) {
                if (empty($_module['description'])) {
                    $gdpr_access_rows[$k2][$k3]['description'] = func_get_langvar_by_name('module_descr_' . $_module['service_id']);
                }

                $gdpr_access_rows[$k2][$k3]['service_id'] = func_get_langvar_by_name('module_name_' . $_module['service_id']);
                if (empty($gdpr_access_rows[$k2][$k3]['service_id'])) {
                    $gdpr_access_rows[$k2][$k3]['service_id'] = $_module['service_id'];
                }
            }
        }

    }

    $smarty->assign('access_rows', $gdpr_access_rows);
    $smarty->assign('carriers', $_carriers);

    // Records of consents Tab
    if (defined('XC_GDPR_ALLOW_ADMIN_CONSENT_TAB')) {
        global $config;
        global $total_nav_pages, $total_items, $objects_per_page, $page, $first_page;
        $total_items = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[gdpr_user_consents]");
        $objects_per_page = 30;

        $page = empty($page) ? 0 : $page;
        include $xcart_dir . '/include/navigation.php';

        $user_consents = func_query("SELECT * FROM $sql_tbl[gdpr_user_consents] ORDER BY update_date DESC LIMIT $first_page, $objects_per_page") ?: array();
        $smarty->assign('user_consents', $user_consents);
        $smarty->assign('navigation_script','configuration.php?option=EU_Cookie_Law');
        $smarty->assign('last_policy_version',func_query_first_cell("SELECT MAX(agreement_id) FROM $sql_tbl[gdpr_agreement_versions]"));
    }

    // General part
    $smarty->assign('integration_type_tabs', $gdpr_integration_type_tabs);
    $smarty->assign('custom_admin_module_config_tpl_file', 'modules/EU_Cookie_Law/EU_GDPR/configuration.tpl');
}
