<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    17268acd4e746718cc2d5ba3cb5dbdf531ff9f41, v22 (xcart_4_7_10), 2018-10-11 10:05:22, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }

global $config, $XCART_SESSION_NAME, $xcart_dir, $sql_tbl, $CLIENT_IP, $smarty;// EU_GDPR
$addons['EU_Cookie_Law'] = true;

$sql_tbl['customer_eu_cookie_accesses'] = XC_TBL_PREFIX . 'customer_eu_cookie_accesses';
$sql_tbl['gdpr_access_log'] = XC_TBL_PREFIX . 'gdpr_access_log';
$sql_tbl['gdpr_agreement_versions'] = XC_TBL_PREFIX . 'gdpr_agreement_versions';
$sql_tbl['gdpr_modules'] = XC_TBL_PREFIX . 'gdpr_modules';
$sql_tbl['gdpr_user_consents'] = XC_TBL_PREFIX . 'gdpr_user_consents';


// disable module for non-EU customers
if (
    !defined('DEVELOPMENT_MODE') && !defined('XC_DEBUG_EU_COOKIE_LAW') // EU_GDPR
    && !in_array(func_constant('AREA_TYPE'), array('A','P'))
    && function_exists('geoip_continent_code_by_name')
    && in_array(geoip_continent_code_by_name($CLIENT_IP), array('AF','AN','AS','NA','OC','SA'))
    && !empty($CLIENT_IP) && !empty($smarty)
) {
    unset($active_modules['EU_Cookie_Law']);
    $smarty->assign('active_modules', $active_modules);
}

settype($config['EU_Cookie_Law']['strictly_necessary_cookies'], 'array');
$config['EU_Cookie_Law']['strictly_necessary_cookies'] = 
array_merge($config['EU_Cookie_Law']['strictly_necessary_cookies'],
    array(
        $XCART_SESSION_NAME,
        'eucl_cookie_access',
    )
);


settype($config['EU_Cookie_Law']['functional_cookies'], 'array');

$config['EU_Cookie_Law']['functional_cookies'] = array_merge($config['EU_Cookie_Law']['functional_cookies'],
    array(
        $XCART_SESSION_NAME . 'C_remember',
        $XCART_SESSION_NAME . 'B_remember',
        $XCART_SESSION_NAME . 'A_remember',
        $XCART_SESSION_NAME . 'P_remember',
        'GreetingCookie',
        'RefererCookie',
        'access_key',
        'adv_campaignid',
        'adv_campaignid_time',
        'custom_template',//?include/lib/cssin/vendor/csstidy/css_optimiser.php
        'hash_antibot_validation_val',//DEV used for nginx caching
        'load_defer_code_plain_combine',//DEV used for debugging MInify css/js
        'partner',
        'partner_clickid',
        'partner_time',
        'popup_product_1st_column',
        'store_language',
    )// https://help.x-cart.com/index.php?title=X-Cart:EU_Cookie_Law#X-Cart_cookies
);


$css_files['EU_Cookie_Law'][] = array();
$css_files['EU_Cookie_Law'][] = array('altskin' => TRUE);

$_module_dir  = $xcart_dir . XC_DS . 'modules' . XC_DS . 'EU_Cookie_Law';
/*
 Load module functions
*/
if (!empty($include_func)) {
    require_once $_module_dir . XC_DS . 'func.php';
}


/*
* Init gdpr part
*/
if (!empty($include_func) || !empty($include_init)) {
    func_gdpr_init();
}

/*
* Functions definitions to load module
*/
function func_gdpr_init()
{//{{{
    global $config, $sql_tbl, $REQUEST_METHOD, $mode;

    //for whole site
    func_gdpr_overwrite_eml_setting();

    // backend handlers
    if (
        defined('ADMIN_MODULES_CONTROLLER')
        || func_postponed_events_storage()
    ) {
        spl_autoload_register('func_gdpr_backend_autoloader');
        func_add_event_listener('Postponed:module.enable', '\XC\GDPR\Backend\AccessLog::updateModules');
        func_add_event_listener('Postponed:module.disable', '\XC\GDPR\Backend\AccessLog::updateModules');
    } elseif (
        defined('ADMIN_CONFIGURATION_CONTROLLER')
        && !empty($_GET['option'])
        && $_GET['option'] == 'EU_Cookie_Law'//EU_GDPR
    ) {
        $last_update_date = func_query_first_cell("SELECT MAX(update_date) FROM $sql_tbl[gdpr_access_log]") ?: 0;

        if ($last_update_date < (XC_TIME - (SECONDS_PER_MIN * 60))) {
            spl_autoload_register('func_gdpr_backend_autoloader');
            // update log once per hour
            \XC\GDPR\Backend\AccessLog::updateAll();
        }
    }

    if (
        (
            strpos($_SERVER['PHP_SELF'], 'register.php') !== false
            && isset($_POST['usertype'])
        ) || (
            strpos($_SERVER['PHP_SELF'], 'pages.php') !== false
            && !empty($mode) && $mode == 'modified'
        )
    ) {
        if ($REQUEST_METHOD == 'POST') {
            spl_autoload_register('func_gdpr_consent_autoloader');//for admin/Pages.php

            if (!empty($_POST['usertype']) && strpos($_SERVER['PHP_SELF'], 'register.php') !== false) {//for Register.php
                func_add_event_listener('user.register.aftersave', '\XC\GDPR\Consents::recordUser');
            }
        }
    }
}//}}}

function func_gdpr_backend_autoloader($class_name) {//{{{
    global $xcart_dir;
    static $call_include_counter = 0;

    $match_array = array(
        'XC\GDPR\\' => 'modules/EU_Cookie_Law/EU_GDPR/classes.php',
    );

    foreach($match_array as $class_pattern => $file) {
        if (strpos($class_name, $class_pattern) !== false) {
            include $xcart_dir . XC_DS . $file;
            $call_include_counter++;
            break;
        }
    }

    if ($call_include_counter >= count($match_array)) {
        spl_autoload_unregister(__FUNCTION__);
        return;
    }
}// FUnc_gdpr_backend_autoloader}}}

function func_gdpr_consent_autoloader($class_name)
{//{{{
    global $xcart_dir;
    static $call_include_counter = 0;

    $match_array = array(
        'XC\GDPR\\' => 'modules/EU_Cookie_Law/EU_GDPR/consent_classes.php',
    );

    foreach($match_array as $class_pattern => $file) {
        if (strpos($class_name, $class_pattern) !== false) {
            require_once $xcart_dir . XC_DS . $file;
            $call_include_counter++;
            break;
        }
    }

    if ($call_include_counter >= count($match_array)) {
        spl_autoload_unregister(__FUNCTION__);
        return;
    }
}//FUnc_gdpr_customer_autoloader}}}

function func_gdpr_get_static_pages() {//{{{
    global $sql_tbl, $config;

    $pages = array(func_get_langvar_by_name('lbl_please_select_one'));
    $pages = $pages + func_query_hash("SELECT pageid, CONCAT(title, ' (', filename, ')', ' pageid=', pageid, ' ', language) FROM $sql_tbl[pages] WHERE `level` = 'E' ORDER BY orderby", 'pageid', false, true);

    if (!in_array($config['EU_Cookie_Law']['gdpr_static_pageid'], array_keys($pages))) {
        $config['EU_Cookie_Law']['gdpr_static_pageid'] = 0;
        db_query("UPDATE $sql_tbl[config] SET value=0 WHERE name='gdpr_static_pageid'");
    }
    return $pages;
}//}}}

function func_gdpr_overwrite_eml_setting() {//{{{
    global $config, $g_modules_configuration_post;

    // Overwrite some email notification options
    $options_map = array(
        'eml_profile_deleted_admin' => 'Y',
    );


    foreach ($options_map as $default_option => $module_option) {
        if (
            defined('ADMIN_CONFIGURATION_CONTROLLER')
            && !empty($_GET['option']) && $_GET['option'] == 'Email_Note'
        ) {
            if (!empty($module_option)) {
                $g_modules_configuration_post['Email_Note'][$default_option]['small_note'] = func_get_langvar_by_name('txt_gdpr_actual_eml_profile_deleted_admin');
            }
        } elseif (isset($config['Email_Note'][$default_option])) {
            //Override default Email values for all pages besides configuration.php?option=Email
            $config['Email_Note'][$default_option] = $module_option;
        }
    }
}//}}}
