<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * save of cookie access
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7e78a769270b51de1f97dcd34838c4aa984aaeb8, v13 (xcart_4_7_10), 2018-10-08 09:42:30, eu_cookie_law.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }

if (empty($active_modules['EU_Cookie_Law'])) {
    func_close_window();
}

/**
 * Update data
 */
if (
    'POST' === $REQUEST_METHOD
    && 'change_settings' === $mode
) {
    $now = XC_TIME;
    $functional_access = ($functional_access == 'Y') ? 'Y' : 'N';
    $other_access = ($other_access == 'Y') ? 'Y' : 'N';

    if ($functional_access == 'N') {
        $other_access = 'N';
    }

    if ($other_access == 'Y') {
        $functional_access = 'Y';
    }

    func_setcookie('eucl_cookie_access', "$now/$functional_access/$other_access", $now + 31536000);

    if (!empty($logged_userid) && $logged_userid > 0) {
        db_query("REPLACE INTO $sql_tbl[customer_eu_cookie_accesses] set eu_cookie_access='$now/$functional_access/$other_access', userid='$logged_userid'");

        require_once $xcart_dir . '/modules/EU_Cookie_Law/EU_GDPR/consent_classes.php';
        \XC\GDPR\Consents::recordUser($logged_userid);
    }

    func_reload_parent_window();
    exit;
} elseif (// EU_GDPR
    !empty($mode)
    && $mode == 'set_full_cookie'
    && 'GET' === $REQUEST_METHOD
) {
    if (!empty($logged_userid)) {
        require_once $xcart_dir . '/modules/EU_Cookie_Law/EU_GDPR/consent_classes.php';
        \XC\GDPR\Consents::recordUser($logged_userid);

        if ($existent_data = func_query_first_cell("SELECT eu_cookie_access FROM $sql_tbl[customer_eu_cookie_accesses] WHERE userid = '$logged_userid'")) {
            $existent_data = explode('/', $existent_data);

            if (
                empty($existent_data[0])
                && !empty($existent_data[1])
            ) {
                // Keep other settings which have been set previously
                $existent_data[0] = 1;
            }
        }
    }
    $_cookie_access = func_eucl_get_corrected_access(empty($existent_data) ? array(1,'Y','Y') : $existent_data);
    func_setcookie('eucl_cookie_access', implode('/', $_cookie_access), XC_TIME + 31536000);
    exit;
}

func_display('modules/EU_Cookie_Law/popup_cookie_settings.tpl', $smarty);

?>
