<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Functions for Froogle module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    9420d43903cbe798e4b468f13709aaacf26ac8a2, v4 (xcart_4_7_9), 2018-01-09 16:56:31, ExporterClass.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

namespace XC\Froogle\Backend;

if ( !defined('XCART_START') ) { header("Location: ../../"); die("Access denied"); }

global $xcart_dir;
include_once $xcart_dir . XC_DS . 'include/classes/class.csvFileExporter.php';

class Exporter {
    const
        PRODUCTS_PER_RAW = 500,
        IN_PROGRESS = 'IN_PROGRESS',
        FINISHED = 'FINISHED';

    protected $current_step, $export_lng, $sess_filename;

    public function __construct() { // {{{
        global $store_froogle_lng, $store_froogle_filename;

        x_session_register('store_froogle_lng');
        x_session_register('store_froogle_filename');
        $this->export_lng = $store_froogle_lng ?: '';
        $this->sess_filename = func_get_files_location() . XC_DS . $store_froogle_filename ?: '';
    } // }}}

    public function export_n_redirect() {//{{{
        global $sql_tbl, $XCARTSESSID, $top_message, $froogle_current_step, $config, $xcart_dir, $froogle_init_sess_total;

        x_session_register('top_message', array());
        x_session_register('froogle_current_step');
        x_session_register('froogle_init_sess_total');
        $finish_url = 'froogle.php';
        $continue_url = 'froogle.php?mode=fcreate_chunk_by_chunk';

        if (
            empty($froogle_current_step)
            || !$this->export_lng
            || !$this->sess_filename
        ) {
            // it seems the export is ended
            x_session_unregister('froogle_current_step');
            func_header_location($finish_url);
        }

        if ($froogle_current_step == 1) {
            //generate ids to export
            $this->markProductsPending();
            $left_total_count = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[froogle_products_pending_export] WHERE sessid='$XCARTSESSID'");
            $froogle_init_sess_total = $left_total_count;
            @unlink($this->sess_filename);
        } else {
            $left_total_count = func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[froogle_products_pending_export] WHERE sessid='$XCARTSESSID'");
        }
        $froogle_current_step++;

        if (empty($left_total_count)) {
            $this->removeSessionPendingData();
            $top_message['content'] = func_get_langvar_by_name('msg_adm_froogle_file_success');
            func_header_location($finish_url);
        }

        $force_get_sql_labels = $config['General']['use_cached_lng_vars'] != 'Y';
        $start_text = func_get_langvar_by_name('lbl_exporting_data_pass_', array('pass' => (100-round($left_total_count / $froogle_init_sess_total, 2) * 100) . '%'), false, $force_get_sql_labels);
        $_export_params = array(
            'currency' => $config['Froogle']['froogle_currency'],
            'module_name' => 'Froogle',
            'language' => $this->export_lng,
            'age_group' => '',
            'expiration_date' => empty($config['Froogle']['froogle_expiration_date']) ? 0.5 : $config['Froogle']['froogle_expiration_date'],
            'weight_unit' => $config['Froogle']['froogle_weight_unit'],
            'force_use_https_links' => ($config['Froogle']['froogle_used_https_links'] == 'Y' || $config['Security']['use_https_login'] == 'Y'),

        );

        $fileExporter = new csvFileExporterFroogle($this->sess_filename, $start_text, $_export_params);

        $ids2export = func_query_column("SELECT productid" . $this->getCondPackedIds(static::PRODUCTS_PER_RAW));
        $res = $fileExporter->saveProducts(array('ids' => $ids2export));

        switch ($res['code']) {
            case csvFileExporterFroogle::FILE_OPEN_ERROR :
                $top_message = array(
                    'type' => 'E',
                    'content' => func_get_langvar_by_name('msg_adm_froogle_file_unsuccess', array('file_path' => $this->sess_filename, 'dir' => dirname($this->sess_filename)))
                );
                $this->removeSessionPendingData('delete_pending');
                func_header_location($finish_url);

            case csvFileExporterFroogle::EMPTY_PRODUCTS :
                db_query("DELETE" . $this->getCondPackedIds(static::PRODUCTS_PER_RAW));
                func_header_location($continue_url);
                break;
        }

        if (count($ids2export) >= $left_total_count) {
            $this->removeSessionPendingData('delete_pending');
            $top_message['content'] = func_get_langvar_by_name('msg_adm_froogle_file_success');
            func_header_location($finish_url);
        } else {
            db_query("DELETE" . $this->getCondPackedIds(static::PRODUCTS_PER_RAW));
            func_header_location($continue_url);
        }
    }//}}}

    protected function markProductsPending() {//{{{
        global $sql_tbl, $XCARTSESSID;

        !mt_rand(0, 10) && db_query("DELETE FROM $sql_tbl[froogle_products_pending_export] WHERE sessid NOT IN (SELECT sessid FROM $sql_tbl[sessions_data])");

        db_query("REPLACE INTO $sql_tbl[froogle_products_pending_export] (SELECT p.productid AS productid,'$XCARTSESSID' AS sessid FROM $sql_tbl[products] AS p)");

    }//}}}

    protected function removeSessionPendingData($sql_mode = '') {//{{{
        global $XCARTSESSID, $sql_tbl;

        x_session_unregister('froogle_current_step');
        x_session_unregister('froogle_init_sess_total');
        if ($sql_mode == 'delete_pending') {
            db_query("DELETE FROM $sql_tbl[froogle_products_pending_export] WHERE sessid='$XCARTSESSID'");
        }
    }//}}}

    protected function getCondPackedIds($limit) {//{{{
        global $XCARTSESSID, $sql_tbl;
        $limit = intval($limit);

        return " FROM $sql_tbl[froogle_products_pending_export] WHERE sessid='$XCARTSESSID' ORDER BY productid LIMIT $limit";
    }//}}}
}//c-lass EXporter

class csvFileExporterFroogle extends \XC\csvFileExporter {
    const
    MAX_TITLE_LENGTH = 150,
    MAX_DESCRIPTION_LENGTH = 5000,
    MAX_GOOGLE_PRODUCT_CATEGORY_LENGTH = 100000,//no limit https://support.google.com/merchants/answer/6324406?hl=en&ref_topic=6324338
    MAX_PRODUCT_TYPE_LENGTH = 750,
    MAX_BRAND_LENGTH = 70,//https://support.google.com/merchants/answer/6324351?hl=en&ref_topic=6324338
    FORCE_USE_FULLDESCR = true,//false in parent
    ADD_PHP_PROTECTED_SIGNATURE = false,//true in parent
    ALWAYS_SET_GROUP_ID = false,//true in parent
    USE_PRODUCTID_AS_GROUP = false;//true in parent

    protected $excludeFields = array('age_group');

    protected function convertText($str, $max_len=0) {//{{{//
        return func_froogle_convert($str, $max_len);
    }//}}}

    protected function getProductExtraFields($pid, $in_variantid = 0, $in_use_product_fields_bydef = true) {//{{{//
        global $config;
        $in_use_product_fields_bydef = $config['Froogle']['froogle_use_product_fields_bydef'] == 'Y';
        return parent::getProductExtraFields($pid, $in_variantid, $in_use_product_fields_bydef);
    }//}}}

    protected function getProductPrice($in_productid, $in_product_price, $display_including_tax='N') {//{{{
        global $config;
        $display_including_tax = $config['Froogle']['froogle_display_including_tax'];
        return parent::getProductPrice($in_productid, $in_product_price, $display_including_tax);
    }//}}}
}
