<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    119aa071ae4873b347478c2090f8ecde3787770d, v19 (xcart_4_7_10), 2018-02-19 10:35:14, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }

/*
* Add a new value below to use the extra_field with the respective service_name for froogle export 
*/
$export_product_extrafields_headers_g['Froogle'] = $froogle_additional_attributes = array(
    /* Google's category of item */
    "google_product_category",
    /* Unique Product Identifiers */
    "gtin", 
    "mpn", 
    /* Submit the 'identifier exists' attribute with a value of FALSE when the item does not have unique GTIN/MPN/brand */
    "identifier_exists",
    "upc", 
    "ean", 
    "jan", 
    "isbn",
    /* Shared by Apparel and Variants */
    "color",
    "size",
    /* Variant Products */
    "material",
    "pattern",
    /* Apparel Products */
    "gender",
    "age_group",
    /* Custom attributes */
    "c:custom_attr",
);

$css_files['Froogle'][] = array();
$addons['Froogle'] = true;
$sql_tbl['froogle_products_pending_export'] = XC_TBL_PREFIX . 'froogle_products_pending_export';

$_module_dir  = $xcart_dir . XC_DS . 'modules' . XC_DS . 'Froogle';
/*
 Load module functions
*/
if (!empty($include_func)) {
    require_once $_module_dir . XC_DS . 'func.php';
}

// register cron jobs for cli mode
$cron_tasks[] = array(
    'function' => 'func_froogle_ecomm_update_all_feeds',
    'include'  => $xcart_dir . '/modules/Froogle/cron.php',
    'external_cron_only' => true,
);

settype($froogle_additional_attributes, 'array');
array_map('strtolower', $froogle_additional_attributes);

?>
