<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration update by cron
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    11fb7eba9c772cba2b5fec9530c35915eb0a1f39, v2 (xcart_4_7_12), 2019-12-29 16:20:12, cron.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header("Location: ../../"); die("Access denied"); }

function func_froogle_ecomm_update_all_feeds() {
    global $sql_tbl, $config, $xcart_dir, $all_languages, $single_mode, $xcart_http_host;

    $res = "Google Shopping: \n";
    if (defined('X_INTERNAL_CRON')) {
        return $res . 'you have to use shell cron. Internal cron skipped';
    }

    if (empty($xcart_http_host) && !defined('DEVELOPMENT_MODE')) {
        return $res . '$xcart_http_host variable is empty. Please check config.php/config.local.php files';
    }

    if ($config['Froogle']['froogle_ecomm_frequency_feed'] == 'never') {
        return $res . 'Disabled by the "Frequency of product feeds renewal" setting';
    }

    switch ($config['Froogle']['froogle_ecomm_frequency_feed']) {
        case 'hourly':
            $delta = SECONDS_PER_HOUR;
            break;
        case 'daily':
            $delta = SECONDS_PER_DAY;
            break;
        case 'weekly':
            $delta = SECONDS_PER_WEEK;
            break;
        default:
            return $res . '"Frequency of product feeds renewal" is not defined';
    }

    $cron_languages = $config['Froogle']['froogle_cron_languages'] != 'N' ? array_filter(explode(';', $config['Froogle']['froogle_cron_languages'])) : '';

    if (empty($cron_languages) && !empty($all_languages)) {
        $cron_languages = array_keys($all_languages);
    }

    if (empty($cron_languages)) {
        return $res . 'Empty languages';
    }

    x_load('backoffice');//for Func_get_files_locatio
    $old_single_mode = $single_mode;
    $single_mode = true;//don't use provider cond
    $_dir = func_get_files_location(0, 'A') . XC_DS  . 'cron_froogle';
    if (!func_mkdir($_dir)) {
        return $res . 'Cannot create dir:' . $_dir;
    }

    include_once $xcart_dir . XC_DS . 'modules/Froogle/ExporterClass.php';

    foreach ($cron_languages as $lng) {
        $sess_filename = $_dir .  XC_DS . "froogle_{$lng}.txt";
        $filemtime = @filemtime($sess_filename);
        if (!empty($filemtime) && $filemtime > (XC_TIME - $delta)) {
            $res .= "froogle_{$lng}.txt is up-to-date, skipped\n";
            continue;
        }

        $_export_params = array(
            'currency' => $config['Froogle']['froogle_currency'],
            'module_name' => 'Froogle',
            'language' => $lng,
            'age_group' => '',
            'expiration_date' => empty($config['Froogle']['froogle_expiration_date']) ? 0.5 : $config['Froogle']['froogle_expiration_date'],
            'weight_unit' => $config['Froogle']['froogle_weight_unit'],
            'force_use_https_links' => ($config['Froogle']['froogle_used_https_links'] == 'Y' || $config['Security']['use_https_login'] == 'Y'),

        );

        @unlink($sess_filename);

        $fileExporter = new XC\Froogle\Backend\csvFileExporterFroogle($sess_filename, '', $_export_params);
        $export_res = $fileExporter->saveProducts(array());
        if ($export_res['code'] == XC\Froogle\Backend\csvFileExporterFroogle::FILE_OPEN_ERROR) {
            $res .= func_get_langvar_by_name('msg_adm_froogle_file_unsuccess', array('file_path' => $sess_filename, 'dir' => dirname($sess_filename)), false, true) . "\n";
        } else {
            $res .= " $sess_filename is generated. Products:$export_res[real_exported_count_ids] Code:$export_res[code]\n";
        }
    }//foreach ($cron_languages as $lng)
    $single_mode = $old_single_mode;

    return $res;
}
