<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Froogle export module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    57925c23899bb883f8d10d470fc5a19b82d253cc, v116 (xcart_4_7_10), 2018-10-15 15:47:48, froogle.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_SESSION_START') ) { header("Location: ../../"); die("Access denied"); }

x_session_register('store_froogle_lng');

x_load('backoffice','taxes','product');

set_time_limit(0);

$location[] = array(func_get_langvar_by_name('lbl_froogle_export'), '');
include $xcart_dir.'/include/import_tools.php';

$is_ftp_module = '';
if(function_exists('ftp_connect') && !empty($config['Froogle']['froogle_username']) && !empty($config['Froogle']['froogle_password']))
    $is_ftp_module = 'Y';

$froogle_host = 'uploads.google.com';

x_session_register('store_froogle_filename');

// Export data
if ($REQUEST_METHOD == 'GET' && $mode == 'fcreate_chunk_by_chunk') {
//{{{
    include_once $xcart_dir . XC_DS . 'modules/Froogle/ExporterClass.php';
    $exporterObj = new \XC\Froogle\Backend\Exporter();
    $exporterObj->export_n_redirect();
//}}}
} elseif (!empty($active_modules['Froogle']) && $REQUEST_METHOD == 'POST' && $mode == 'fcreate') {
//{{{
    if (empty($froogle_file)) {
        if (empty($config['froogle_export_file'])) {
            $froogle_file = ($config['Froogle']['froogle_username'] ? $config['Froogle']['froogle_username'] : "froogle").".txt";
        } else {
            $froogle_file = $config['froogle_export_file'];
        }
    } elseif($froogle_file != $config['froogle_export_file']) {
        func_array2insert('config', array('name' => 'froogle_export_file', 'value' => $froogle_file, 'type' => 'text'), true);
    }
    $store_froogle_filename = $froogle_file;
    $store_froogle_lng = $froogle_lng;
    x_session_register('froogle_current_step', 1);
    $froogle_current_step = 1;

    func_header_location('froogle.php?mode=fcreate_chunk_by_chunk');
//}}}
} elseif(!empty($active_modules['Froogle']) && $REQUEST_METHOD == 'POST' && $mode == 'fdownload' && $froogle_file) {
    $froogle_file = func_get_files_location().XC_DS.$froogle_file;
    // Download export file
    if (!file_exists($froogle_file)) {
        $top_message['content'] = func_get_langvar_by_name("lbl_file_not_found");
        $top_message['type'] = "E";
        func_header_location('froogle.php');
    }

    header("Content-type: application/force-download");
    header("Content-Disposition: attachment; filename=".basename($froogle_file));
    func_readfile($froogle_file);
    exit;
}
elseif(!empty($active_modules['Froogle']) && $REQUEST_METHOD == 'POST' && $mode == 'fupload' && $froogle_file && $is_ftp_module) {
    $store_froogle_filename = $froogle_file;
    $froogle_file = func_get_files_location().XC_DS.$froogle_file;
    // Upload export file to Froogle server
    if (!file_exists($froogle_file)) {
        $top_message['content'] = func_get_langvar_by_name("lbl_file_not_found");
        $top_message['type'] = "E";
        func_header_location('froogle.php');
    }

    if (function_exists('ftp_connect')) {
        $ftp = ftp_connect($froogle_host);
        $top_message['type'] = 'E';
        if($ftp && @ftp_login($ftp, $config['Froogle']['froogle_username'], $config['Froogle']['froogle_password'])) {
            ftp_pasv($ftp, true);
            $fp = func_fopen($froogle_file, 'r', true);
            if ($fp) {
                if (@ftp_fput($ftp, basename($froogle_file), $fp, FTP_BINARY)) {
                    $top_message['content'] = func_get_langvar_by_name('msg_adm_froogle_success');
                    $top_message['type'] = 'I';
                }
                else {
                    $top_message['content'] = func_get_langvar_by_name('msg_adm_err_froogle_FTP_write_failed');
                }

                fclose($fp);
            }
            else {
                $top_message['content'] = func_get_langvar_by_name('msg_adm_err_froogle_file_not_found');
            }

            ftp_quit($ftp);
        }
        else {
            $top_message['content'] = func_get_langvar_by_name('msg_adm_err_froogle_FTP_failed');
        }
    }
    else {
        @exec("ftp -v -u ftp://".$config['Froogle']['froogle_username'].":".$config['Froogle']['froogle_password']."@".$froogle_host."/".func_shellquote(basename($froogle_file))." ".func_shellquote($froogle_file)." 2>&1", $res);
        $res = @implode("\n", $res);
        if (strpos($res, "226 ") !== false) {
            $top_message['content'] = func_get_langvar_by_name('msg_adm_froogle_success');
            $top_message['type'] = 'I';
        }
        else {
            $top_message['type'] = 'E';
            $top_message['content'] = func_get_langvar_by_name('msg_adm_err_froogle_FTP_failed');
        }
    }

    func_header_location('froogle.php');
}

$smarty->assign('froogle_file', $store_froogle_filename);
$smarty->assign('def_froogle_file', ($config['Froogle']['froogle_username'] ? $config['Froogle']['froogle_username'] : "froogle").".txt");

$smarty->assign('is_ftp_module', $is_ftp_module);

$smarty->assign('main', 'froogle_export');

$smarty->assign('froogle_lng', $store_froogle_lng ? $store_froogle_lng : $shop_language);

// Assign the current location line
$smarty->assign('location', $location);

$_dir = func_get_files_location(0, 'A') . XC_DS  . 'cron_froogle';
$cron_files = glob("$_dir/*");
if (!empty($cron_files)) {
    foreach ($cron_files as $k=>$_file) {
        $cron_files[$k] = array(
            'filename' => $current_location . str_replace($xcart_dir, '', $_dir) .  '/' . basename($_file),
            'size' => func_convert_to_megabyte(filesize($_file)),
            'lastupdate' => strftime($config["Appearance"]["datetime_format"], filemtime($_file)),
        );
    }
    $smarty->assign('cron_files', $cron_files);
}
