<?php /* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * REST API handler
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    17bc388355ed897d1f839f9e8ecd458d7d05ebfa, v3 (xcart_4_7_12), 2020-03-03 16:14:16, PathDispatcher.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

namespace XC\GoogleAdsKliken\REST;

if ( !defined('XCART_START') ) { header('Location: ..'); die('Access denied'); }

class PathDispatcher {
    const API_VERSION = '5.3.5.5';
    const SECURITY_SQL_CONDITION = " name NOT IN ('google_adskliken_restkey_write', 'UPS_username','UPS_accesskey','UPS_regusr','UPS_regpwd','UPS_taskey','xpc_shopping_cart_id','xpc_xpayments_url','xpc_public_key','xpc_private_key','alibaba_wholesale_AppKey','alibaba_wholesale_SecretKey','site_administrator','ip_register_codes','allowed_ips','xpc_allowed_ip_addresses','mandrill_enable_mailer','mandrill_smtp_username','smtp_server','smtp_user','use_smtp','unallowed_request_notify','eml_login_error','admin_sqlerror_notify','allow_ips','iContact_password','froogle_password','HTTPS_test_passed','news_emails_per_pass','send_login_pass','UPS_password','xpc_private_key_password','force_change_password_days','check_old_passwords','api_password','intershipper_password','pb_api_password','xbackup_ftp_password','pb_sftp_password','sftp_password','smtp_password','CPC_password','DHL_password','FEDEX_password','1800c_password', 'cmpi_transpwd') "; // the most import is google_adskLIkEn_restkey_wrIte And passwords, "type":"password" or name like '%pass%'

    public static $configNameGetters = array(
    //{{{
        'shop_currency' => 'getShopCurrency',
        'google_adskliken_shop_currency' => 'getShopCurrency',
        'weight_unit' => 'getWeightUnit',
        'dim_unit' => 'getDimUnit',
        'taxablebase' => 'getTaxableBase',
        'addresstype' => 'getAddressType',
    );//}}}

    public static $configNameAliases = array(
    //{{{
        'account_id' => 'google_adskliken_account_id',
        'allow_membership_request' => 'membership_signup',
        'app_token' => 'google_adskliken_account_token',
        'checkout_type' => 'checkout_module',
        'default_language' => 'default_customer_language',
        'default_products_sort_order' => 'products_order',
        'google_verification_token' => 'google_adskliken_google_token',
        'key_read' => 'google_adskliken_restkey_read',
        'maximal_order_amount' => 'maximum_order_amount',
        'origin_address' => 'shipfrom_address',
        'origin_city' => 'shipfrom_city',
        'origin_country' => 'shipfrom_country',
        'origin_state' => 'shipfrom_state',
        'origin_use_company' => 'shipfrom_address_as_company_one',
        'origin_zipcode' => 'shipfrom_zipcode',
        'show_out_of_stock_products' => 'show_outofstock_products',
        'users_per_page' => 'users_per_page_admin',
        'week_start' => 'working_week_starts_from',
        //'key' => 'google_adskliken_restkey_write',//cannot be uncomment due to sEcuRity reAsOn
    );//}}}

    public static $configNamePostFilters = array(
    //{{{
        '1800c_state' => 'changeToStateId',
        'checkout_type' => 'changeCheckoutModuleName',
        'default_state' => 'changeToStateId',
        'location_state' => 'changeToStateId',
        'origin_state' => 'changeToStateId',
        'shipfrom_state' => 'changeToStateId',
        'week_start' => 'changeLongDayNameToShort',
    );//}}}

    protected static $configCategoryAliases = array(
    //{{{
        'kliken\googleads' => 'Google_Ads_Kliken',
        'xc\restapi' => 'Google_Ads_Kliken',
    );//}}}

	/**
	 * GET: Retrieve tax types
	 */
	public function readAllCdevSalestaxTax($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND tax.taxid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        $data = func_query_hash("SELECT tax.taxid, tax.taxid AS 'id', (IF(tax.active='Y', TRUE, FALSE)) AS 'enabled', tax.*, rate.*, IF(rate.formula != '',rate.formula,tax.formula) AS taxableBase, (IF(rate.rate_type='%', 'p', 'a')) AS 'type', rate_value AS 'value' FROM $sql_tbl[taxes] tax LEFT JOIN $sql_tbl[tax_rates] rate USING(taxid) $where $limit_str", 'taxid') ?: null;
        if (!empty($_id_from_path)) {
            $_count = 1;
        } else {
            $_count = $data ? count($data) : 1;
        }

        if (is_array($data)) {
            $new_data = array();
            $i = 0;
            foreach ($data as $_tax_id=>$_tax_rates) {
                $new_data[$i]['id'] = $_tax_id;
                foreach ($_tax_rates as $_taxrate_id=>$_tax_rate) {
                    $new_data[$i]['enabled'] = (bool)$_tax_rate['enabled'];
                    $_tax_rate['id'] = $_tax_rate['rateid'];
                    $_tax_rate['zoneId'] = $_tax_rate['zoneid'];
                    $new_data[$i]['rates'][] = array_intersect_key($_tax_rate, array_flip(array('id','zoneId','value','taxableBase','type')));
                }
                $i++;
            }
            $data = $new_data;
            if (!empty($_id_from_path)) {
                $data = empty($data) ? $data : array_pop($data);
            }
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve Tax type by id
	 */
	public function readCdevSalestaxTax()
	{//{{{
        return $this->readAllCdevSalestaxTax($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update tax type by id
	 */
	public function updateCdevSalestaxTax()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add tax rate
	 */
	public function createCdevSalestaxTaxRate()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete tax rate by id
	 */
	public function deleteCdevSalestaxTaxRate()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve tax rates by conditions
	 */
	public function readAllCdevSalestaxTaxRate()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve tax rate by id
	 */
	public function readCdevSalestaxTaxRate()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update tax rate by id
	 */
	public function updateCdevSalestaxTaxRate()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New category
	 */
	public function createCategory()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete category by id
	 */
	public function deleteCategory()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve CAtegories by conditions
	 */
	public function readAllCategory($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND c.categoryid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        $select_str = "SELECT c.*, (IF(c.avail='Y', TRUE, FALSE)) AS 'enabled' , (IF(c.parentid=0, TRUE, FALSE)) AS 'isRootCategory', img.id AS 'imgid', img.image_path, _url.clean_url  FROM $sql_tbl[categories] c LEFT JOIN $sql_tbl[images_C] img ON img.id=c.categoryid LEFT JOIN $sql_tbl[clean_urls] _url ON _url.resource_type='C' AND _url.resource_id=c.categoryid $where GROUP BY c.categoryid $orderby_str $limit_str";
        $data = func_query($select_str) ?: null;
        if (!empty($data)) {
            $_new_data = array();
            x_load('image');
            foreach ($data as $k=>$_cat_data) {
                $_new_data[$k]['isRootCategory'] = $_cat_data['isRootCategory'];
                $_new_data[$k]['categoryId'] = $_cat_data['categoryid'];
                $_new_data[$k]['parentId'] = $_cat_data['parentid'];
                $_new_data[$k]['enabled'] = (bool)$_cat_data['enabled'];
                $_new_data[$k]['image'] = $_cat_data['imgid'] ? func_get_image_url($_cat_data['imgid'], 'C', $_cat_data['image_path']) : '';
                $_new_data[$k]['name'] = $_cat_data['category'];
                //$_new_data[$k]['description'] = $_cat_data['descr'];
                $_new_data[$k]['cleanUrls'] = array($_cat_data['clean_url']);
            }
            $data = $_new_data;
        }

        if (!empty($_id_from_path)) {
            $_count = 1;
            $data = empty($data) ? $data : array_pop($data);
        } else {
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve category by id
	 */
	public function readCategory()
	{//{{{
        global $sql_tbl, $current_area, $shop_language, $config;
        return $this->readAllCategory(intval($this->in_path_idname));
	}//}}}

	/**
	 * PUT: Update category by id
	 */
	public function updateCategory()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New config entry
	 */
	public function createConfig()
	{//{{{
        global $sql_tbl;
        $where = ' WHERE ' . static::SECURITY_SQL_CONDITION;//for sEcuRity reAson

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete config entry by id
	 */
	public function deleteConfig()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve all config entries
	 */
	public function readAllConfig($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE ' . static::SECURITY_SQL_CONDITION;//for sEcuRity reAson

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];

        //Id From Filter Or From ReadConfig
        if (!empty($_idname)) {

            //Try To Find Xc5 Emulations
            if (($_get_method = static::tryToResolveAlias($_idname, 'configNameGetters')) != $_idname) {
                if (empty($_id_from_path)) {
                    // _cnd[Name] Filter Must Return An Array Of Array
                    return $this->outputData(array(Config::$_get_method()));
                } else {
                    // This Is The Code To Obtain Single Var From config
                    return $this->outputData(Config::$_get_method());
                }
            }

            //Try To Find Xc5 Aliases
            $_idname = static::tryToResolveAlias($_idname, 'configNameAliases');
            $where .= " AND name='$_idname'";
        }

        if ($this->in_cnd['category']) {
            $this->in_cnd['category'] = static::tryToResolveAlias($this->in_cnd['category'], 'configCategoryAliases');
            $where .= " AND category='{$this->in_cnd['category']}'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        if (!empty($_id_from_path)) {

            // This Is The Code To Obtain Single Var From config
            $data = func_query_hash("SELECT name AS 'name1', name AS 'config_id', name, category, type, orderby, value, null AS 'widgetParameters' FROM $sql_tbl[config] $where $limit_str", 'name1', false) ?: null;
            $_count = 1;

        } else {
            $data = func_query_hash("SELECT name AS 'name1', name AS 'config_id', name,  category, type, orderby, value, null AS 'widgetParameters' FROM $sql_tbl[config] $where AND name NOT IN ('".implode("','", array_keys(static::$configNameGetters))."') $orderby_str $limit_str", 'name1', false) ?: array();

            // Emulate Some Variable For Category Call
            $_get_class_name = __NAMESPACE__ . '\\ConfigCategoryAddition';
            if (
                $this->in_cnd['category']
                && ($m_name = 'get' . ucwords(strtolower(str_replace('\\\\', '_', $this->in_cnd['category']))))
                && method_exists($_get_class_name, $m_name)
            ) {
                $data = array_merge($data, call_user_func_array(array($_get_class_name, $m_name), array($orderby_str)));
            }

            if (empty($data)) {
                $data = null;
                $_count = 1;
            } else {
                $_count = count($data);
            }
        }

        // Apply Xc5 Postfilters For Some Variables
        foreach (static::$configNamePostFilters as $_xc5_name => $handler) {

            if (isset($data[$_xc5_name])) {
                $data[$_xc5_name]['value'] = Config::$handler($data[$_xc5_name]['value']);
            } elseif (
                isset(static::$configNameAliases[$_xc5_name])# nolint
                && isset($data[static::$configNameAliases[$_xc5_name]])# nolint
            ) {
                $data[static::$configNameAliases[$_xc5_name]]['value'] = Config::$handler($data[static::$configNameAliases[$_xc5_name]]['value']);# nolint
            }
        }

        if (is_array($data)) {
            $data = array_values($data);
        }

        if (
            !empty($_id_from_path)
            && is_array($data)
        ) {
            $this->outputData($data[0], $_count);
        } else {
            $this->outputData($data, $_count);
        }
        return true;
	}//}}}

	/**
	 * GET: Retrieve config entry by id
	 */
	public function readConfig()
	{//{{{
        return $this->readAllConfig($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update config entry by id
	 */
	public function updateConfig()
	{//{{{
        $where = static::SECURITY_SQL_CONDITION;//for sEcuRity reAson

        $__idname = $this->in_path_idname;
        if (empty($__idname) || !$this->in_model || !is_array($this->in_model)) {
            return $this->outputData(null, 0);
        }

        $__idname = static::tryToResolveAlias($__idname, 'configNameAliases');

        $where .= " AND name='$__idname'";

        $white_keys = array('name','comment','value','category','orderby','type','defvalue','variants','validation');
        $data = $this->in_model;
        if (!empty($data['config_id']) && !is_numeric($data['config_id']) && is_string($data['config_id']) && empty($data['name'])) {
            $data['name'] = $data['config_id'];
        }

        $data = array_intersect_key($data, array_flip($white_keys));

        if (empty($data)) {
            return $this->readConfig();
        }

        if (!empty($data['category'])) {
            $data['category'] = static::tryToResolveAlias($data['category'], 'configCategoryAliases');
        }

        if (!empty($data['name'])) {
            $data['name'] = static::tryToResolveAlias($data['name'], 'configNameAliases');
        }

        func_unset($data, 'name');
        if (empty($data)) {
            return null;
        }
        func_array2update('config', $data, $where);

        return $this->readConfig();
	}//}}}

	/**
	 * POST: Add New country
	 */
	public function createCountry()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete country by id
	 */
	public function deleteCountry()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve countries by conditions
	 */
	public function readAllCountry()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve country by id
	 */
	public function readCountry()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update country by id
	 */
	public function updateCountry()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New currency
	 */
	public function createCurrency()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete currency by id
	 */
	public function deleteCurrency()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve all currencies
	 */
	public function readAllCurrency($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND code='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        if (!empty($_id_from_path)) {
            $data = func_query_first("SELECT code AS 'currency_id', $sql_tbl[currencies].* FROM $sql_tbl[currencies] $where $limit_str") ?: null;
            $_count = 1;
        } else {
            $data = func_query("SELECT code AS 'currency_id', $sql_tbl[currencies].* FROM $sql_tbl[currencies] $where $orderby_str $limit_str") ?: null;
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve currency by id
	 */
	public function readCurrency()
	{//{{{
        return $this->readAllCurrency($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update currency by id
	 */
	public function updateCurrency()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New order
	 */
	public function createOrder()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete order by id
	 */
	public function deleteOrder()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve orders by conditions
	 */
	public function readAllOrder($_id_from_path = '')
	{//{{{
        global $sql_tbl, $active_modules, $config, $xcart_dir, $sql_max_allowed_packet, $current_area;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND orderid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        $select_str = "SELECT orderid  FROM $sql_tbl[orders] $where $limit_str";
        $ids = func_query_column($select_str) ?: null;
        if (empty($ids)) {
            return $this->outputData(null);
        }

        x_load('order');
        $new_data = array();
        if (empty($sql_tbl['order_status_history'])) {
            include_once $xcart_dir . XC_DS . 'modules/Advanced_Order_Management/config.php';
        }
        $pids2check = array();
        $index = 0;
        foreach ($ids as $_order_id) {
            $data = func_order_data($_order_id);

            $data = func_array_merge($data, $data['order']);
            unset($data['order']);
            $data['orderNumber'] = $data['orderId'] = intval($data['orderid']);
            $data['shippingCost'] = $data['shipping_cost'];
            $data['paymentFee'] = $data['payment_surcharge'];
            $data['taxAmount'] = $data['tax'];
            $data['discountValue'] = $data['discount'] + $data['coupon_discount'] + $data['giftcert_discount'];

            $data['payment_method_name'] = $data['payment_method'];

            $data['items'] = $data['products'];
            unset($data['products']);

            $data['paymentStatus'] = $data['status'];

            if (!empty($data['items'])) {
                foreach ($data['items'] as $k=>$v) {
                    if (empty($pids2check[$v['productid']])) {
                        $pids2check[$v['productid']] = array();
                    }
                    if (!empty($v['productid'])) {
                        $pids2check[$v['productid']][$index] = $k;
                    }
                    $data['items'][$k]['sku'] = $data['items'][$k]['productcode'];
                    $data['items'][$k]['productId'] = $data['items'][$k]['productid'];
                    $data['items'][$k]['name'] = $data['items'][$k]['product'];
                    $data['items'][$k]['total'] = $data['items'][$k]['subtotal'];
                    $data['items'][$k]['quantity'] = $data['items'][$k]['amount'];
                    $data['items'][$k]['enabled'] = true;
                    $data['items'][$k]['shortDescription'] = $data['items'][$k]['descr'];
                    $data['items'][$k]['description'] = $data['items'][$k]['fulldescr'];
                    $data['items'][$k]['freeShipping'] = !empty($data['items'][$k]['free_shipping']) && $data['items'][$k]['free_shipping'] == 'Y';
                }

            }

            $data['orderDate'] = $data['date'];
            $data['paymentMethod'] = $data['payment_method'];
            $data['customerInfo'] = $data['userinfo'];
            $data['billingInfo'] = $data['customerInfo']['address']['B'];
            $data['shippingInfo'] = $data['customerInfo']['address']['S'];
            $data['shippingMethod'] = empty($data['shipping']) && !empty($data['shippingid']) ? func_query_first_cell("SELECT shipping FROM $sql_tbl[shipping] WHERE shippingid='" . $data['shippingid'] . "'") : $data['shipping'];
            unset($data['userinfo']);

            $data['order_status_history'] = func_query("SELECT * FROM $sql_tbl[order_status_history] WHERE orderid='$data[orderNumber]'");

            $new_data[] = $data;
            $index++;
        }

        $data = $new_data;

        // Let Us Fill The Enabled Fields By Acutula Product State
        if (!empty($pids2check)) {
            x_load('product');
            $pids2check_ids = array_keys($pids2check);
            $_ids_string= implode("','", $pids2check_ids);

            if (strlen($_ids_string) + 2000 > $sql_max_allowed_packet && !empty($sql_max_allowed_packet)) {
                $delimitor = round((strlen($_ids_string) + 2000) / $sql_max_allowed_packet);
                $chunks_size = min(1, round(count($pids2check_ids) / ($delimitor + 2)));

                $pids_chunks = array_chunk($pids2check_ids, $chunks_size);
            } else {
                $pids_chunks = array($pids2check_ids);
            }

            if (empty($config['setup_images'])) {
                $config['setup_images'] = array('T' => array('location' => ''));
            }

            $current_area = 'C';
            $query = array(
                'skip_tables' => \XCSearchProducts::getSkipTablesByTemplate(\XCSearchProducts::SKIP_ALL_POSSIBLE),//compatible from xcart_4_6_0
            );
            $available_ids = array();
            foreach ($pids_chunks as $_pids2check) {
                $query['query'] = " AND $sql_tbl[products].productid IN ('" . implode("','", $_pids2check) . "')";
                $chunkavailable_ids = func_search_products($query, 0, 'skip_orderby', '', true) ?: array();//compatible from xcart_4_5_1
                array_walk($chunkavailable_ids, function(&$val, $key) {$val = $val['productid'];});#nolint

                $available_ids = array_merge($available_ids, $chunkavailable_ids);
            }
            $current_area = 'A';

            $disabled_products = array_diff_key($pids2check, array_flip($available_ids));

            if (!empty($disabled_products)) {
                foreach ($disabled_products as $dis_pid=>$_tmp) {
                    foreach ($pids2check[$dis_pid] as $data_order_index=>$data_item_index) {
                        $data[$data_order_index]['items'][$data_item_index]['enabled'] = false;
                    }
                }
            }
        }

        if (!empty($_id_from_path)) {
            $data = empty($data) ? $data : array_pop($data);
            $_count = 1;
        } else {
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve order by id
	 */
	public function readOrder()
	{//{{{
        return $this->readAllOrder(intval($this->in_path_idname));
	}//}}}

	/**
	 * PUT: Update order by id
	 */
	public function updateOrder()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New order history event
	 */
	public function createOrderhistoryevents()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete order history event by id
	 */
	public function deleteOrderhistoryevents()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve order history events by conditions
	 */
	public function readAllOrderhistoryevents()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve order history event by id
	 */
	public function readOrderhistoryevents()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update order history event by id
	 */
	public function updateOrderhistoryevents()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New order item
	 */
	public function createOrderitem()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete order item by id
	 */
	public function deleteOrderitem()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve order items by conditions
	 */
	public function readAllOrderitem()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve order item by id
	 */
	public function readOrderitem()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update order item by id
	 */
	public function updateOrderitem()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New order item surcharge
	 */
	public function createOrderitemSurcharge()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete order item surcharge by id
	 */
	public function deleteOrderitemSurcharge()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve all order item surcharges
	 */
	public function readAllOrderitemSurcharge()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve order item surcharge by id
	 */
	public function readOrderitemSurcharge()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update order item surcharge by id
	 */
	public function updateOrderitemSurcharge()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New product
	 */
	public function createProduct()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete product by id
	 */
	public function deleteProduct()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve product by conditions
	 */
	public function readAllProduct($_id_from_path = '')
	{//{{{
        global $sql_tbl, $config, $active_modules, $current_area, $shop_language, $xcart_dir, $mode, $objects_per_page, $search_data, $REQUEST_METHOD, $single_mode, $smarty, $obtain_extra_fields;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        $search_data['products'] = array();
        if (!empty($_idname)) {
            $where .= " AND p.productid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        $shop_language = $_def_code = $config['default_customer_language'];

        $mode = 'search';
        $obtain_extra_fields = false;
        $current_area = 'A';
        $objects_per_page = 9999999;
        $_inner_search = true;

        if (!empty($this->in_cnd['limit'][1])) {
            $objects_per_page = $this->in_cnd['limit'][1];
            $search_data['products']['page'] = (!empty($this->in_cnd['limit'][0]) ? floor($this->in_cnd['limit'][0] / $objects_per_page) : 0) + 1;
        }

        $search_data['products']['_']['orderbys'] = array('null');//To Avoid Sort By Product

        if (isset($this->in_cnd['updatedate'][0])) {
            $force_update_date = intval($this->in_cnd['updatedate'][0]);
            $search_data['products']['_']['inner_joins']['gak_product_update_times'] = array(
                'on' => "$sql_tbl[products].productid=$sql_tbl[gak_product_update_times].productid AND $sql_tbl[gak_product_update_times].update_date >=$force_update_date"
            );

            $search_data['products']['_']['fields'] = array("$sql_tbl[gak_product_update_times].update_date");
        }

        if (!empty($this->in_cnd['updatedate'][1])) {
            $force_update_date = empty($force_update_date) ? min(XC_TIME, $this->in_cnd['updatedate'][1]) : $force_update_date;
            if (empty($search_data['products']['_']['inner_joins']['gak_product_update_times'])) {
                $search_data['products']['_']['inner_joins']['gak_product_update_times'] = array(
                    'on' => "$sql_tbl[products].productid=$sql_tbl[gak_product_update_times].productid AND $sql_tbl[gak_product_update_times].update_date <=" . intval($this->in_cnd['updatedate'][1])
                );
                $search_data['products']['_']['fields'] = array("$sql_tbl[gak_product_update_times].update_date");
            } else {
                $search_data['products']['_']['inner_joins']['gak_product_update_times']['on'] .= " AND $sql_tbl[gak_product_update_times].update_date <=" . intval($this->in_cnd['updatedate'][1]);
            }
        }

        if (isset($force_update_date)) {
            if (!mt_rand(0, 10) || $force_update_date  <= 100000) {// Someone Tries To Show All The Products
                db_query("INSERT INTO $sql_tbl[gak_product_update_times] (SELECT productid, '" . XC_TIME . "' FROM $sql_tbl[products] WHERE productid NOT IN ( SELECT productid FROM $sql_tbl[gak_product_update_times]))");
            }
        }

        $REQUEST_METHOD = 'GET';
        define('AREA_TYPE', 'A');
        $products = array();
        include $xcart_dir . '/include/search.php';

        //$data = func_query($select_str) ?: null;

        $data = null;
        if (!empty($products)) {
            $_new_prod_data = array();
            foreach ($products as $k=>$_prod_data) {
                $_new_prod_data[$k]['sku'] = $_prod_data['productcode'];
                $_new_prod_data[$k]['productId'] = $_prod_data['productid'];
                $_new_prod_data[$k]['name'] = $_prod_data['product'];
                $_new_prod_data[$k]['description'] = $_prod_data['fulldescr'];
                $_new_prod_data[$k]['shortDescription'] = $_prod_data['descr'];
                $_new_prod_data[$k]['price'] = $_prod_data['price'];
                $_new_prod_data[$k]['weight'] = $_prod_data['weight'];
                $_new_prod_data[$k]['inventoryEnabled'] = $config['General']['unlimited_products'] != 'Y';
                $_new_prod_data[$k]['quantity'] = $_prod_data['avail'];
                $_new_prod_data[$k]['URL'] = func_get_resource_url('product', $_prod_data['productid']);
                $_new_prod_data[$k]['enabled'] = in_array($_prod_data['forsale'], array('Y','H'));
                $_new_prod_data[$k]['cleanUrls'] = array(func_clean_url_get_raw_resource_url('P', $_prod_data['productid']));

                // Images

                // Detect Product Thumbnail And Image
                $image_ids = array();
                if (
                    !empty($_prod_data['variantid'])
                    && !empty($active_modules['Product_Options'])
                ) {
                    $image_ids['W'] = $_prod_data['variantid'];
                    $prefered_image_type = 'W';
                } else {
                    $prefered_image_type = 'P';
                }

                $image_ids['P'] = $_prod_data['productid'];
                if (!empty($active_modules['Detailed_Product_Images'])) {
                    $image_ids['D'] = $_prod_data['productid'];
                }
                $image_ids['T'] = $_prod_data['productid'];
                $image_data = func_get_image_url_by_types($image_ids, $prefered_image_type) ?: array();
                $_new_prod_data[$k]['images'] = array();;
                if (!empty($image_data['images'])) {
                    foreach ($image_data['images'] as $_type => $_img) {
                        if (empty($_img['is_default'])) {
                            $_new_prod_data[$k]['images'][] = $_img['url'];
                        }
                    }
                }


                // Categories
                $_new_prod_data[$k]['categories'] = func_query_column("SELECT categoryid FROM $sql_tbl[products_categories] WHERE productid='$_prod_data[productid]' AND avail='Y' ORDER BY main DESC");

                $_new_prod_data[$k]['createdDate'] = $_prod_data['add_date'];
                if (!empty($_prod_data['update_date'])) {
                    $_new_prod_data[$k]['modifiedDate'] = $_prod_data['update_date'];
                }
//                $_new_prod_data[$k]['arrivalDate'] = $_prod_data[''];


                // Attributes
                if (!empty($active_modules['Extra_Fields'])) {
                    if (empty($active_modules['Froogle'])) {
                        global $froogle_additional_attributes;
                        $include_func = true;
                        include_once $xcart_dir . XC_DS . 'modules/Froogle/config.php';
                    }
                    $froogle_additional_attributes[] = 'brand';
                    $_new_prod_data[$k]['attributes'] = func_froogle_get_product_additional_attributes($_prod_data['productid']) ?: array();//compatible from xcart_4_4_4
                } else {
                    $_new_prod_data[$k]['attributes'] = array();
                }

                if (empty($_new_prod_data[$k]['attributes']['brand']) && !empty($_prod_data['manufacturerid'])) {
                    $_new_prod_data[$k]['attributes']['brand'] = func_query_first_cell("SELECT manufacturer FROM $sql_tbl[manufacturers] WHERE manufacturerid='$_prod_data[manufacturerid]'");
                }

                if (!empty($active_modules['Product_Options'])) {
                    $_options = func_get_product_classes($_prod_data['productid']) ?: array();
                    foreach ($_options as $_opt) {
                        $_new_prod_data[$k]['attributes'][$_opt['class']] = array();
                        if (!empty($_opt['options'])) {
                            foreach ($_opt['options'] as $_opt_val) {
                                $_new_prod_data[$k]['attributes'][$_opt['class']][] = $_opt_val['option_name'];
                            }
                        }
                    }
                }

                $_new_prod_data[$k]['shippingDimensions'] = array('length' => $_prod_data['length'],'width' => $_prod_data['width'],'height' => $_prod_data['height']);

            }

            $data = $_new_prod_data;
        }

        if (!empty($_id_from_path)) {
            $data = empty($data) ? $data : array_pop($data);
            $_count = 1;
        } else {
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve Product by id
	 */
	public function readProduct()
	{//{{{
        return $this->readAllProduct(intval($this->in_path_idname));
	}//}}}

	/**
	 * PUT: Update product by id
	 */
	public function updateProduct()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New shipping markup
	 */
	public function createShippingMarkup()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete shipping markup by id
	 */
	public function deleteShippingMarkup()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve shipping markups by conditions
	 */
	public function readAllShippingMarkup($_id_from_path = '')
	{//{{{
        global $sql_tbl, $config;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND rateid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        // compatible . rate_p_apply_to added in xcart_4_7_7
        if (version_compare($config['version'], '4.7.7') >= 0) {
            $sql_table_type = "(CASE (IF(type='R',rate_p_apply_to,apply_to)) WHEN 'DST' THEN 'DS' WHEN 'ST' THEN 'S' ELSE (IF(type='R',rate_p_apply_to,apply_to)) END) AS tableType";
        } else {
            $sql_table_type = "(CASE (IF(type='R',apply_to,apply_to)) WHEN 'DST' THEN 'DS' WHEN 'ST' THEN 'S' ELSE (IF(type='R',apply_to,apply_to)) END) AS tableType";
        }
        $select_str = "SELECT rateid AS 'markup_id',minweight AS 'min_weight',maxweight AS 'max_weight',mintotal AS 'min_total',maxtotal AS 'max_total',mintotal AS 'min_discounted_total',maxtotal AS 'max_discounted_total',rate AS 'markup_flat', rate_p AS 'markup_percent', item_rate AS 'markup_per_item', weight_rate AS 'markup_per_weight',zoneid AS 'zone_id',shippingid AS 'shipping_id', $sql_table_type FROM $sql_tbl[shipping_rates] $where $limit_str";

        $sql_processor = "(CASE code WHEN '' THEN 'offline' WHEN 'APOST' THEN 'aupost' WHEN 'CPC' THEN 'capost' WHEN 'FDX' THEN 'fedex' ELSE LOWER(code) END) AS 'processor'";
        $shipping_fields_query = "SELECT shippingid AS 'method_id', $sql_processor, code AS 'carrier',CONCAT(code,IF(subcode='',service_code,subcode)) AS code, (IF(active = 'Y', 'TRUE', 'FALSE')) AS 'enabled',orderby AS 'position', shippingid AS 'method_id', shipping AS 'method_name',shipping_time AS 'deliveryTime', 0 AS 'handlingFee', 'a' AS 'handlingFeeType' FROM $sql_tbl[shipping] WHERE shippingid = ";
        $data = func_query($select_str) ?: null;
        if (!empty($data)) {
            foreach ($data as $k=>$v) {
                $data[$k]['shipping_method'] = func_query_first($shipping_fields_query . intval($data[$k]['shipping_id']));
                $data[$k]['shipping_method']['tableType'] = $data[$k]['tableType'];
                $data[$k]['shipping_method']['enabled'] = (bool)$data[$k]['shipping_method']['enabled'];
                $data[$k]['zone'] = func_query("SELECT zoneid AS 'zone_id', zone_name, false AS 'is_default' FROM $sql_tbl[zones] WHERE zoneid = " . intval($data[$k]['zone_id']));
                if (empty($data[$k]['zone'])) {
                    $data[$k]['zone'] = array( 'zone_id' => 0, 'zone_name' => 'All Addresses (default zone)', 'is_default' => true);
                }
            }
        }
        if (!empty($_id_from_path)) {
            $_count = 1;
            $data = empty($data) ? $data : array_pop($data);
        } else {
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve shipping markup by id
	 */
	public function readShippingMarkup()
	{//{{{
        return $this->readAllShippingMarkup($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update shipping markup by id
	 */
	public function updateShippingMarkup()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New state
	 */
	public function createState()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete state by id
	 */
	public function deleteState()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve states by conditions
	 */
	public function readAllState($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND stateid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        if (!empty($_id_from_path)) {
            $data = func_query_first("SELECT stateid AS 'state_id', $sql_tbl[states].* FROM $sql_tbl[states] $where $limit_str") ?: null;
            $_count = 1;
        } else {
            $data = func_query("SELECT stateid AS 'state_id', $sql_tbl[states].* FROM $sql_tbl[states] $where $orderby_str $limit_str") ?: null;
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve state by id
	 */
	public function readState()
	{//{{{
        return $this->readAllState($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update state by id
	 */
	public function updateState()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New shipping zone
	 */
	public function createZone()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete shipping zone by id
	 */
	public function deleteZone()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve all shipping Zones
	 */
	public function readAllZone($_id_from_path = '')
	{//{{{
        global $sql_tbl;

        $where = ' WHERE 1 ';

        $_idname = $_id_from_path ? $_id_from_path : $this->in_cnd['name'];
        if (!empty($_idname)) {
            $where .= " AND zoneid='$_idname'";
        }

        list($orderby_str, $limit_str) = $this->getLimitOrderBy();

        if (!empty($_id_from_path)) {
            $data = func_query("SELECT zoneid AS 'zone_id', $sql_tbl[zones].*, $sql_tbl[zone_element].* FROM $sql_tbl[zones] LEFT JOIN $sql_tbl[zone_element] USING(zoneid) $where $limit_str") ?: null;

            if (is_array($data)) {
                foreach ($data as $k=>$v) {
                    if (!$k) {
                        func_unset($data[$k], 'field','field_type');
                        $res = $data[$k];
                        $res['shipping_markups'] = func_query("SELECT zoneid,$sql_tbl[shipping_rates].* FROM $sql_tbl[shipping_rates] WHERE zoneid = " . intval($v['zoneid']));
                    }
                    $res['zone_elements'][] = array_intersect_key($v, array_flip(array('field','field_type')));
                }
                $data = $res;
            }
            $_count = 1;
        } else {
            $data = func_query("SELECT zoneid AS 'zone_id', $sql_tbl[zones].* FROM $sql_tbl[zones] $where $orderby_str $limit_str") ?: null;
            $_count = $data ? count($data) : 1;
        }

        $this->outputData($data, $_count);
        return true;
	}//}}}

	/**
	 * GET: Retrieve shipping zone by id
	 */
	public function readZone()
	{//{{{
        return $this->readAllZone($this->in_path_idname);
	}//}}}

	/**
	 * PUT: Update shipping zone by id
	 */
	public function updateZone()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * POST: Add New shipping zone element
	 */
	public function createZoneelement()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * DELETE: Delete shipping zone element by id
	 */
	public function deleteZoneelement()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve all shipping zone elements
	 */
	public function readAllZoneelement()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * GET: Retrieve shipping zone element by id
	 */
	public function readZoneelement()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}

	/**
	 * PUT: Update shipping zone element by id
	 */
	public function updateZoneelement()
	{//{{{
        global $sql_tbl;

        return $this->notImplemented();
        $this->outputData($data); #nolint
        return true;
	}//}}}



	/**
     * =======================================================================================================================================
	 * Common methods
     * =======================================================================================================================================
	 */
	public function parseGetPostIntoProperties()
	{//{{{
        foreach(array('_key' => '','_path' => '','model' => array(),'_cnd' => array(), '_method'  => '') as $var => $default) {
            $newvar = 'in_' . str_replace('_', '', $var);
            $this->$newvar = isset($GLOBALS[$var]) ? $GLOBALS[$var] : $default;
        }

        $this->in_cnd = is_array($this->in_cnd) ? $this->in_cnd : array();

        foreach($this->in_cnd as $key=>$var) {
            unset($this->in_cnd[$key]);
            $this->in_cnd[strtolower($key)] = $var;
        }

        $__path = explode('/', $this->in_path);
        $this->in_path_idname = isset($__path[1]) ? trim($__path[1]) : null;

        $in_cond_default = array(
            'name' => '',
            'category' => '',
            'limit' => array(null,null),
            'orderby' => array(null,null),
        );
        $this->in_cnd = func_array_merge($in_cond_default, $this->in_cnd);

        if (
            !$this->in_model
            && $this->getHttpMethod() == 'PUT'
        ) {
            if ($this->in_model = file_get_contents("php://input")) {
                $this->in_model = func_addslashes(json_decode($this->in_model, true));
            }
        }

        return true;
	}//}}}

	public function keysAreCorrect()
	{//{{{
        global $config;

        if (
            !$this->in_key
            || (
                $this->in_key !== $config['Google_Ads_Kliken']['google_adskliken_restkey_write']
                && $this->in_key !== $config['Google_Ads_Kliken']['google_adskliken_restkey_read']
            )
        ) {
            return false;
        }

        if ($this->getHttpMethod() !== 'GET' && $this->in_key !== $config['Google_Ads_Kliken']['google_adskliken_restkey_write']) {
            return false;
        }

        return true;
	}//}}}

	public function echo403DueToWrongKeys()
	{//{{{
        header("HTTP/1.1 403 Forbidden");
        echo 'wrong key or read-only key is used for non GET operation';
        exit;
	}//}}}

	public function methodExists($map)
	{//{{{
        $http_method = $this->getHttpMethod();
        $__path = explode('/',$this->in_path);
        if (!isset($__path[1])) {
            $search_key = $this->in_path . '@' . $http_method;
        } else {
            $_id = $__path[1] === '0' || $__path[1] === 0 ? $__path[1] : '{id}';
            $search_key = $__path[0] . "/$_id" . '@' . $http_method;
        }
        return isset($map[$search_key]) ? $map[$search_key] : false;
	}//}}}

	public function callMethod($_metod_name)
	{//{{{
        $this->$_metod_name();
        return true;
	}//}}}

	public function notImplemented()
	{//{{{
        header("HTTP/1.1 405 Method Not Allowed");
        echo 'notImplemented';
        return true;
	}//}}}

	protected static function tryToResolveAlias($_key_value, $map)
	{//{{{
        $map_aliases = static::$$map;
        if (isset($map_aliases[strtolower(stripslashes($_key_value))])) {
            return $map_aliases[strtolower(stripslashes($_key_value))];
        }

        return $_key_value;
	}//}}}

	protected function getHttpMethod()
	{//{{{
        $possible_methods = array('GET','POST','DELETE','PUT');
        if (in_array(strtoupper($this->in_method), $possible_methods)) {
            return strtoupper($this->in_method);
        } elseif (!empty($_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE']) && in_array(strtoupper($_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE']), $possible_methods)) {
            return strtoupper($_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE']);
        }

        return strtoupper($_SERVER['REQUEST_METHOD']);
	}//}}}

	protected function outputData($data, $count = null)
	{//{{{
        header('Content-Type: application/json; charset=utf-8');
        if (isset($count)) {
            header('X-Result-Count: ' . $count);
        }
        $converted_data = json_encode($data);
        header('Content-Length: ' . strlen($converted_data));

        echo $converted_data;
	}//}}}

	protected function getLimitOrderBy()
	{//{{{
        if (isset($this->in_cnd['orderby'][0])) {
            $_orderby = $this->in_cnd['orderby'];
            $_orderby_str = ' ORDER BY ' . (is_array($_orderby) && isset($_orderby[0]) ? ($_orderby[0] . ' ') : ' ') . (isset($_orderby[1]) ? ($_orderby[1] . ' ') : ' ');
        } else {
            $_orderby_str = '';
        }

        if (isset($this->in_cnd['limit'][1])) {
            $_limit = $this->in_cnd['limit'];
            $_limit_str = ' LIMIT ' . (!empty($_limit[0]) ? (intval($_limit[0]) . ',') : '') . intval($_limit[1]);
        } else {
            $_limit_str = '';
        }

        return array($_orderby_str, $_limit_str);
	}//}}}
}

class Config {
    const OUTPUT_FORMAT = 'array_of_array';
    public static function getShopCurrency()
    {//{{{
        global $sql_tbl, $active_modules, $config;

        if (
            !empty($active_modules['XMultiCurrency'])
            && ($_default_cur = func_query_first_cell("SELECT c.code_int FROM $sql_tbl[mc_currencies] mc INNER JOIN $sql_tbl[currencies] c ON c.code=mc.code WHERE mc.is_default=1"))
        ) {
            ;//Do Nothing
        } else {
            $_default_cur = func_query_first_cell("SELECT code_int FROM $sql_tbl[currencies] WHERE code='{$config['Google_Ads_Kliken']['google_adskliken_shop_currency']}'");
        }

        if (static::OUTPUT_FORMAT == 'array_of_array') {
            return func_query_first("SELECT name AS 'config_id','shop_currency' AS name,category,type,orderby,'$_default_cur' AS value FROM $sql_tbl[config] WHERE name='google_adskliken_shop_currency'");
        }
    }//}}}

    public static function getDimUnit()
    {//{{{
        global $config;
        $res = array(
            'config_id' => 'dim_unit',
            'name' => 'dim_unit',
            'category' => '',
            'type' => '',
            'orderby' => '',
            'value' => $config['General']['dimensions_symbol'],
        );

        $number_of_centimeters_in_the_unit = $config['General']['dimensions_symbol_cm'];

        $units = array('cm', 'dm', 'in', 'm', 'mm');

        foreach($units as $try_unit) {
            $convert_value = func_units_convert($number_of_centimeters_in_the_unit, 'cm', $try_unit, 20);

            if (abs(1 - $convert_value) < 0.000001) {
                $res['value'] = $try_unit;
                break;
            }
        }

        if (static::OUTPUT_FORMAT == 'array_of_array') {
            return $res;
        }
    }//}}}

    public static function getWeightUnit()
    {//{{{
        global $config;
        $res = array(
            'config_id' => 'weight_unit',
            'name' => 'weight_unit',
            'category' => '',
            'type' => '',
            'orderby' => '',
            'value' => $config['General']['weight_symbol'],
        );

        $number_of_gramms_in_the_unit = $config['General']['weight_symbol_grams'];

        $units = array( 'g', 'kg', 'lbs', 'oz', );

        foreach($units as $try_unit) {
            $convert_value = func_units_convert($number_of_gramms_in_the_unit, 'g', $try_unit, 20);

            if (abs(1 - $convert_value) < 0.000001) {
                $res['value'] = $try_unit;
                break;
            }
        }

        if (static::OUTPUT_FORMAT == 'array_of_array') {
            return $res;
        }
    }//}}}

    public static function getTaxableBase()
    {//{{{
        global $sql_tbl;

        $base = func_query_column("SELECT IF(tr.formula != '',tr.formula,t.formula) AS formula FROM $sql_tbl[taxes] t INNER JOIN $sql_tbl[tax_rates] tr USING(taxid) WHERE t.active='Y'") ?: array();
        $base = array_filter($base, function($k) {return preg_match('/ST|PS|SH|DST/', $k);}) ?: array();# nolint

        if (static::OUTPUT_FORMAT == 'array_of_array') {
            return array(
                'config_id' => 'taxableBase',
                'name' => 'taxableBase',
                'category' => '',
                'type' => '',
                'orderby' => '',
                'value' => implode(',',$base),
            );
        }
    }//}}}

    public static function getAddressType()
    {//{{{
        global $sql_tbl;

        $base = func_query_column("SELECT IF(t.address_type='B','billing','shipping') AS addressType FROM $sql_tbl[taxes] t INNER JOIN $sql_tbl[tax_rates] tr USING(taxid) WHERE t.active='Y'");

        if (static::OUTPUT_FORMAT == 'array_of_array') {
            return array(
                'config_id' => 'addressType',
                'name' => 'addressType',
                'category' => '',
                'type' => '',
                'orderby' => '',
                'value' => implode(',',$base),
            );
        }
    }//}}}

    public static function changeToStateId($data)
    {//{{{
        global $sql_tbl;

        if (is_array($data) && isset($data[0])) {
            foreach($data as $k => $_config_row) {
                $data[$k]['value'] = func_query_first_cell("SELECT stateid FROM $sql_tbl[states] WHERE code='$_config_row[value]'") ?: $_config_row['value'];
            }
        } elseif (isset($data['value'])) {
            $data['value'] = func_query_first_cell("SELECT stateid FROM $sql_tbl[states] WHERE code='$data[value]'") ?: $data['value'];
        } elseif (is_scalar($data)) {
            $data = func_query_first_cell("SELECT stateid FROM $sql_tbl[states] WHERE code='$data'") ?: $data;
        }

        return $data;
    }//}}}

    public static function changeLongDayNameToShort($data)
    {//{{{
        return str_replace(array('Monday','Sunday'), array('mon','sun'), $data);
    }//}}}

    public static function changeCheckoutModuleName($data)
    {//{{{
        return str_replace(array('Fast_Lane_Checkout','One_Page_Checkout'), array('fast-lane','one-page'), $data);
    }//}}}
}

class ConfigCategoryAddition {

    public static function getCdev_salestax($in_orderby_str)
    {//{{{
        $xc5_names = array('addresstype','taxablebase');

        return static::getData('CDev\\SalesTax', $xc5_names, $in_orderby_str);
    }//}}}

    public static function getUnits($in_orderby_str)
    {//{{{
        $xc5_names = array('weight_unit','weight_symbol','dim_unit','date_format','time_format',
        'weight_trailing_zeroes','weight_format','dim_symbol','week_start','time_zone','csv_delim','export_import_charset','export_product_attrs');

        return static::getData('Units', $xc5_names, $in_orderby_str);
    }//}}}

    public static function getGeneral($in_orderby_str)
    {//{{{
        $xc5_names = array("allow_membership_request","cart_ttl","checkout_type","customer_presentation","default_admin_language","default_language","default_prod_display_mode","default_products_sort_order","default_purchase_limit","default_search_sort_order","display_check_number","enable_add2cart_button_grid","force_choose_product_options","force_login_before_checkout","internal_cron_enabled","login_lifetime","maximal_order_amount","minimal_order_amount","order_number_counter","products_per_page_admin","products_per_page","products_per_page_max","redirect_to_cart","requires_shipping_default","shop_currency","show_out_of_stock_products","subcategories_look","terms_url","time_zone","trailing_zeroes","users_per_page");

        return static::getData('General', $xc5_names, $in_orderby_str);
    }//}}}

    public static function getCompany($in_orderby_str)
    {//{{{
        $xc5_names = array('company_address','company_contacts','company_fax','company_identity','company_name','company_phone','company_website','contact_us_comment','deliverability_check','location_address','location_city','location_country','location_custom_state','location_state','location_zipcode','orders_department','origin_address','origin_city','origin_country','origin_custom_state','origin_state','origin_use_company','origin_zipcode','site_administrator','start_year','support_department','users_department');

        return static::getData('Company', $xc5_names, $in_orderby_str);
    }//}}}

    protected static function getData($in_category, $in_xc5_names, $in_orderby_str)
    {//{{{
        global $sql_tbl;

        // Main Select Try To Find The Same Names
        $xc4_names_from_alias = (array_values(array_intersect_key(PathDispatcher::$configNameAliases, array_flip($in_xc5_names))));
        $_data = func_query("SELECT name AS 'config_id', name, '$in_category' AS category, type, orderby, value, null AS 'widgetParameters' FROM $sql_tbl[config] WHERE name IN ('".implode("','", array_merge($in_xc5_names, $xc4_names_from_alias))."') $in_orderby_str") ?: array();

        // Rename Back Xc4 Names To Xc5 Names
        $xc4_xc5_aliases = array_flip(PathDispatcher::$configNameAliases);
        foreach ($_data as $k=>$_config) {
            foreach ($xc4_names_from_alias as $xc4_alias) {
                if ($xc5_name = array_search($_config['name'], PathDispatcher::$configNameAliases)) {
                    $_data[$k]['config_id'] = $_data[$k]['name'] = $xc5_name;
                    break;
                }
            }

            // Apply Post Filter. Must Be After The Above Cycle
            foreach (array_intersect_key(array_flip($in_xc5_names), PathDispatcher::$configNamePostFilters) as $implemented_key => $tmp) {
                if ($implemented_key == $_data[$k]['name']) {
                    $_data[$k]['value'] = call_user_func_array(array(__NAMESPACE__ . '\\Config', PathDispatcher::$configNamePostFilters[$implemented_key]), array($_data[$k]['value']));
                }
            }

        }

        // Add Values From Classes
        foreach (array_intersect_key(array_flip($in_xc5_names), PathDispatcher::$configNameGetters) as $implemented_key => $tmp) {
            $conf_data = call_user_func_array(array(__NAMESPACE__ . '\\Config', PathDispatcher::$configNameGetters[$implemented_key]), array());
            if (empty($conf_data)) {
                continue;
            }
            $conf_data['category'] = $in_category;
            $conf_data['widgetParameters'] = null;
            $_data = array_merge($_data, array($conf_data));
        }

        return $_data;
    }//}}}
}
