<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Configuration options processing.
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    709ca6dd92799e0f3bd05cc3c5c212bd283ed8e6, v1 (xcart_4_7_12), 2020-02-06 20:05:09, admin_config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */
namespace XC\GoogleAdsKliken;

if ( !defined('XCART_START') ) { header("Location: ../"); die("Access denied"); }


if ($REQUEST_METHOD == 'GET' && $option == 'Google_Ads_Kliken') {

    if (
        !empty($active_modules['XMultiCurrency'])
        && ($_default_cur = func_query_first_cell("SELECT code FROM $sql_tbl[mc_currencies] WHERE is_default=1"))
    ) {
        $configuration['google_adskliken_shop_currency']['value'] = $_default_cur;
        $configuration['google_adskliken_shop_currency']['comment'] = 'Shop currency, synchronize with <a href="currencies.php" target="_blank">Primary currency</a>';
    } else {
        $configuration['google_adskliken_shop_currency']['comment'] = 'Shop currency, synchronize with <a href="configuration.php?option=General#tr_currency_symbol" target="_blank">Primary currency symbol</a>';
    }

    x_session_register('kliken_signin_token');
    if (empty($maid) || empty($appt) || empty($t) || $t !== $kliken_signin_token) {
        Tabs::generateData();

    } elseif (CallbackHandler::saveKlikenTokens_n_sendRestKeys($maid, $appt)) {
        x_session_unregister('kliken_signin_token');
        func_header_location(Tools::BASE_KLIKEN_URL . '/smb');
    } else {
        // Some Errors Was In The Above FunCtion
        func_header_location( (!empty($xcart_catalogs['admin']) ? $xcart_catalogs['admin'] : "$current_location/admin") . '/configuration.php?option=Google_Ads_Kliken' );
    }
}

if (!is_callable('random_int')) {
    require_once $xcart_dir . XC_DS . 'modules/Google_Ads_Kliken/lib/paragonie/random_compat/lib/random.php';
}

class Tabs {
    public static function generateData()
    {//{{{
        global $sql_tbl, $smarty, $xcart_dir, $config;

        $googleadsk_integration_type_tabs = array();
        // admin

        if (empty($config['Google_Ads_Kliken']['google_adskliken_account_id']) || empty($config['Google_Ads_Kliken']['google_adskliken_account_token'])) {
            $googleadsk_integration_type_tabs[] = static::generateGetStartedTab();
        } else {
            $googleadsk_integration_type_tabs[] = array(
                'title' => 'Manage Campaigns',
                'tpl' => 'modules/Google_Ads_Kliken/backend/manage_campaigns.tpl',
                'anchor' => 'getstarted',
            );
        }

        $googleadsk_integration_type_tabs[] = array(
            'title' => func_get_langvar_by_name('lbl_settings'),
            'tpl' => 'modules/Google_Ads_Kliken/backend/setting_tab.tpl',
            'anchor' => 'settings',
        );

        // General part
        $smarty->assign('integration_type_tabs', $googleadsk_integration_type_tabs);
        $smarty->assign('custom_admin_module_config_tpl_file', 'modules/Google_Ads_Kliken/backend/configuration.tpl');
    }//}}}

    protected static function generateGetStartedTab()
    {//{{{
        global $smarty;
        $smarty->assign('kliken_signUpLink', Tools::getGetSignUpLink());

        return array(
            'title' => 'Get Started',
            'tpl' => 'modules/Google_Ads_Kliken/backend/getstarted.tpl',
            'anchor' => 'getstarted',
        );
    }//}}}

    public static function generateGetStartedTab2()
    {//{{{
    }//}}}
}

class Tools {
    const BASE_KLIKEN_URL = 'https://x-cart.kliken.com';

    public static function getGetSignUpLink()
    {//{{{
        global $logged_userid, $current_location, $kliken_signin_token, $xcart_catalogs;

        // Get User info
        $userinfo = func_userinfo($logged_userid);

        // Generate a session Token for the bounce back data
        x_session_register('kliken_signin_token');
        if (empty($kliken_signin_token)) {
            $kliken_signin_token = self::generateKey();
        }

        return sprintf(
            self::BASE_KLIKEN_URL . '/auth/xcart/?u=%s&n=%s&e=%s&t=%s&return=%s',
            rawurlencode($current_location),
            rawurlencode($userinfo['firstname']." ".$userinfo['lastname']),
            rawurlencode($userinfo['email']),
            $kliken_signin_token,
            rawurlencode( (!empty($xcart_catalogs['admin']) ? $xcart_catalogs['admin'] : "$current_location/admin") . '/configuration.php?option=Google_Ads_Kliken')
        );
    }//}}}

    public static function generateKey($length = 32, $keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ')
    {//{{{
        if (function_exists('func_get_secure_random_key')) {
            return func_get_secure_random_key($length, 'user_password');
        }

        if (function_exists('random_int')) {
            $pieces = array();
            $max = mb_strlen($keyspace, '8bit') - 1;

            for ($i = 0; $i < $length; ++$i) {
                $pieces[] = $keyspace[random_int(0, $max)];
            }

            return implode('', $pieces);
        }

        return md5(uniqid(rand(), true));
    }//}}}
}

class CallbackHandler {
    public static function saveKlikenTokens_n_sendRestKeys($account_id, $application_token)
    {//{{{
        global $config;

        if (empty($account_id) || empty($application_token)) {
            return false;
        }
        func_array2update('config', array('value' => $account_id), "name = 'google_adskliken_account_id'");
        func_array2update('config', array('value' => $application_token), "name = 'google_adskliken_account_token'");
        $config['Google_Ads_Kliken']['google_adskliken_account_id'] = $account_id;
        $config['Google_Ads_Kliken']['google_adskliken_account_token'] = $application_token;

        if (static::postBackApiKeys()) {
            return true;
        } else {
            //TODO clear the above keys?
            return false;
        }
    }//}}}

    protected static function postBackApiKeys()
    {//{{{
        global $config, $current_location, $top_message;

        // Check if RESTAPI module has the keys saved or not
        $restKeyWrite = $config['Google_Ads_Kliken']['google_adskliken_restkey_write'];
        $restKeyRead = $config['Google_Ads_Kliken']['google_adskliken_restkey_read'];

        if (empty($restKeyWrite)) {
            $restKeyWrite = Tools::generateKey();
            x_log_add('google-ads-kliken', 'REST API Write Key generated!');
            func_array2update('config', array('value' => $restKeyWrite), "name = 'google_adskliken_restkey_write'");
        }

        if (empty($restKeyRead)) {
            $restKeyRead = Tools::generateKey();

            x_log_add('google-ads-kliken', 'REST API Read Key generated! ');
            func_array2update('config', array('value' => $restKeyRead), "name = 'google_adskliken_restkey_read'");
        }

        // Send back to our Webhook the store URL, and the REST API keys. ONLY if we have account id and app Token.
        $accountId = $config['Google_Ads_Kliken']['google_adskliken_account_id'];
        $appToken = $config['Google_Ads_Kliken']['google_adskliken_account_token'];

        if (!empty($accountId) && !empty($appToken)) {
            x_load('http');

            $hookUrl = 'https://app.mysite-analytics.com/WebHooks/XCartAuth/';

            $body = json_encode(array(
                'account_id'     => $accountId,
                'app_token'      => $appToken,
                'store_url'      => $current_location,
                'rest_key_write' => $restKeyWrite,
                'rest_key_read'  => $restKeyRead,
            ));
            list($a, $response) = func_https_request('POST', $hookUrl, $body, '', '', 'application/json', '', '', '');

            x_log_add('google-ads-kliken', 'POSTing to WW at: ' . $hookUrl . "response\n" . print_r($a, true) . print_r($response, true));

            if ($response === '0' || !preg_match("/HTTP\/.*\s*200\s*OK/i", $a)) {
                x_session_register('top_message');
                $top_message = array(
                    'type' => 'W',
                    'content' => 'Module Kliken\GoogleAds was unable to access your store\'s catalog . Please make sure the correct Account Id and Application Token are saved, or contact Kliken for support.',
                );

                return false;
            }

            return true;
        }

        return false;
    }//}}}
}
