<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Common functions for Google Ads by Kliken Module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    313870cce4c0ce7e9e1ca356584e7ba0c011bd83, v2 (xcart_4_7_12), 2020-03-04 21:04:49, classes.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

namespace XC\GoogleAdsKlikenBackend;

if ( !defined('XCART_SESSION_START') ) { header('Location: ../../'); die('Access denied'); }

class ProductUpdateDate {
    public static function onDelete($params = array(), $result = array())
    {//{{{
        global $sql_tbl;

        if (!is_array($params['productid'])) {
            $pids = array($params['productid']);
        } else {
            $pids = $params['productid'];
        }

        if (empty($pids)) {
            db_query("TRUNCATE TABLE $sql_tbl[gak_product_update_times]");
        } else {
            db_query("DELETE FROM $sql_tbl[gak_product_update_times] WHERE productid IN ('".implode("', '", $pids)."')");
        }

        return $result;
    }//}}}

    public static function onUpdate($params = array(), $result = array())
    {//{{{
        global $sql_tbl;
        static $already_done = array();

        if (empty($params['productid'])) {
            return $result;
        }

        if (!is_array($params['productid'])) {
            $pids = array($params['productid']);
        } else {
            $pids = $params['productid'];
        }

        if (!empty($params['geids'])) {
            if (!is_array($params['geids'])) {
                $_geids = array($params['geids']);
            } else {
                $_geids = $params['geids'];
            }
        } else {
            $_geids = array();
        }

        if (
            empty($params['mode'])
            || !in_array($params['mode'], array('clean_urls_history','links','delete','clone','details','product_class_modify','product_class_assign','upselling_links','del_upsale_link','review_modify','acr_reviews','delete_reviews','acr_update_reviews','update_reviews','review_delete','bongo_update','pconf','product_zoomer', 'product_feeds_modify','update_classification'))
        ) {
            foreach ($pids as $pid) {
                if (isset($already_done[$pid])) {
                    continue;
                }

                db_query("REPLACE INTO $sql_tbl[gak_product_update_times] VALUES ('$pid', '" . XC_TIME . "')");
                $already_done[$pid] = 1;
            }

            foreach ($_geids as $_geid) {
                if (empty($_geid)) {
                    continue;
                }
                db_query("REPLACE INTO $sql_tbl[gak_product_update_times] SELECT productid, '" . XC_TIME . "' FROM $sql_tbl[ge_products] WHERE geid = '$_geid'");
            }
        }

        return $result;

    }//}}}

    public static function onPostponedInsert($params = array(), $result = array())
    {//{{{
        global $sql_tbl;

        if (empty($_GET['productid']) || empty($params['is_new'])) {
            return $result;
        }
        return static::onUpdate(array('productid' => $_GET['productid']), $result);
    }//}}}

    public static function onProductListUpdate($posted_data = array(), $result = array())
    {//{{{
        if (empty($posted_data)) {
            return $result;
        }
        return static::onUpdate(array('productid' => array_keys($posted_data)), $result);
    }//}}}

    public static function onImportCompleteProducts($section = '')
    {//{{{
        global $sql_tbl, $logged_userid;

        db_query("REPLACE INTO $sql_tbl[gak_product_update_times] SELECT id, '" . XC_TIME . "' FROM $sql_tbl[import_cache] WHERE userid = '$logged_userid' AND data_type='Prp'");//func_import_get_cache('Prp', $_productid, $_productid); nolint
    }//}}}

    public static function onImportCompleteProductDetails($section = '')
    {//{{{
        global $sql_tbl, $logged_userid;
        static $done = false;

        if ($done) {
            return true;
        }
        $done = true;

        db_query("REPLACE INTO $sql_tbl[gak_product_update_times]
                      SELECT    id, '" . XC_TIME . "' FROM $sql_tbl[import_cache] WHERE userid = '$logged_userid' AND data_type='PI'
            UNION ALL SELECT value, '" . XC_TIME . "' FROM $sql_tbl[import_cache] WHERE userid = '$logged_userid' AND data_type='PR' AND value!='RESERVED'
            UNION ALL SELECT value, '" . XC_TIME . "' FROM $sql_tbl[import_cache] WHERE userid = '$logged_userid' AND data_type='PN' AND value!='RESERVED'
        ");// func_import_get_cache('PI', $values['productid']); func_import_get_cache('PR', $values['productcode']); func_import_get_cache('PN', $values['product']); nolint

    }//}}}

    public static function onExtraFieldsValuesDelete($field_ids = array(), $result = array())
    {//{{{
        global $sql_tbl;
        db_query("DELETE FROM $sql_tbl[gak_product_update_times] WHERE productid IN (SELECT productid FROM $sql_tbl[extra_field_values] WHERE fieldid IN ('".implode("','", $field_ids)."'))");
        return $result;
    }//}}}

    public static function updateModules($module_name)
    {//{{{
        global $sql_tbl;

        if (in_array($module_name, array('Product_Options', 'Extra_Fields', 'Detailed_Product_Images', 'Manufacturers', 'Google_Ads_Kliken'))) {
            db_query("TRUNCATE TABLE $sql_tbl[gak_product_update_times]");
            db_query("REPLACE INTO $sql_tbl[gak_product_update_times] SELECT productid, '" . XC_TIME . "' FROM $sql_tbl[products]");
        }

    }//}}}
}
