<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    108b66d4a1516cb3fa5b36f93bf695f6dee9de1e, v5 (xcart_4_7_12), 2020-03-10 18:05:51, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }

global $config, $XCART_SESSION_NAME, $xcart_dir, $sql_tbl, $CLIENT_IP, $smarty;
$addons['Google_Ads_Kliken'] = true;

$css_files['Google_Ads_Kliken'][] = array();
$css_files['Google_Ads_Kliken'][] = array('admin' => true);

$sql_tbl['gak_product_update_times'] = XC_TBL_PREFIX . 'gak_product_update_times';//Compatible

define('XC_GOOGLE_ADSKLIKEN_WITH_NEW_PATCHER', '4.7.12');

if (!empty($include_func) || !empty($include_init)) {
    func_google_adskliken_init();
}

/*
* Functions definitions to load module
*/
function func_google_adskliken_init()
{//{{{
    global $config, $sql_tbl, $REQUEST_METHOD, $mode, $PHP_SELF, $smarty;

    if (
        (defined('AREA_TYPE') && AREA_TYPE == 'C')
        || basename($PHP_SELF) == 'check_tpl_syntax.php'
    ) {
        spl_autoload_register('func_google_adskliken_frontend_autoloader');
        if (!empty($smarty)) {
            $smarty->registerPlugin('function', 'func_kliken_tpl_get_product_category', array('\XC\GoogleAdsKliken\tplOrderMessage', 'getProductCategory'));
        }

        if (version_compare($config['version'], '4.7.0') >= 0) {
            // Smarty_prefilter_add_google_adskliken_entry_points is called here
            $smarty->addAutoloadFilters(array('add_google_adskliken_entry_points'), 'pre');
        } else {
            // For Old Versions
            Smarty_prefilter_add_google_adskliken_entry_points('', null);
        }

    } else {
        // Backend Handlers
        spl_autoload_register('func_google_adskliken_backend_autoloader');
        func_add_event_listener('evt-products-delete4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onDelete');
        func_add_event_listener('evt-product-ajax-images-modify4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onUpdate');
        func_add_event_listener('evt-extra_fields-extra_field_values-delete4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onExtraFieldsValuesDelete');

        /* Postponed: MUST NOT be under page condition as the can be launched on anther page. */
        if (defined('ADMIN_MODULES_CONTROLLER') || func_postponed_events_storage()) {//Compatible
            func_add_event_listener('Postponed:module.enable', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::updateModules');//Compatible
            func_add_event_listener('Postponed:module.disable', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::updateModules');//Compatible
        }

        if (defined('IS_IMPORT')) {
            func_add_event_listener('evt-import-complete-complex4712-DETAILED_IMAGES', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');
            func_add_event_listener('evt-import-complete-complex4712-MULTILANGUAGE_PRODUCTS', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');
            func_add_event_listener('evt-import-complete-complex4712-PRODUCTS_EXTRA_FIELD_VALUES', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');
            func_add_event_listener('evt-import-complete-complex4712-PRODUCT_OPTIONS', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');
            func_add_event_listener('evt-import-complete-complex4712-PRODUCT_VARIANTS', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');
            func_add_event_listener('evt-import-complete-simple4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProductDetails');

            func_add_event_listener('evt-import-complete-complex4712-PRODUCTS', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onImportCompleteProducts');
        } else {
            //Don'T Listen The Event During Import-Export in favor far faster onImportCompleteProductDetails
            func_add_event_listener('evt-products-list-update4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onProductListUpdate');
            func_add_event_listener('evt-products-inventory-update4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onUpdate');

            if (basename($PHP_SELF) == 'product_modify.php') {
                func_add_event_listener('evt-product-details-modify4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onUpdate');
                func_add_event_listener('Postponed:evt-product-details-modify4712', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onPostponedInsert');
            } else {
                // Do Not Duplicate Event For Product_modify
                func_add_event_listener('products.lng.update', '\XC\GoogleAdsKlikenBackend\ProductUpdateDate::onUpdate'); // For Product Clone / Can be used From 477
            }
        }

    }

    return false;
}//}}}

function func_google_adskliken_backend_autoloader($class_name)
{//{{{
    global $xcart_dir;
    static $call_include_counter = 0;

    $match_array = array(
        'XC\GoogleAdsKlikenBackend\\' => 'modules/Google_Ads_Kliken/backend/classes.php',
    );

    foreach($match_array as $class_pattern => $file) {
        if (strpos($class_name, $class_pattern) !== false) {
            include $xcart_dir . XC_DS . $file;
            $call_include_counter++;
            break;
        }
    }

    if ($call_include_counter >= count($match_array)) {
        spl_autoload_unregister(__FUNCTION__);
        return;
    }
}// FUnc_google_adskliken_backend_autoloader}}}

function func_google_adskliken_frontend_autoloader($class_name)
{//{{{
    global $xcart_dir;
    static $call_include_counter = 0;

    $match_array = array(
        'XC\GoogleAdsKliken\\' => 'modules/Google_Ads_Kliken/frontend/classes.php',
    );

    foreach($match_array as $class_pattern => $file) {
        if (strpos($class_name, $class_pattern) !== false) {
            require_once $xcart_dir . XC_DS . $file;
            $call_include_counter++;
            break;
        }
    }

    if ($call_include_counter >= count($match_array)) {
        spl_autoload_unregister(__FUNCTION__);
        return;
    }
}//FUnc_google_adskliken_frOnend_autoloader}}}

/**
 * Used On The Setting Page
 */
function func_google_adskliken_get_currencies()
{//{{{
    global $sql_tbl;

    return func_query_hash("SELECT code, CONCAT(name, ' (', code, ')') FROM $sql_tbl[currencies] ORDER BY name", 'code', false, true);
}//}}}

/*
* dynamically add module patches to customer tpls
*/
function Smarty_prefilter_add_google_adskliken_entry_points($source, $smarty)
{//{{{
    global $xcart_dir, $config;
    static $is_called ;

    if (!empty($is_called)) {
        return $source;
    }
    $is_called = 1;

    if (version_compare($config['version'], XC_GOOGLE_ADSKLIKEN_WITH_NEW_PATCHER) >= 0) {
        require_once $xcart_dir . XC_DS . 'include' . XC_DS . 'lib' . XC_DS . 'dynamic_tpl_patcher.php';

        x_tpl_prefilter_append_to_file('customer/service_js.tpl', array('file' => 'skin/common_files/modules/Google_Ads_Kliken/frontend/service_js.tpl', 'module_name' => 'Google_Ads_Kliken','skip_conditions' => true));
        x_tpl_prefilter_append_to_file('customer/service_body_js.tpl', array('file' => 'skin/common_files/modules/Google_Ads_Kliken/frontend/service_body_js.tpl', 'module_name' => 'Google_Ads_Kliken', 'skip_conditions' => true));
    } else {
        require $xcart_dir . XC_DS . 'modules' . XC_DS . 'Google_Ads_Kliken' . XC_DS . 'lib' . XC_DS . 'dynamic_tpl_patcher.php';//old_version_compatible; conflict with xcart/modules/XAuth/ext.core.php <=4.7.3
        require $xcart_dir . XC_DS . 'modules' . XC_DS . 'Google_Ads_Kliken' . XC_DS . 'tpl_patch_functions.php';
        modules\Google_Ads_Kliken\lib\x_tpl_add_callback_patch('customer/service_js.tpl', 'func_google_adskliken_tpl_patch_service_js', modules\Google_Ads_Kliken\lib\X_TPL_PREFILTER);
        modules\Google_Ads_Kliken\lib\x_tpl_add_callback_patch('customer/service_body_js.tpl', 'func_google_adskliken_tpl_patch_service_body_js', modules\Google_Ads_Kliken\lib\X_TPL_PREFILTER);
    }

    return $source;
}//}}}
