<?php /* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * REST API handler
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    709ca6dd92799e0f3bd05cc3c5c212bd283ed8e6, v1 (xcart_4_7_12), 2020-02-06 20:05:09, rest_api_server.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ..'); die('Access denied'); }
#IN: $_path $_method
require $xcart_dir . '/modules/Google_Ads_Kliken/PathDispatcher.php';

if (!function_exists('getallheaders')) { //{{{
    function getallheaders() {
       $headers = array();
       foreach ($_SERVER as $name => $value)
       {
           if (substr($name, 0, 5) == 'HTTP_')
           {
               $headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
           }
       }
       return $headers;
    }
}//}}}

if (defined('XC_DEBUG_REST_API')) {//{{{
    $_old = $QUERY_STRING;
    $QUERY_STRING = '';
    x_log_add('rest_api_call', print_r(array_diff_key($_GET, array('_key' => 1)), true) . print_r(array_diff_key($_POST, array('_key' => 1)), true) . print_r(array_diff_key(getallheaders(), array('Cookie' => 1)), true));
    $QUERY_STRING = $_old;
}//}}}

$obj_resolver = new \XC\GoogleAdsKliken\REST\PathDispatcher();

$obj_resolver->parseGetPostIntoProperties();

if (!$obj_resolver->keysAreCorrect() && !defined('XC_UNIT_TEST_MODE')) {
    $obj_resolver->echo403DueToWrongKeys();
}

$mapMethods = array(//{{{
    'cdev-salestax-tax@GET' => 'readAllCdevSalestaxTax', // GET: Retrieve tax types
    'cdev-salestax-tax/{id}@GET' => 'readCdevSalestaxTax', // GET: Retrieve tax type by id
    'cdev-salestax-tax/{id}@PUT' => 'updateCdevSalestaxTax', // PUT: Update tax type by id
    'cdev-salestax-tax-rate/0@POST' => 'createCdevSalestaxTaxRate', // POST: Add tax rate
    'cdev-salestax-tax-rate/{id}@DELETE' => 'deleteCdevSalestaxTaxRate', // DELETE: Delete tax rate by id
    'cdev-salestax-tax-rate@GET' => 'readAllCdevSalestaxTaxRate', // GET: Retrieve tax rates by conditions
    'cdev-salestax-tax-rate/{id}@GET' => 'readCdevSalestaxTaxRate', // GET: Retrieve tax rate by id
    'cdev-salestax-tax-rate/{id}@PUT' => 'updateCdevSalestaxTaxRate', // PUT: Update tax rate by id
    'category/0@POST' => 'createCategory', // POST: Add new category
    'category/{id}@DELETE' => 'deleteCategory', // DELETE: Delete category by id
    'category@GET' => 'readAllCategory', // GET: Retrieve categories by conditions
    'category/{id}@GET' => 'readCategory', // GET: Retrieve category by id
    'category/{id}@PUT' => 'updateCategory', // PUT: Update category by id
    'config/0@POST' => 'createConfig', // POST: Add new config entry
    'config/{id}@DELETE' => 'deleteConfig', // DELETE: Delete config entry by id
    'config@GET' => 'readAllConfig', // GET: Retrieve all config entries
    'config/{id}@GET' => 'readConfig', // GET: Retrieve config entry by id
    'config/{id}@PUT' => 'updateConfig', // PUT: Update config entry by id
    'country/0@POST' => 'createCountry', // POST: Add new country
    'country/{id}@DELETE' => 'deleteCountry', // DELETE: Delete country by id
    'country@GET' => 'readAllCountry', // GET: Retrieve countries by conditions
    'country/{id}@GET' => 'readCountry', // GET: Retrieve country by id
    'country/{id}@PUT' => 'updateCountry', // PUT: Update country by id
    'currency/0@POST' => 'createCurrency', // POST: Add new currency
    'currency/{id}@DELETE' => 'deleteCurrency', // DELETE: Delete currency by id
    'currency@GET' => 'readAllCurrency', // GET: Retrieve all currencies
    'currency/{id}@GET' => 'readCurrency', // GET: Retrieve currency by id
    'currency/{id}@PUT' => 'updateCurrency', // PUT: Update currency by id
    'order/0@POST' => 'createOrder', // POST: Add new order
    'order/{id}@DELETE' => 'deleteOrder', // DELETE: Delete order by id
    'order@GET' => 'readAllOrder', // GET: Retrieve orders by conditions
    'order/{id}@GET' => 'readOrder', // GET: Retrieve order by id
    'order/{id}@PUT' => 'updateOrder', // PUT: Update order by id
    'orderhistoryevents/0@POST' => 'createOrderhistoryevents', // POST: Add new order history event
    'orderhistoryevents/{id}@DELETE' => 'deleteOrderhistoryevents', // DELETE: Delete order history event by id
    'orderhistoryevents@GET' => 'readAllOrderhistoryevents', // GET: Retrieve order history events by conditions
    'orderhistoryevents/{id}@GET' => 'readOrderhistoryevents', // GET: Retrieve order history event by id
    'orderhistoryevents/{id}@PUT' => 'updateOrderhistoryevents', // PUT: Update order history event by id
    'orderitem/0@POST' => 'createOrderitem', // POST: Add new order item
    'orderitem/{id}@DELETE' => 'deleteOrderitem', // DELETE: Delete order item by id
    'orderitem@GET' => 'readAllOrderitem', // GET: Retrieve order items by conditions
    'orderitem/{id}@GET' => 'readOrderitem', // GET: Retrieve order item by id
    'orderitem/{id}@PUT' => 'updateOrderitem', // PUT: Update order item by id
    'orderitem-surcharge/0@POST' => 'createOrderitemSurcharge', // POST: Add new order item surcharge
    'orderitem-surcharge/{id}@DELETE' => 'deleteOrderitemSurcharge', // DELETE: Delete order item surcharge by id
    'orderitem-surcharge@GET' => 'readAllOrderitemSurcharge', // GET: Retrieve all order item surcharges
    'orderitem-surcharge/{id}@GET' => 'readOrderitemSurcharge', // GET: Retrieve order item surcharge by id
    'orderitem-surcharge/{id}@PUT' => 'updateOrderitemSurcharge', // PUT: Update order item surcharge by id
    'product/0@POST' => 'createProduct', // POST: Add new product
    'product/{id}@DELETE' => 'deleteProduct', // DELETE: Delete product by id
    'product@GET' => 'readAllProduct', // GET: Retrieve product by conditions
    'product/{id}@GET' => 'readProduct', // GET: Retrieve product by id
    'product/{id}@PUT' => 'updateProduct', // PUT: Update product by id
    'shipping-markup/0@POST' => 'createShippingMarkup', // POST: Add new shipping markup
    'shipping-markup/{id}@DELETE' => 'deleteShippingMarkup', // DELETE: Delete shipping markup by id
    'shipping-markup@GET' => 'readAllShippingMarkup', // GET: Retrieve shipping markups by conditions
    'shipping-markup/{id}@GET' => 'readShippingMarkup', // GET: Retrieve shipping markup by id
    'shipping-markup/{id}@PUT' => 'updateShippingMarkup', // PUT: Update shipping markup by id
    'state/0@POST' => 'createState', // POST: Add new state
    'state/{id}@DELETE' => 'deleteState', // DELETE: Delete state by id
    'state@GET' => 'readAllState', // GET: Retrieve states by conditions
    'state/{id}@GET' => 'readState', // GET: Retrieve state by id
    'state/{id}@PUT' => 'updateState', // PUT: Update state by id
    'zone/0@POST' => 'createZone', // POST: Add new shipping zone
    'zone/{id}@DELETE' => 'deleteZone', // DELETE: Delete shipping zone by id
    'zone@GET' => 'readAllZone', // GET: Retrieve all shipping zones
    'zone/{id}@GET' => 'readZone', // GET: Retrieve shipping zone by id
    'zone/{id}@PUT' => 'updateZone', // PUT: Update shipping zone by id
    'zoneelement/0@POST' => 'createZoneelement', // POST: Add new shipping zone element
    'zoneelement/{id}@DELETE' => 'deleteZoneelement', // DELETE: Delete shipping zone element by id
    'zoneelement@GET' => 'readAllZoneelement', // GET: Retrieve all shipping zone elements
    'zoneelement/{id}@GET' => 'readZoneelement', // GET: Retrieve shipping zone element by id
    'zoneelement/{id}@PUT' => 'updateZoneelement', // PUT: Update shipping zone element by id
);//}}}

if ($mname = $obj_resolver->methodExists($mapMethods)) {
    $obj_resolver->callMethod($mname);
} else {
    $obj_resolver->notImplemented();
}
