<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    d1ff60e234b51037e89d58c77f96f571525bb609, v2 (xcart_4_7_12), 2020-02-28 17:54:22, tpl_patch_functions.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }


function func_google_adskliken_tpl_patch_service_js($tpl_name, $tpl_source)
{//{{{
    global $xcart_dir;

    if (strpos($tpl_source, 'active_modules.Google_Ads_Kliken') !== false) {
        return $tpl_source;
    }
    $content = file_get_contents($xcart_dir . '/skin/common_files/modules/Google_Ads_Kliken/frontend/service_js.tpl');

    // add call {include file="modules/Google_Ads_Kliken/frontend/service_js.tpl #lintoff
    $tpl_source .=<<<EOT
        {* Google_Ads_Kliken hunk start*}
        {if \$active_modules.Google_Ads_Kliken and \$config.Google_Ads_Kliken.google_adskliken_google_token}
            $content
        {/if}
        {* Google_Ads_Kliken hunk end*}
EOT;
    #linton

    func_google_adskliken_tpl_debug($tpl_name, $tpl_source);

    return $tpl_source;
}//}}}

function func_google_adskliken_tpl_patch_service_body_js($tpl_name, $tpl_source)
{//{{{
    global $xcart_dir;

    if (strpos($tpl_source, 'active_modules.Google_Ads_Kliken') !== false) {
        return $tpl_source;
    }

    $content = file_get_contents($xcart_dir . '/skin/common_files/modules/Google_Ads_Kliken/frontend/service_body_js.tpl');

    // add call {include file="modules/Google_Ads_Kliken/frontend/service_body_js.tpl #lintoff
    $snippet =<<<EOT
        {* Google_Ads_Kliken hunk start*}
        {if \$active_modules.Google_Ads_Kliken and \$config.Google_Ads_Kliken.google_adskliken_account_id}
            $content
        {/if}
        {* Google_Ads_Kliken hunk end*}
EOT;

    if (!empty($content)) {
        $tpl_source = $tpl_source . $snippet;
    } #linton

    func_google_adskliken_tpl_debug($tpl_name, $tpl_source);

    return $tpl_source;
}//}}}

function func_google_adskliken_tpl_debug($tpl_name, $tpl_source)
{//{{{
    if (defined('XC_GOOGLE_ADS_KLIKEN_TPL_DEBUG')) {
       x_log_add('google_adskliken_patched_files', 'patched_file:' . $tpl_name . "\n" . $tpl_source);
    }
}//}}}

