<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration script
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7f870d71d44bca60280584a90410f899c35502cc, v1 (xcart_4_7_12), 2020-02-03 17:17:40, admin_config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) { header("Location: ../../"); die("Access denied"); }

if ($option != 'Social_Feeds') {
    return false;
}

if ($REQUEST_METHOD == 'GET') {

    // If API key has been changed refresh account info

    if (!empty($config['socfeeds_flickr_data'])) {
        $flickr_account = unserialize($config['socfeeds_flickr_data']);
    } else {
        $flickr_account = array('api_key' => '');
    }

    if (
        !empty($config['Social_Feeds']['socfeeds_fl_api_key'])
        && $config['Social_Feeds']['socfeeds_fl_api_key'] != $flickr_account['api_key']
        && !empty($config['Social_Feeds']['socfeeds_fl_photoset_id'])
    ) {

        func_flickr_save_account();

    }

    // Complete Instagram Verification And Save Data
    //{{{
    if (!empty($_GET['code'])) {

        $res = func_instagram_get_token($_GET['code']);

        if ($res['code'] != 400) {

            $res['socfeeds_ig_client_id']     = $config['Social_Feeds']['socfeeds_ig_client_id'];
            $res['socfeeds_ig_client_secret'] = $config['Social_Feeds']['socfeeds_ig_client_secret'];

            $file = fopen($xcart_dir . '/skin/common_files/modules/Social_Feeds/images/instagram_profile_logo.png', "w+");
            fputs($file, file_get_contents($res['user']['profile_picture']));
            fclose($file);

            if (!empty($res['access_token'])) {

                db_query("UPDATE $sql_tbl[config] SET value = '" . serialize($res) . "' WHERE name = 'socfeeds_ig_access_token'");

            }

        } else {

            $top_message = array(
               'type'    => 'E',
                'content' => $res['error_message'],
            );

            $smarty->assign('top_message', $top_message);
            $smarty->assign('token_not_valid', 'Y');

        }
    }

    if (!empty($config['Social_Feeds']['socfeeds_ig_client_id'])) {

        $access_token = func_query_first_cell("SELECT value FROM $sql_tbl[config] WHERE name = 'socfeeds_ig_access_token'");

        $access_token = unserialize($access_token);

        if (
            $config['Social_Feeds']['socfeeds_ig_client_id'] != $access_token['socfeeds_ig_client_id']
            || $config['Social_Feeds']['socfeeds_ig_client_secret'] != $access_token['socfeeds_ig_client_secret']
        ) {

            $smarty->assign('display_request_token', 'Y');

        }

    }


    if (function_exists('func_clear_instagram_cache')) {
        func_clear_instagram_cache(true);
    }

    $smarty->assign('social_feed_ig_redirect_uri', $current_location . DIR_ADMIN);
    //}}}
}
