<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module functions
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7f870d71d44bca60280584a90410f899c35502cc, v1 (xcart_4_7_12), 2020-02-03 17:17:40, func.flickr.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */


function func_ajax_block_flickr_feed()
{ //{{{

    global $config, $smarty;

    $images_info = func_flickr_request('getPhotos');

    $smarty->assign('sf_account_info', unserialize($config['socfeeds_flickr_data']));
    $smarty->assign('sf_photoset', $images_info['photoset']);

    $_display_load_more = (count($images_info['photoset']['photo']) == 45) ? 'Y' : 'N';
    $smarty->assign('sf_display_load_more', $_display_load_more);

    $dimensions = array();
    $dimensions = func_sf_assign_dimensions();

    $smarty->assign('flickr_height', $dimensions['height'] - 28);

    if (!empty($_POST['flickr_page'])) {

        return func_display('modules/Social_Feeds/flickr_photos.tpl', $smarty, false);

    } else {

        return func_display('modules/Social_Feeds/flickr.tpl', $smarty, false);

    }

} //}}}

function func_flickr_request($method)
{ //{{{
    global $smarty;

    func_register_cache_function(
        'func_flickr_request',
        array (
            'dir'   => 'flickr_request_cache',
            'ttl'   => SECONDS_PER_DAY,
        )
    );

    $postData = array();

    $params_func = 'func_flickr_' . $method;

    foreach ($params_func() as $k => $v) {
        $postData[] = "$k=$v";
    }

    $save_result_in_cache = true;

    $md5_args = $method . md5(serialize($postData));

    if (($data = func_get_cache_func($md5_args, 'func_flickr_request'))) {
        return $data['data'];
    }

    x_load('http');
    list($header, $result) = func_https_request('POST', 'https://api.flickr.com/services/rest/', implode('&', $postData));

    $result = unserialize($result);

    if ($result['stat'] == 'fail') {

        $top_message = array(
            'type'    => 'E',
            'content' => $result['message'],
        );

        $smarty->assign('top_message', $top_message);
        $save_result_in_cache = false;
    }

    if (isset($result['photoset']['photo'])) {

        foreach($result['photoset']['photo'] as $k => $photo) {
          $result['photoset']['photo'][$k]['url_sq'] = preg_replace('/^http:/','', $photo['url_sq']);
        }

    }

    if ($save_result_in_cache) {
        $res = func_save_cache_func($result, $md5_args, 'func_flickr_request');

        if (!$res) {
            func_register_cache_function(
                'func_flickr_request',
                array (
                    'dir'   => 'flickr_request_cache',
                    'ttl'   => SECONDS_PER_DAY,
                    'force_restore' => true,
                    'force_dir_creation' => true,
                )
            );
        }
    }


    return $result;
} //}}}

function func_flickr_getPhotos()
{ //{{{

    global $config, $smarty;

    $page = !empty($_POST['flickr_page']) ? $_POST['flickr_page'] : 1;

    $smarty->assign('flickr_page', $page + 1);

    return array(
        'api_key'       => $config['Social_Feeds']['socfeeds_fl_api_key'],
        'method'        => 'flickr.photosets.getPhotos',
        'photoset_id'   => $config['Social_Feeds']['socfeeds_fl_photoset_id'],
        'extras'        => 'original_format,url_sq,url_m,date_taken,tags',
        'per_page'      => 45,
        'page'          => $page,
        'format'        => 'php_serial'
    );

} //}}}

function func_flickr_getInfo()
{ //{{{

    global $config;

    $images_info = func_flickr_request('getPhotos');

    return array (
        'api_key'   => $config['Social_Feeds']['socfeeds_fl_api_key'],
        'method'    => 'flickr.people.getInfo',
        'user_id'   => $images_info['photoset']['owner'],
        'format'    => 'php_serial'
    );

} //}}}

function func_flickr_save_account()
{ //{{{

    global $config, $sql_tbl, $top_message, $smarty;

    $_flickr_account = func_flickr_request('getInfo');

    if ($_flickr_account['stat'] == 'fail') {

        $data = array(
            'API_error' => 'Y',
            'error_message' => $_flickr_account['message'],
        );

        db_query("UPDATE $sql_tbl[config] set value = '" . serialize($data) . "' WHERE name = 'socfeeds_flickr_data'");

        return false;

    }

    $_flickr_account = $_flickr_account['person'];

    $data = array(
        'api_key'       => $config['Social_Feeds']['socfeeds_fl_api_key'],
        'username'      => $_flickr_account['username']['_content'],
        'id'            => $_flickr_account['id'],
        'iconfarm'      => $_flickr_account['iconfarm'],
        'iconserver'    => $_flickr_account['iconserver'],
        'nsid'          => $_flickr_account['nsid'],
        'profileurl'    => $_flickr_account['profileurl']['_content'],
        'photosurl'     => $_flickr_account['photosurl']['_content'],
        'icon_url'      => 'farm' . $_flickr_account['iconfarm'] . '.staticflickr.com/' . $_flickr_account['iconserver'] . '/buddyicons/' . $_flickr_account['nsid'] . '.jpg',
        'account_url'   => 'www.flickr.com/photos/' . $_flickr_account['username']['_content']
    );

    db_query("UPDATE $sql_tbl[config] set value = '" . serialize($data) . "' WHERE name = 'socfeeds_flickr_data'");

    return true;

} //}}}
