<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module functions
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7f870d71d44bca60280584a90410f899c35502cc, v1 (xcart_4_7_12), 2020-02-03 17:17:40, func.instagram.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

function func_ajax_block_instagram_feed()
{ //{{{

    global $config, $smarty;

    $smarty->assign('instagram_user', unserialize($config['socfeeds_ig_access_token']));

    $photos = func_instagram_photos();

    $smarty->assign('instagram_photos', $photos['data']);
    $smarty->assign('max_tag_id', $photos['pagination']['next_max_tag_id']);

    $dimensions = array();
    $dimensions = func_sf_assign_dimensions();

    $smarty->assign('instagram_height', $dimensions['height'] - 71);

    if(isset($_POST['max_tag_id']) && !empty($_POST['max_tag_id'])) {

        return func_display('modules/Social_Feeds/instagram_photos.tpl', $smarty, false);

    } else {

        return func_display('modules/Social_Feeds/instagram.tpl', $smarty, false);

    }

} //}}}

function func_instagram_photos()
{ //{{{

    global $sql_tbl;

    func_clear_instagram_cache();

    $max_tag_id = (isset($_POST['max_tag_id']) && !empty($_POST['max_tag_id'])) ? $_POST['max_tag_id'] : '';

    if(func_query_first_cell("SELECT COUNT(*) FROM $sql_tbl[sf_cache] WHERE list_id = '" . $max_tag_id . "' AND expiry < " . XC_TIME) > 0) {

        return func_instagram_cached_photos();

    } else {

        return func_instagram_request_photos();

    }

} //}}}

function func_instagram_get_token($code)
{ //{{{

    global $config, $current_location;

    x_load('http');

    $data = array(
        'client_id'         =>  $config['Social_Feeds']['socfeeds_ig_client_id'],
        'client_secret'     =>  $config['Social_Feeds']['socfeeds_ig_client_secret'],
        'grant_type'        =>  'authorization_code',
        'redirect_uri'      =>  $current_location . DIR_ADMIN . DIRECTORY_SEPARATOR . 'configuration.php?option=Social_Feeds',
        'code'              =>  $code,
    );

    $postData = array();

    foreach ($data as $k => $v) {
        $postData[] = "$k=$v";
    }

    $return = func_https_request('POST', 'https://api.instagram.com/oauth/access_token',  $postData);

    $return = json_decode($return[1], true);

    return $return;

} //}}}

function func_instagram_request_photos()
{ //{{{

    global $config;

    x_load('http');

    $instagram_data = unserialize($config['socfeeds_ig_access_token']);

    if(!empty($_POST['max_tag_id'])) {
        $max_tag_id = '&max_tag_id=' . $_POST['max_tag_id'];
    }

    if(!empty($config['Social_Feeds']['socfeeds_ig_tag'])) {
        $request_url = 'https://api.instagram.com/v1/tags/' . $config['Social_Feeds']['socfeeds_ig_tag'] . '/media/recent?access_token=' . $instagram_data['access_token'] . $max_tag_id;
    }
    else {
        $request_url = 'https://api.instagram.com/v1/users/' . $instagram_data['user']['id'] . '/media/recent/?access_token=' . $instagram_data['access_token'];
    }

    $photos = func_https_request('GET', $request_url);
    $photos = json_decode($photos[1], true);

    foreach($photos['data'] as $k => $photo) {

        $photos['data'][$k]['images']['low_resolution']['url'] = preg_replace('/^http:/', '', $photo['images']['low_resolution']['url']);

    }

    func_instagram_save_to_cache($photos);

    return $photos;

} //}}}

function func_instagram_save_to_cache($photos, $list_id = 0)
{ //{{{

    global $sql_tbl;

    $data = array(
        'list_id'   => $_POST['max_tag_id'],
        'expiry'    => XC_TIME + 3600,
        'data'      => addslashes(serialize($photos)),
        'param1'    => $photos['pagination']['next_max_tag_id']
    );

    func_array2insert('sf_cache', $data, true);

} //}}}

function func_instagram_cached_photos($list_id = 0)
{ //{{{

    global $sql_tbl;

    $max_tag_id = (isset($_POST['max_tag_id']) && !empty($_POST['max_tag_id'])) ? $_POST['max_tag_id'] : '';

    $photos = unserialize(func_query_first_cell("SELECT data FROM $sql_tbl[sf_cache] WHERE param1 = '" . $max_tag_id . "'"));

    return $photos;

} //}}}

function func_clear_instagram_cache($force = false)
{ //{{{

    global $sql_tbl;

    if ($force) {
        db_query("DELETE FROM $sql_tbl[sf_cache]");
    } else {
        db_query("DELETE FROM $sql_tbl[sf_cache] WHERE expiry < " . XC_TIME);
    }

} //}}}
