<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module functions
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    8c36a90d6cfeadab108d9987d96e7e8be55ea408, v2 (xcart_4_7_12), 2020-04-06 15:14:37, func.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined("XCART_SESSION_START") ) { header("Location: ../"); die("Access denied"); }

function func_sf_init()
{ //{{{
    global $xcart_dir, $smarty, $module_compiled_keys;

    $_module_dir  = $xcart_dir . XC_DS . 'modules' . XC_DS . 'Social_Feeds';

    foreach (func_sf_enabled_feeds() as $feed) {

        if(file_exists($_module_dir . XC_DS . 'func.' . $feed . '.php'))
            require_once $_module_dir . XC_DS . 'func.' . $feed . '.php';

    }

    $smarty->register_modifier('func_sf_get_facebook_lang_code', 'func_sf_get_facebook_lang_code');

    func_sf_assign_dimensions();

    $area = (defined('AREA_TYPE')) ? AREA_TYPE : '';

    if (defined('ADMIN_CONFIGURATION_CONTROLLER')) {
        func_add_event_listener('module.config.update', 'func_sf_on_module_update');
    }

    if (defined('QUICK_START') || $area != 'C') {
        return;
    }


    // Smarty_prefilter_add_social_feeds_entry_points is called here
    $smarty->addAutoloadFilters(array('add_social_feeds_entry_points'), 'pre');

} //}}}

/*
* Dynamically Add {Include File="Modules/Social_Feeds/* Calls To Customer Tpls
*/
function Smarty_prefilter_add_social_feeds_entry_points($source, $smarty)
{//{{{
    global $xcart_dir, $active_modules;
    static $is_called ;

    if (!empty($is_called)) {
        return $source;
    }
    $is_called = 1;

    require_once $xcart_dir . XC_DS . 'include' . XC_DS . 'lib' . XC_DS . 'dynamic_tpl_patcher.php';

    if (empty($active_modules['Xcart_Mobile_Skin'])) {
        $file_to_patch = 'customer/service_head.tpl';
    } else {
        $file_to_patch = 'customer/service_head_mobile.tpl';
    }

    x_tpl_prefilter_append_to_file($file_to_patch, array('file' => 'skin/common_files/modules/Social_Feeds/service_head.tpl', 'insert_before' => '{load_defer_code type' , 'module_name' => 'Social_Feeds'));
    x_tpl_prefilter_append_to_file('customer/service_body_js.tpl', array('file' => 'skin/common_files/modules/Social_Feeds/service_body_js.tpl', 'insert_before' => '{load_defer_code type', 'module_name' => 'Social_Feeds'));
    x_tpl_prefilter_append_to_file('customer/left_bar.tpl', array('file' => 'skin/common_files/modules/Social_Feeds/left_bar.tpl', 'insert_before' => '{include file="poweredby.tpl"}', 'module_name' => 'Social_Feeds'));

    return $source;
}//}}}

function func_sf_on_module_update($module_name, $new_config)
{//{{{
    global $config;

    if ($module_name != 'Social_Feeds') {
        return;
    }

    if (
        (!empty($new_config['socfeeds_yt_username']) || !empty($new_config['socfeeds_yt_api_key']))
        && (empty($config['Social_Feeds']['socfeeds_yt_username']) || empty($config['Social_Feeds']['socfeeds_yt_api_key']))
    ) {
        func_register_cache_function(
            'func_youtube_request',
            array (
                'dir'   => 'youtube_request_cache',
                'ttl'   => SECONDS_PER_DAY,
                )
            );
    }

    if (
        (!empty($new_config['socfeeds_fl_api_key']) || !empty($new_config['socfeeds_fl_photoset_id']))
        && (empty($config['Social_Feeds']['socfeeds_fl_api_key']) || empty($config['Social_Feeds']['socfeeds_fl_photoset_id']))
    ) {
        func_register_cache_function(
            'func_flickr_request',
            array (
                'dir'   => 'flickr_request_cache',
                'ttl'   => SECONDS_PER_DAY,
                )
            );
    }
    return;
}//}}}

function func_sf_assign_dimensions()
{ //{{{

    global $alt_skin_info, $smarty;

    $dimensions = array(
        'ideal_comfort'             => array('height' => 500, 'width' => 250),
        'ideal_responsive'          => array('height' => 500, 'width' => 0),
        'books_and_magazines'       => array('height' => 500, 'width' => 250),
        '2-columns'                 => array('height' => 500, 'width' => 210),
        '3-columns'                 => array('height' => 500, 'width' => 220),
        'fashion_mosaic_blue'       => array('height' => 500, 'width' => 205),
        'fashion_mosaic_green'      => array('height' => 500, 'width' => 250),
        'fashion_mosaic_grey'       => array('height' => 500, 'width' => 250),
        'fashion_mosaic_pink'       => array('height' => 500, 'width' => 250),
        'vivid_dreams_aquamarine'   => array('height' => 500, 'width' => 240),
        'vivid_dreams_chromo'       => array('height' => 500, 'width' => 240),
        'vivid_dreams_lotus'        => array('height' => 500, 'width' => 230),
        'vivid_dreams_violet'       => array('height' => 500, 'width' => 240),
        'light_responsive'          => array('height' => 500, 'width' => 0),
    );

    $smarty->assign('social_feeds_height', $dimensions[$alt_skin_info['alt_schemes_skin_name']]['height']);
    $smarty->assign('social_feeds_width',  $dimensions[$alt_skin_info['alt_schemes_skin_name']]['width']);

    return (isset($dimensions[$alt_skin_info['alt_schemes_skin_name']])
                ? $dimensions[$alt_skin_info['alt_schemes_skin_name']]
                : array('height' => 500, 'width' => 250)
            );

} //}}}

function func_sf_enabled_feeds()
{ //{{{

    global $config, $smarty;

    $feeds = array(
        'facebook'      => 'socfeeds_fb_page_url',
        'twitter'       => 'socfeeds_tw_widget_id',
        'flickr'        => 'socfeeds_fl_api_key',
        'youtube'       => 'socfeeds_yt_username',
        'instagram'     => 'socfeeds_ig_client_id'
    );

    $return = array();

    foreach($feeds as $feed => $field) {

        if (!empty($config['Social_Feeds'][$field])) {

            $return[] = $feed;

        }

    }

    $smarty->assign('sf_enabled_social_feeds', $return);

    return $return;

} //}}}

function func_sf_get_facebook_lang_code($store_language)
{ //{{{
    global $all_languages;

    $fb_langs = array (
    //{{{
      'Afrikaans' => 'af_ZA',
      'Akan' => 'ak_GH',
      'Albanian' => 'sq_AL',
      'Amharic' => 'am_ET',
      'Arabic' => 'ar_AR',
      'Armenian' => 'hy_AM',
      'Assamese' => 'as_IN',
      'Aymara' => 'ay_BO',
      'Azerbaijani' => 'az_AZ',
      'Basque' => 'eu_ES',
      'Belarusian' => 'be_BY',
      'Bengali' => 'bn_IN',
      'Bhojpuri' => 'bp_IN',
      'Bosnian' => 'bs_BA',
      'Breton' => 'br_FR',
      'Bulgarian' => 'bg_BG',
      'Burmese' => 'qz_MM',
      'Burmese' => 'my_MM',
      'Catalan' => 'ca_ES',
      'Cebuano' => 'cx_PH',
      'Cherokee' => 'ck_US',
      'Chewa' => 'ny_MW',
      'Chinese' => 'zh_CN',
      'Classical Greek' => 'gx_GR',
      'Corsican' => 'co_FR',
      'Croatian' => 'hr_HR',
      'Czech' => 'cs_CZ',
      'Danish' => 'da_DK',
//      'Dutch (België)' => 'nl_BE',
      'Dutch' => 'nl_NL',
//      'English (India)' => 'en_IN',
//      'English (Pirate)' => 'en_PI',
//      'English (UK)' => 'en_GB',
      'English' => 'en_US',
//      'English (Upside Down)' => 'en_UD',
      'Esperanto' => 'eo_EO',
      'Estonian' => 'et_EE',
      'Faroese' => 'fo_FO',
      'Filipino' => 'tl_PH',
      'Finnish' => 'fi_FI',
//      'French (Canada)' => 'fr_CA',
      'French' => 'fr_FR',
      'Frisian' => 'fy_NL',
      'Fula' => 'ff_NG',
      'Galician' => 'gl_ES',
      'Ganda' => 'lg_UG',
      'Georgian' => 'ka_GE',
      'German' => 'de_DE',
      'Greek' => 'el_GR',
      'Guarani' => 'gn_PY',
      'Gujarati' => 'gu_IN',
      'Haitian Creole' => 'ht_HT',
      'Hausa' => 'ha_NG',
      'Hebrew' => 'he_IL',
      'Hindi' => 'hi_IN',
      'Hungarian' => 'hu_HU',
      'Icelandic' => 'is_IS',
      'Igbo' => 'ig_NG',
      'Indonesian' => 'id_ID',
      'Irish' => 'ga_IE',
      'Italian' => 'it_IT',
//      'Japanese (Kansai)' => 'ja_KS',
      'Japanese' => 'ja_JP',
      'Javanese' => 'jv_ID',
      'Kannada' => 'kn_IN',
      'Kashmiri' => 'ks_IN',
      'Kazakh' => 'kk_KZ',
      'Khmer' => 'km_KH',
      'Kinyarwanda' => 'rw_RW',
      'Klingon' => 'tl_ST',
      'Korean' => 'ko_KR',
      'Kurdish' => 'ku_TR',
      'Kyrgyz' => 'ky_KG',
      'Lao' => 'lo_LA',
      'Latin' => 'la_VA',
      'Latvian' => 'lv_LV',
      'Leet Speak' => 'fb_LT',
      'Limburgish' => 'li_NL',
      'Lingala' => 'ln_CD',
      'Lithuanian' => 'lt_LT',
      'Macedonian' => 'mk_MK',
      'Malagasy' => 'mg_MG',
      'Malay' => 'ms_MY',
      'Malayalam' => 'ml_IN',
      'Maltese' => 'mt_MT',
      'Marathi' => 'mr_IN',
      'Mongolian' => 'mn_MN',
      'Māori' => 'mi_NZ',
      'Nepali' => 'ne_NP',
      'Northern Ndebele' => 'nd_ZW',
      'Northern Sotho' => 'ns_ZA',
      'Northern Sámi' => 'se_NO',
      'Norwegian (bokmal)' => 'nb_NO',
      'Norwegian (nynorsk)' => 'nn_NO',
      'Oriya' => 'or_IN',
      'Pashto' => 'ps_AF',
      'Persian' => 'fa_IR',
      'Polish' => 'pl_PL',
//    'Portuguese (Brazil)' => 'pt_BR',
      'Portuguese' => 'pt_PT',
      'Punjabi' => 'pa_IN',
      'Quechua' => 'qu_PE',
      'Quiché' => 'qc_GT',
      'Romanian' => 'ro_RO',
      'Romansh' => 'rm_CH',
      'Russian' => 'ru_RU',
      'Sanskrit' => 'sa_IN',
      'Sardinian' => 'sc_IT',
      'Serbian' => 'sr_RS',
      'Shona' => 'sn_ZW',
      'Silesian' => 'sz_PL',
//    'Simplified Chinese (China)' => 'zh_CN',
      'Sinhala' => 'si_LK',
      'Slovak' => 'sk_SK',
      'Slovenian' => 'sl_SI',
      'Somali' => 'so_SO',
      'Sorani Kurdish' => 'cb_IQ',
      'Southern Ndebele' => 'nr_ZA',
      'Southern Sotho' => 'st_ZA',
//    'Spanish (Chile)' => 'es_CL',
//    'Spanish (Colombia)' => 'es_CO',
//    'Spanish (Mexico)' => 'es_MX',
      'Spanish' => 'es_ES',
//    'Spanish (Venezuela)' => 'es_VE',
//    'Spanish' => 'es_LA',
      'Swahili' => 'sw_KE',
      'Swazi' => 'ss_SZ',
      'Swedish' => 'sv_SE',
      'Syriac' => 'sy_SY',
      'Tajik' => 'tg_TJ',
      'Tamazight' => 'tz_MA',
      'Tamil' => 'ta_IN',
      'Tatar' => 'tt_RU',
      'Telugu' => 'te_IN',
      'Thai' => 'th_TH',
      'Traditional Chinese (Hong Kong)' => 'zh_HK',
      'Traditional Chinese (Taiwan)' => 'zh_TW',
      'Tsonga' => 'ts_ZA',
      'Tswana' => 'tn_BW',
      'Turkish' => 'tr_TR',
      'Turkmen' => 'tk_TM',
      'Ukrainian' => 'uk_UA',
      'Urdu' => 'ur_PK',
      'Uzbek' => 'uz_UZ',
      'Venda' => 've_ZA',
      'Vietnamese' => 'vi_VN',
      'Welsh' => 'cy_GB',
      'Wolof' => 'wo_SN',
      'Xhosa' => 'xh_ZA',
      'Yiddish' => 'yi_DE',
      'Yoruba' => 'yo_NG',
      'Zazaki' => 'zz_TR',
      'Zulu' => 'zu_ZA',
    );//}}}

    if (!empty($all_languages[$store_language])) {
        $store_language_name = $all_languages[$store_language]['language'];
    } elseif(!empty($store_language)) {
        foreach($fb_langs as $_language => $_code) {
            if (strpos($_code, $store_language . '_') !== false) {
                $store_language_name = $_language;
                break;
            }
        }
    }


    return !empty($fb_langs[$store_language_name]) ? $fb_langs[$store_language_name] : 'en_US';
} //}}}
