<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module functions
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    7f870d71d44bca60280584a90410f899c35502cc, v1 (xcart_4_7_12), 2020-02-03 17:17:40, func.youtube.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

/* YouTube functions */

function func_ajax_block_youtube_feed()
{ //{{{

    global $smarty;

    $sf_account_info = func_youtube_account();
    $nextPageToken = $videos = false;
    if ($sf_account_info) {
        list($nextPageToken, $videos) = func_youtube_videos($sf_account_info['channel_id']);
    }


    $dimensions = array();
    $dimensions = func_sf_assign_dimensions();

    $smarty->assign('youtube_height', $dimensions['height'] - 85);
    $smarty->assign('youtube_width',  $dimensions['width']);

    $smarty->assign('sf_account_info', $sf_account_info);
    $smarty->assign('sf_videos', $videos);
    $smarty->assign('nextPageToken', $nextPageToken);

    if (!isset($_POST['nextPageToken'])) {
        return func_display('modules/Social_Feeds/youtube.tpl', $smarty, false);
    } else {
        return func_display('modules/Social_Feeds/youtube_videos.tpl', $smarty, false) ?: '<script type="text/javascript" language="JavaScript 1.2"> //<![CDATA[ var nextPageToken = "' .$nextPageToken . '"; //]]> </script> <button id="youtube-load-more" class="youtube-load-more">' . func_get_langvar_by_name('lbl_socfeeds_yt_no_more_videos', NULL, false, true)  . '</button>';
    }

} //}}}

function func_youtube_account()
{ //{{{

    global $config;

    $query = array(
        'part'          => 'snippet,contentOwnerDetails',
        'id'   => $config['Social_Feeds']['socfeeds_yt_username'],
        'key'           => $config['Social_Feeds']['socfeeds_yt_api_key']
    );

    $result = func_youtube_request('channels', $query);

    $account = array();

    if (!empty($result) && !empty($result['items'])) {
        $result = $result['items'][0];

        $account['title']  = $result['snippet']['title'];
        $account['icon_url'] = $result['snippet']['thumbnails']['default']['url'];
        $account['channel_id'] = $result['id'];
    }

    return $account;

} //}}}

function func_youtube_videos($channel_id)
{ //{{{

    global $config;

    $nextPageToken = (isset($_POST['nextPageToken']) && !empty($_POST['nextPageToken'])) ? $_POST['nextPageToken'] : false;

    $query = array(
        'part'          => 'snippet',
        'type'          => 'video',
        'maxResults'    => '10',
        'channelId'     => $channel_id,
        'key'           => $config['Social_Feeds']['socfeeds_yt_api_key']
    );

    if(isset($_POST['nextPageToken'])) {
        $query['pageToken'] = $nextPageToken;
    }

    $result = func_youtube_request('search', $query);

    $return = array();

    if (!empty($result['items'])) {
        foreach ($result['items'] as $k => $v) {
            $video_stat = func_youtube_video_stat($result['items'][$k]['id']['videoId']);

            $return[$k]['title'] = $result['items'][$k]['snippet']['title'];
            $return[$k]['video_url'] = 'https://www.youtube.com/watch?v=' . $result['items'][$k]['id']['videoId'];
            $return[$k]['views'] = $video_stat['viewCount'];
            $return[$k]['likes'] = $video_stat['likeCount'];
            $return[$k]['thumbnail'] = $result['items'][$k]['snippet']['thumbnails']['medium']['url'];
        }
    }

    $nextPageToken = isset($result['nextPageToken']) ? $result['nextPageToken'] : '';

    return array($nextPageToken, $return);
} //}}}

function func_youtube_video_stat($video_id)
{ //{{{
    global $config;

    $query = array(
        'part'  => 'statistics',
        'id'    => $video_id,
        'key'   => $config['Social_Feeds']['socfeeds_yt_api_key']
    );

    $result = func_youtube_request('videos', $query);

    return empty($result) ? array() : $result['items'][0]['statistics'];
} //}}}

function func_youtube_request($api_method, $query)
{ //{{{

    func_register_cache_function(
        'func_youtube_request',
        array (
            'dir'   => 'youtube_request_cache',
            'ttl'   => SECONDS_PER_DAY,
        )
    );

    $save_result_in_cache = true;

    $md5_args = $api_method . md5(serialize($query));

    if (($data = func_get_cache_func($md5_args, 'func_youtube_request'))) {
        return $data['data'];
    }

    x_load('http');

    list($header, $result) = func_https_request('GET', 'https://www.googleapis.com/youtube/v3/' . $api_method . '?' . http_build_query($query));

    if (defined('XC_SOCIAL_FEEDS_DEBUG')) {
       x_log_add('social_feeds_youtube', "*** Request:\n" . print_r($query, true) . "\n\n*** Response:\n" . print_r($result, true));
    }

    $result = json_decode($result, true);

    if (isset($result['error']) && !empty($result['error'])) {
        $save_result_in_cache = false;

        $result = array();
    }

    if ($save_result_in_cache) {
        $res = func_save_cache_func($result, $md5_args, 'func_youtube_request');

        if (!$res) {
            func_register_cache_function(
                'func_youtube_request',
                array (
                    'dir'   => 'youtube_request_cache',
                    'ttl'   => SECONDS_PER_DAY,
                    'force_restore' => true,
                    'force_dir_creation' => true,
                )
            );
        }
    }

    return $result;

} //}}}
