<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * @category   Modules
 * @package    X-Cart
 * @subpackage Two-Factor authentication via Authy
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    c3c5d9d66fd379f06231f8d08787bd396b9e1b82, v1 (xcart_4_7_12), 2020-02-10 11:51:41, twofactor_token.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (!defined('XCART_START')) {
    header('Location: ../../');
    die('Access denied');
}

x_session_register('twofactor_verify');

if (
    !empty($active_modules['TwoFactorAuth'])
    && !empty($logged_userid)
    && func_twofactor_is_waiting_for_token($current_area)
) {

    if ($mode == 'verify_token' && !empty($token)) {

        $verified = func_twofactor_verify_token($token, $logged_userid);

        if ($verified) {
            $redirect_url = $twofactor_verify[$current_area]['redirect_url'];

            x_load('user');
            // Save into login history
            func_store_login_action($logged_userid, $current_area, 'login', 'success');

            // Save into log file admin/provider login
            if (in_array($current_area, array('A', 'P'))) {

                x_log_flag(
                    'log_activity',
                    'ACTIVITY',
                    "'" . $twofactor_verify[$current_area]['saved_login'] . "' user (ID: $userid) with '$current_area' usertype has logged in. Remote IP '$REMOTE_ADDR'"
                );

            }

            func_twofactor_unset_token_waiting($current_area);

            if (func_is_ajax_request()) {
                func_reload_parent_window();
            } else {
                func_header_location($redirect_url);
            }
        } else {
            $top_message = array(
                'content' => func_get_langvar_by_name('msg_twofactor_invalid_token', NULL, FALSE, TRUE),
                'type' => 'E'
            );

            if (func_is_ajax_request()) {
               func_register_ajax_message(
                    'popupDialogCall',
                    array(
                        'action'  => 'message',
                        'message' => $top_message
                    )
                );

                $top_message = '';
            }

            func_header_location('twofactor_token.php');
        }


    }

    $smarty->assign('sms_sent', $twofactor_verify[$current_area]['sms_sent']);
    $phone = func_twofactor_get_phone($logged_userid);
    $smarty->assign('token_phone', $phone['phone']);

} else {

    func_header_location('home.php');

}

$smarty->assign('main', 'twofactor_token_verify');
