<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Module configuration
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    23a1a60d185c1e1bf13e807ab8aa00e79d79c1e1, v18 (xcart_4_7_10), 2018-03-28 18:13:13, config.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_START') ) { header('Location: ../../'); die('Access denied'); }

// Add modules/XMultiCurrency/main.css
$css_files['XMultiCurrency'][] = array();
$addons['XMultiCurrency'] = true;
$css_files['XMultiCurrency'][] = array('altskin' => true);

// Table with currencies list customer which can select 
$sql_tbl['mc_currencies'] = XC_TBL_PREFIX . 'mc_currencies';
$sql_tbl['mc_geolite_networks'] = XC_TBL_PREFIX . 'mc_geolite_networks';
$sql_tbl['mc_geolite_locations'] = XC_TBL_PREFIX . 'mc_geolite_locations';

// List of modules which implements the gathering exchange rates from online services
$mcServices = array(
    'gfin',        // Google Finance
    'currencyconverterapi',        // The Free Currency Converter API
    //'gconv',       // Google Currency Conversion API/NOT worked now
    'webservicex', // WebserviceX.NET
);

$geoIPServices = array(
    'freegeoip',    // freegeoip.net
    'maxmind_free', // maxmind.com
);

// Enable/disable logging of exchange rates update procedure
$mc_log_rates_update = TRUE;

// Load module functions
if (!empty($include_func)) {
    require_once $xcart_dir . XC_DS . 'modules' . XC_DS . 'XMultiCurrency' . XC_DS . 'func.php';
}

// Module initialization
if (!empty($include_init)) {
    require_once $xcart_dir . XC_DS . 'modules' . XC_DS . 'XMultiCurrency' . XC_DS . 'init.php';
}
