<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Converge / Elavon Hosted Payments Page (HPP)
 * https://developer.elavon.com/#/api/eb6e9106-0172-4305-bc5a-b3ebe832f823.rcosoomi/versions/5180a9f2-741b-439c-bced-5c84a822f39b.rcosoomi/documents/?converge-integration-guide/book/integration_methods/hosted_payments.html
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Payment interface
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    2a321c65d1ad1429f47434729de546ac23ecdfac, v2 (xcart_4_7_11), 2019-04-25 08:59:19, cc_convergepay.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (
    (isset($_POST['errorCode']) || isset($_POST['ssl_result']))
    || (isset($_GET['errorCode']) || isset($_GET['ssl_result']))
) {
    require __DIR__.'/auth.php';

    if (defined('CONVERGEPAY_DEBUG')) {
        func_pp_debug_log('convergepay', 'R', print_r($_GET, true) . print_r($_POST, true));
    }

    if (!func_is_active_payment('cc_convergepay.php'))
        exit;

    $module_params = func_get_pm_params('cc_convergepay.php');
    if (empty($ssl_invoice_number)) {
        // Use current session_id if ssl_invoice_number was not passed in the response
        $bill_output['sessid'] = $XCARTSESSID;
    } else {
        $bill_output['sessid'] = func_query_first_cell("SELECT sessid FROM $sql_tbl[cc_pp3_data] WHERE ref='" . $ssl_invoice_number . "'");
    }

    // https://developer.elavon.com/#/api/eb6e9106-0172-4305-bc5a-b3ebe832f823.rcosoomi/versions/5180a9f2-741b-439c-bced-5c84a822f39b.rcosoomi/documents/?converge-integration-guide/book/api_reference/avs_codes.html
    $avserr = array(//{{{
        'A' => "Address matches - ZIP Code does not match",
        'B' => "Street address match, Postal code in wrong format (international issuer)",
        'C' => "Street address and postal code in wrong formats",
        'D' => "Street address and postal code match (international issuer)",
        'E' => "AVS Error",
        'F' => "Address does compare and five-digit ZIP code does compare (UK only)",
        'G' => "Service not supported by non-US issuer",
        'I' => "Address information not verified by international issuer",
        'M' => "Street Address and Postal code match (international issuer)",
        'N' => "No Match on Address (Street) or ZIP",
        'O' => "No Response sent",
        'P' => "Postal codes match, Street address not verified due to incompatible formats",
        'R' => "Retry, System unavailable or Timed out",
        'S' => "Service not supported by issuer",
        'U' => "Address information is unavailable",
        'W' => "9-digit ZIP matches, Address (Street) does not match",
        'X' => "Exact AVS Match",
        'Y' => "Address (Street) and 5-digit ZIP match",
        'Z' => "5-digit ZIP matches, Address (Street) does not match",
    );
    //}}}
    $cvverr = array(//{{{
        'M' => "CVV2/CVC2 Match",
        'N' => "CVV2/CVC2 No match",
        'P' => "Not processed",
        'S' => "Issuer indicates that the CVV2/CVC2 data should be present on the card, but the merchant has indicated that the CVV2/CVC2 data is not resent on the card",
        'U' => "Issuer has not certified for CVV2/CVC2 or Issuer has not provided Visa with the CVV2/CVC2 encryption keys",
    );//}}}

    $bill_output['code'] = 2;
    if (isset($errorCode)) {
        $bill_output['billmes'] = $errorName . ': ' . $errorMessage . ' (error code: ' . $errorCode . ')';
    } else {

        $bill_output['billmes'] = '';
        if ($ssl_result == 0 && isset($ssl_txn_id)) {
            x_load('xml', 'http');

            //verify transaction
            $fields = array(
                'ssl_merchant_id' => trim($module_params['param01']),
                'ssl_user_id' => trim($module_params['param07']),
                'ssl_pin' => trim($module_params['param02']),
                'ssl_transaction_type' => 'txnquery',
                'ssl_txn_id' => $ssl_txn_id,
            );

            if ($module_params['testmode'] != 'N') {
                $fields['ssl_test_mode'] = 'TRUE';
            }

            $urls = XCconvergepay::getUrls($module_params);

            $post_str = '<txn>';
            foreach ($fields as $var => $val) {
                $post_str .= "<$var>$val</$var>";
            }
            $post_str .= '</txn>';

            list($a, $return) = func_https_request('POST', $urls['url_xml'], $post_str);

            if (defined('CONVERGEPAY_DEBUG')) {
                func_pp_debug_log('convergepay', 'transaction_details', print_r($fields, true) . print_r($a, true) . print_r($return, true));
            }

            // https://developer.elavon.com/#/api/eb6e9106-0172-4305-bc5a-b3ebe832f823.rcosoomi/documents/?converge-integration-guide/book/api_reference/credit_card_codes.html
            // https://developer.elavon.com/#/api/eb6e9106-0172-4305-bc5a-b3ebe832f823.rcosoomi/documents?converge-integration-guide/book/transaction_types/end_of_day/transaction_query.html
            $parse_error = '';
            if (
                !empty($return)
                && ($res = func_xml_parse($return, $parse_error))
                && !empty($res)
                && in_array(func_array_path($res, 'txn/#/ssl_result_message/0/#'), array('APPROVAL','APPROBAT'))
                && in_array(func_array_path($res, 'txn/#/ssl_trans_status/0/#'), array('STL'))
                && $ssl_invoice_number == func_array_path($res, 'txn/#/ssl_invoice_number/0/#')
            ) {
                $bill_output['code'] = 1;
            } else {
                $bill_output['billmes'] .= ( !empty($res) ? (func_array_path($res, 'txn/#/ssl_result_message/0/#') . func_array_path($res, 'txn/#/ssl_trans_status/0/#')) : '' );
            }

            if ($module_params['testmode'] != 'N') {
                $bill_output['code'] = 1;
            }
        }

        x_session_register('secure_oid');

        if (isset($ssl_result_message)) {
            $bill_output['billmes'] .= $ssl_result_message;
        }

        if ($bill_output['code'] == 1 && ($module_params['use_preauth'] == 'Y' || func_is_preauth_force_enabled($secure_oid)))
            $bill_output['is_preauth'] = true;

        if (isset($ssl_txn_id)) {
            $extra_order_data = array(
                'txnid' => $ssl_txn_id,
                'approval_code' => $ssl_approval_code,
                'capture_status' => !empty($bill_output['is_preauth']) ? 'A' : ''
            );

            $bill_output['billmes'] .= ' (Transaction ID: ' . $ssl_txn_id . '; Approval code: ' . $ssl_approval_code . ')';
        }

        if ($ssl_avs_response) {
            $bill_output['avsmes'] = 'AVS Code: ' . $avserr[$ssl_avs_response] . ' (' . $ssl_avs_response . ')';
        }

        if ($ssl_cvv2_response) {
            $bill_output['cvvmes'] = 'CVV Code: ' . $cvverr[$ssl_cvv2_response] . ' (' . $ssl_cvv2_response . ')';
        }
    }

    require($xcart_dir.'/payment/payment_ccend.php');

} else {

    if (!defined('XCART_START')) { header("Location: ../"); die("Access denied"); }

    $ordr = $module_params['param04'] . join("-", $secure_oid);
    $s_phone = empty($userinfo['s_phone']) ? $userinfo['phone'] : $userinfo['s_phone'];

    $fields = array(
        'ssl_invoice_number' => $ordr,
        'ssl_merchant_id' => trim($module_params['param01']),
        'ssl_user_id' => trim($module_params['param07']),
        'ssl_pin' => trim($module_params['param02']),
           //'ssl_customer_code' => '1111',
           'ssl_salestax' => $cart['tax_cost'],
        'ssl_description' => substr($ordr, 0, 255),
        'ssl_amount' => price_format($cart['total_cost']),
        'ssl_transaction_type' => ($module_params['use_preauth'] == 'Y' || func_is_preauth_force_enabled($secure_oid)) ? 'ccauthonly' : 'ccsale',

        'ssl_company' => substr($userinfo['company'], 0, 50),
        'ssl_first_name' => substr($bill_firstname, 0, 15),
        'ssl_last_name' => substr($bill_lastname, 0, 30),
        'ssl_address2' => !empty($userinfo['b_address_2']) ? substr($userinfo['b_address_2'], 0, 30) : '',
        'ssl_city' => substr($userinfo['b_city'], 0, 30),
        'ssl_state' => substr(($userinfo['b_state'] ? $userinfo['b_state'] : 'n/a'), 0, 10),
        'ssl_country' => func_get_3letters_country_code($userinfo['b_country']),
        'ssl_phone' => substr($userinfo['phone'], 0, 20),
        'ssl_email' => substr($userinfo['email'], 0, 100),

        'ssl_ship_to_company' => substr($userinfo['company'], 0, 50),
        'ssl_ship_to_first_name' => substr($userinfo['s_firstname'], 0, 20),
        'ssl_ship_to_last_name' => substr($userinfo['s_lastname'], 0, 30),
        'ssl_ship_to_address1' => substr($userinfo['s_address'], 0, 30),
        'ssl_ship_to_address2' => !empty($userinfo['s_address_2']) ? substr($userinfo['s_address_2'], 0, 30) : '',
        'ssl_ship_to_city' => substr($userinfo['s_city'], 0, 30),
        'ssl_ship_to_state' => substr(($userinfo['s_state'] ? $userinfo['s_state'] : 'n/a'), 0, 10),
        'ssl_ship_to_country' => func_get_3letters_country_code($userinfo['s_country']),
        'ssl_ship_to_zip' => substr($userinfo['s_zipcode'], 0, 10),
        'ssl_ship_to_phone' => substr($s_phone, 0, 20),

        'ssl_result_format' => 'ASCII',
        'ssl_receipt_apprvl_method' => 'REDG',
        'ssl_receipt_apprvl_get_url' => $current_location . '/payment/cc_convergepay.php',
        'ssl_receipt_decl_method' => 'REDG',
        'ssl_receipt_decl_get_url' => $current_location . '/payment/cc_convergepay.php',
        'ssl_error_url' => $current_location . '/payment/cc_convergepay.php'
    );

    if ($module_params['testmode'] != 'N') {
        $fields['ssl_test_mode'] = 'TRUE';
    }

    if ($module_params['param06'] == 'Y') {
        $fields['ssl_avs_address'] = substr($userinfo['b_address'], 0, 20);
        $fields['ssl_avs_zip'] = substr($userinfo['b_zipcode'], 0, 10);
    }

    if ($module_params['param05'] == 'Y') {
        $fields['ssl_cvv2cvc2_indicator'] = '1';
    }

    $urls = XCconvergepay::getUrls($module_params);

    // Send request to receive payment URL
    x_load('http');

    $post = array();
    foreach ($fields as $var => $val) {
        $post[] = $var . '=' . $val;
    }

    list($a, $return) = func_https_request('POST', $urls['url_token'], $post);

    if (defined('CONVERGEPAY_DEBUG')) {
        func_pp_debug_log('convergepay', 'I', print_r($fields, true) . print_r($a, true) . print_r($return, true));
    }

    if (empty($return)) {
        // empty token for some reason
        $bill_output['code'] = 2;
        $bill_output['billmes'] = func_get_langvar_by_name('err_payment_cc_not_available');
        require $xcart_dir . '/payment/payment_ccend.php';
    }

    if (!$duplicate) {
        db_query("REPLACE INTO $sql_tbl[cc_pp3_data] (ref,sessid) VALUES ('".addslashes($ordr)."','".$XCARTSESSID."')");
    }

    func_header_location($urls['url_hpp'] . urlencode($return));
}

class XCconvergepay {
    public static function getUrls($_module_params)
    {//{{{

        if ($_module_params['testmode'] != 'N') {
            $prefix1 = 'demo';
            $prefix2 = 'VirtualMerchantDemo';
        } else {
            $prefix1 = 'www';
            $prefix2 = 'VirtualMerchant';
        }

        $_url_token = "https://$prefix1.convergepay.com/hosted-payments/transaction_token";
        $_url_hpp = "https://$prefix1.convergepay.com/hosted-payments?ssl_txn_auth_token=";
        $_url_xml = "https://$prefix1.convergepay.com/$prefix2/processxml.do";
        return array(
            'url_token' => $_url_token,
            'url_hpp' => $_url_hpp,
            'url_xml' => $_url_xml,
        );

    }//}}}
}
exit;
