/**
 * vim: set ts=2 sw=2 sts=2 et:
 * PayPal Express Checkout controller
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage JS Library
 * @author     Ildar Amankulov
 * @version    9420d43903cbe798e4b468f13709aaacf26ac8a2, v6 (xcart_4_7_9), 2018-01-09 16:56:31, paypal_express_incontext.js, aim
 *
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

if (typeof window.XCPaypalShowButtons !== 'function') {
  window.XCPaypalShowButtons = function (event) {
      if (event) {
        event.stopPropagation();
      }

      $('[data-paypal-button]').each(function () {
        var elem = $(this);

          var state = {
            label: 'checkout',
            fundingicons: false,
            color: 'gold',
            additionalUrlParams: {},
            size: 'responsive',
            funding: {},
            tagline: true
          };

          var style = {
            size: state.size,
            shape: state.shape || 'rect',
            label: state.label,
            branding: true,
            tagline: state.tagline
          };

          if (state.color) {
            style.color = state.color;
          }

          if (state.fundingicons) {
            style.fundingicons = state.fundingicons;
          }

          var CREATE_PAYMENT_URL  = xc_paypal_post_data_g.url + '/payment/ps_paypal_pro.php?mode=express&paypal_express_v4=1&payment_id=' + xc_paypal_post_data_g.payment_id;

          var buttonObject = {

            'env': xc_paypal_post_data_g.testmode == 'Y' ? 'sandbox' : 'production',

            'payment': function(resolve, reject) {
              return paypal.request.get(CREATE_PAYMENT_URL).then(function(result) {

                if (result.hasOwnProperty('token') && result.token) {
                   return result.token;
                }

                if (typeof result.content != 'undefined') {
                  showTopMessage(result.content, 'e');
                  throw new Error(result.content);
                }
              }).catch(function (err) {
                reject(err);
              });
            },

            'onError': function(err) {
              console.log("onError: ", arguments);
            },

            'funding': state.funding,

            'onAuthorize': function (data, actions) {
              return actions.redirect();
            },

            'onCancel': function (data, actions) {
              return actions.redirect();
            },

          };

          if (elem.data('locale')) {
            buttonObject.locale = elem.data('locale');
          }

          paypal.Button.render(buttonObject, elem.get(0));
          elem.removeClass("paypal-button-hidden");
      });
  };//Window.XcpAYPAlShowButtons = function ()
}

if (typeof paypal !== 'undefined' && typeof paypal.Button.render !== 'undefined') {
  XCPaypalShowButtons();
} else {
  $('[data-paypal-button]').on('PayPal_lib_checkout_is_loaded', XCPaypalShowButtons);
}
