/* vim: set ts=2 sw=2 sts=2 et: */
/**
 * Voting widget
 * 
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage JS Library
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com> 
 * @version    b90a2e72455c9ccfd896e6bd49ec3699096f6691, v5 (xcart_4_7_11), 2019-03-07 16:02:33, vote_bar.js, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

$(document).ready(
  function() {
    $('.acr-rating-box .acr-allow-add-rate a').on( "mouseenter", /*HoVer_deprecated_in_3_3*/
      function() {

        if (!this._previous) {
          this._previous = $(this).prevAll();
        }

        $(this).addClass('over');
        this._previous.addClass('over');
      }
    ).on( "mouseleave",
      function() {

        if (!this._previous) {
          this._previous = $(this).prevAll();
        }

        this._previous.removeClass('over');
        $(this).removeClass('over');
      }
    )
    .on('click', /*CLiCk_Event_deprecated_in_3_3*/
      function() {

        if (!this._previous) {
          this._previous = $(this).prevAll();
        }

        if (!this._all) {
          this._all = $(this).parent().children('a');
        }

        this._all.removeClass('full');
        $(this).addClass('full');
        this._previous.addClass('full');

        if (!this._rating) {
          var _rating = parseInt($(this).attr('id').match(/\d+/));
          this._rating = _rating * stars_cost;
        }

        $("#rating").val(this._rating);
        /* remove red from star labels */
        $("#rating").closest('tr').find('td').eq(0).removeClass('fill-error');

      }
    );

    /* highlight empty stars onSUbmit */
    $("#rating").closest('form').submit(
      function( event ) {
        var Jrating = $("#rating"), _Jstars;
        var _val = parseInt(Jrating.val());

        if ((_val == 0 || _val == '') && (_Jstars = Jrating.closest('tr').find('.acr-rating-box'))) {
          var has_shake_effect = $.effects && $.effects.effect && $.effects.effect.shake;

          var top_of_element = _Jstars.offset().top;
          var bottom_of_element = _Jstars.offset().top + _Jstars.outerHeight();
          var bottom_of_screen = $(window).scrollTop() + window.innerHeight;
          var top_of_screen = $(window).scrollTop();

          /* check if stars is in viewport */
          if ((bottom_of_screen > top_of_element) && (top_of_screen < bottom_of_element)){
              var is_in_viewport = true;
          } else {
              var is_in_viewport = false;
          }

          if (is_in_viewport && has_shake_effect && _Jstars.length) {
            _Jstars.effect('shake',{ 'distance':4, times:2 });
          } else {
            xAlert(substitute(lbl_required_field_is_empty, 'field', Jrating.closest('tr').find('label[for="rating"]').html()), lbl_warning, 'W');
          }

          /* highlight label by red */
          Jrating.closest('tr').find('td').eq(0).addClass('fill-error');

          event.preventDefault();
        }

        return true;
      }
    );

    return true;
  }
);
