{*
11f9e7b032f8472a403599352a2f6a2ea811366e, v2 (xcart_4_7_12), 2020-03-02 10:37:26, product_modify.tpl, aim

vim: set ts=2 sw=2 sts=2 et:
*}
  {* the dynamically added to main/product_details.tpl *}

  {**
  * TaxJar Integration Module
  *
  * @category  X-Cart_4_Module
  * @package   TaxJar
  * @author    Qualiteam software Ltd <info@x-cart.com>
  * @copyright Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>. All rights reserved
  * @license   https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
  * @link      https://www.x-cart.com/
  *
  *}

  <tr>
    {if $geid ne ''}<td width="15" class="TableSubHead">&nbsp;</td>{/if}
    <td colspan="2"><br />{include file="main/subheader.tpl"}</td>
  </tr>

  <tr>
    {if $geid ne ''}<td width="15" class="TableSubHead"><input type="checkbox" value="Y" name="fields[csi_taxjar_code]" /></td>{/if}
    <td class="FormButton" nowrap="nowrap">{$lng.lbl_taxjar_category}:</td>
    <td class="ProductDetails">
      <select name="csi_taxjar_code">
          <option value='00000'{if $product.csi_taxjar_code eq '00000'} selected="selected"{/if}>{$lng.lbl_taxjar_no_category}</option>
          {foreach from=$taxjar_categories item=i}
              <option value='{$i.product_tax_code}'{if $i.product_tax_code eq $product.csi_taxjar_code} selected="selected"{/if}>{$i.name}</option>
          {/foreach}
      </select>

      <span id="show_taxjar_warning" style="cursor: pointer; display: inline-block; margin-left: 15px; color: #bd4f4f">Important note</span>

      <p id="taxjar_warning" style="display:none; padding: 10px; border: 1px solid #ff0000; background: #ffdbdb; line-height: 20px; letter-spacing: 1px; font-size: 14px;">IMPORTANT: Currently TaxJar provides product-level tax rules for a subset of product categories. These categories are to be used for products that are either exempt from sales tax in some jurisdictions or are taxed at reduced rates. If the product is fully taxable DO NOT set category. Also keep in mind "<b>Other Exempt</b>" is currently not supported in AutoFile.<br/> For more information see this <a href="https://support.taxjar.com/article/362-smartcalcs-product-categories" target="_blank">TaxJar Product Categories</a><br />Remove the file modules/CSI_TaxJar/categories.json to obtain product tax codes for Plus members</p>
    </td>
  </tr>

  {literal}
  <script type="text/javascript">
  document.getElementById('show_taxjar_warning').addEventListener('click', function () {
    toggle(document.querySelectorAll('#taxjar_warning'));
  });

  function toggle (elements, specifiedDisplay) {
    var element, index;

    elements = elements.length ? elements : [elements];

    for (index = 0; index < elements.length; index++) {
      element = elements[index];

      if (isElementHidden(element)) {
        element.style.display = '';

        // If the element is still hidden after removing the inline display
        if (isElementHidden(element)) {
          element.style.display = specifiedDisplay || 'block';
        }
      } else {
        element.style.display = 'none';
      }
    }

    function isElementHidden (element) {
      return window.getComputedStyle(element, null).getPropertyValue('display') === 'none';
    }
  }
  </script>
  {/literal}
