/* vim: set ts=2 sw=2 sts=2 et: */
/**
 * Functions for EU Cookie Law module
 * 
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage JS Library
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com> 
 * @version    7823901d7bd0e1f5dcf8cd4ac2602dc8f365891e, v8 (xcart_4_7_12), 2020-03-10 12:36:48, func.js, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

/* global lbl_sec, allowed_cookies xcart_web_dir */
/* is needed for EU_GDPR */
var panel_timer = null;

var _EU_Cookie_Law_func_js = function() {
$(document).ready(function () {
  /*show panel*/
  if ($("div#eucl_panel")) {
    $("div#eucl_panel").hide();

    panel_timer = setTimeout(
      function () {
        $("div#eucl_panel").slideDown("slow");
      }, 3000);
  }

  /*reset cookies*/
  setTimeout(
    function () {
      func_reset_unallowed_cookies();
    },
  5000);

  /*register a new function*/
  jQuery.xc_cookie = function (key, value, options) {
    if (func_is_allowed_cookie(key)) {
      $.cookie(key, value, options);
    } else {
      $.cookie(key, null);
    }
  };

});
};/* var _eu_Cookie_Law_func_js = FUnction */

function func_down_eucl_panel(confirm_read) {

  if (confirm_read) {
    $.get('popup_cookie_settings.php?mode=set_full_cookie');
  }
  if ($("div#eucl_panel")) {
    $("div#eucl_panel").slideUp("slow");
  }

  if (panel_timer) {
    clearTimeout(panel_timer);
  }
  panel_timer = null;
}

function func_change_cookie_settings() {
  popupOpen('popup_cookie_settings.php', '', {width: 600, height: 520});
  func_down_eucl_panel();
}

function func_is_allowed_cookie(name) {

  if (!allowed_cookies || allowed_cookies.length === 0) {
    return true;
  }

  for (var i = 0; i < allowed_cookies.length; i++) {
    if (name === allowed_cookies[i]) {
      return true;
    }
  }

  return false;

}

function func_reset_unallowed_cookies() {
  var cookies = func_get_all_cookies();

  for (var name in cookies) {
    if (!func_is_allowed_cookie(name)) {
      deleteCookie(name);
    }
  }
}

function func_get_all_cookies() {

  var cookies = {};
  if (document.cookie && document.cookie !== '') {
    var split = document.cookie.split(';');
    for (var i = 0; i < split.length; i++) {
      var name_value = split[i].split("=");
      name_value[0] = name_value[0].replace(/^ /, '');
      cookies[decodeURIComponent(name_value[0])] = decodeURIComponent(name_value[1]);
    }
  }

  return cookies;
}

/*load lib on jquery load. is supported from 4.7.9 only aimcompatible*/
if (typeof jQuery !== 'undefined') {
    _EU_Cookie_Law_func_js();
} else {
    document.addEventListener('jQuery_lib_is_loaded', function(e) { _EU_Cookie_Law_func_js(); });
}
