CREATE TABLE IF NOT EXISTS xcart_gdpr_access_log (
  service_id varchar(255) NOT NULL DEFAULT '' COMMENT 'related to xcart_modules/xcart_shipping/xcart_payments and so on',
  `category` enum('Shippings','Payments','Admins','Modules','Other') DEFAULT 'Other',
  active enum('Y','N') DEFAULT 'Y',
  initial_access_date int NOT NULL DEFAULT '0',
  update_date int NOT NULL DEFAULT '0',
  description varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (service_id),
  KEY updateAll(update_date)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS xcart_gdpr_modules (
  module_name varchar(255) NOT NULL DEFAULT '' COMMENT 'key for xcart_modules.module_name',
  PRIMARY KEY (module_name)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS xcart_gdpr_user_consents (
  id mediumint unsigned NOT NULL DEFAULT '0' COMMENT 'first_orderid or userid',
  consent_page enum('order','user') DEFAULT 'order',
  ip_user varchar(45) NOT NULL DEFAULT '',
  user_email varchar(128) NOT NULL DEFAULT '',
  orders_count smallint unsigned NOT NULL DEFAULT '0',
  initial_date int NOT NULL DEFAULT '0',
  update_date int NOT NULL DEFAULT '0',
  agreement_id mediumint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (id, consent_page),
  KEY func_delete_order(user_email,consent_page),
  KEY AgreementsSaveVersion(agreement_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='func_delete_order cannot be unique to work properly with registered customers properly';

CREATE TABLE IF NOT EXISTS xcart_gdpr_agreement_versions (
  agreement_id mediumint unsigned NOT NULL AUTO_INCREMENT,
  agreement_text text NOT NULL,
  PRIMARY KEY (agreement_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;




UPDATE xcart_modules SET module_descr='The module makes your X-Cart store GDPR compliant',  tags='userexp,misc', author='qualiteam'  WHERE module_name='EU_Cookie_Law';


DELETE FROM xcart_pages WHERE filename ='gdpr_statement.html';
INSERT INTO xcart_pages (filename,title,`level`,orderby,active,language,show_in_menu,meta_description,meta_keywords,title_tag) VALUES ('gdpr_statement.html','PRIVACY STATEMENT','E',60,'Y','en','Y','','','') ON DUPLICATE KEY UPDATE `level`=`level`;
INSERT INTO xcart_clean_urls VALUES ('Gdpr-statement','S',LAST_INSERT_ID(),UNIX_TIMESTAMP()) ON DUPLICATE KEY UPDATE clean_url=clean_url;


INSERT INTO xcart_config SET name='gdpr_static_pageid', comment='Id of the static page to use in the GDPR popup at checkout (Edit the page before use!)', value=LAST_INSERT_ID(), category='EU_Cookie_Law', orderby='30', `type`='selector', defvalue=LAST_INSERT_ID(), variants='func_gdpr_get_static_pages', validation='uintz' ON DUPLICATE KEY UPDATE orderby=orderby;
INSERT INTO xcart_config SET name='gdpr_disable_terms_checkbox', comment='Disable the checkbox \'I accept the "Terms & Conditions" and "Privacy statement"\'', value='N', category='EU_Cookie_Law', orderby='20', `type`='checkbox', defvalue='N', variants='', validation='' ON DUPLICATE KEY UPDATE orderby=orderby;
INSERT INTO xcart_config SET name='gdpr_sep_recommendation', comment='It is recommended to install the PHP <a href=\"https://php.net/manual/en/geoip.installation.php\" target=\"_blank\">GeoIP extension</a> to limit the display of the popup to EU visitors only', value='N', category='EU_Cookie_Law', orderby='200', `type`='separator', defvalue='', variants='', validation='' ON DUPLICATE KEY UPDATE orderby=orderby;

INSERT INTO xcart_gdpr_agreement_versions (agreement_text) VALUES('');




INSERT IGNORE INTO xcart_gdpr_modules VALUES
('Adv_Mailchimp_Subscription'),
('Alibaba_Wholesale'),
('Amazon_Checkout'),
('Amazon_Payments_Advanced'),
('Anti_Fraud'),
('Automated_Shipping_Refunds_71LBS'),
('AvaTax'),
('Bill_Me_Later'),
('Bongo_International'),
('Braintree'),
('CSI_TaxJar'),
('Google_Ads_Kliken'),
('Google_Analytics'),
('IContact_Subscription'),
('Kayako_Connector'),
('Klarna_Payments'),
('Mandrill'),
('Meritus_Payment_Solutions'),
('Mobile_Admin'),
('PayPal_Here'),
('PayPal_Login'),
('Pilibaba'),
('Pitney_Bowes'),
('QuickBooks'),
('Segment'),
('ShippingEasy'),
('Shopper_Approved'),
('Simplify'),
('Stripe'),
('Stripe_Apple_Pay'),
('TaxCloud'),
('Testimonials'),
('TwoFactorAuth'),
('Wordpress_in_Xcart'),
('XAuth'),
('XBackup'),
('XPayments_Connector'),
('XPayments_Subscriptions');
