CREATE TABLE IF NOT EXISTS `xcart_taxjar_cache` (
  `cache_key` binary(32) NOT NULL COMMENT 'md5(). Use func_binary_empty',
  `value` text NOT NULL,
  `expr` int NOT NULL DEFAULT 0,
  PRIMARY KEY (`cache_key`),
  KEY func_taxjar_CacheRemove (`expr`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





ALTER TABLE xcart_products ADD COLUMN csi_taxjar_code varchar(14) NOT NULL DEFAULT '00000';

INSERT INTO xcart_modules SET module_name='CSI_TaxJar', module_descr='TaxJar integration', active='N', init_orderby='0', author='qualiteam', module_url='', tags='taxes' ON DUPLICATE KEY UPDATE author='qualiteam', tags='taxes';


INSERT IGNORE INTO `xcart_config` (`name`, `comment`, `value`, `category`, `orderby`, `type`, `defvalue`, `variants`, `validation`, `signature`) VALUES
('taxjar_api_live', 'API LIVE key. To get your API key log in to your TaxJar account and go to Account > API Access.', '', 'CSI_TaxJar', 10, 'text', '', '', '', ''),
('taxjar_api_test', 'API TEST key. To get your API key log in to your TaxJar account and go to Account > API Access.', '', 'CSI_TaxJar', 20, 'text', '', '', '', ''),
('taxjar_env', 'Environment', 'live', 'CSI_TaxJar', 30, 'selector', 'live', 'live:Live\ntest:Test', '', ''),
('taxjar_usa_nexus', 'Calculate USA sales tax only for listed states. You can set nexus USA states here or in your TaxJar account. Setting them here will save you TaxJar transactions. List state codes using a comma, a semicolon or new line as a delimiter.', '', 'CSI_TaxJar', 40, 'textarea', '', '', '', ''),
('taxjar_validate_address', 'Enable address validation. Address validation requires a TaxJar Plus subscription.', 'N', 'CSI_TaxJar', 50, 'checkbox', 'N', '', '', ''),
('taxjar_send_info', 'Send create/update information for orders/refunds/customers to TaxJar. Activate this option if planning to use TaxJar reports and filing.', 'Y', 'CSI_TaxJar', 60, 'checkbox', 'Y', '', '', ''),
('taxjar_ttl', 'Cache TTL in minutes.', '240', 'CSI_TaxJar', 70, 'text', '240', '', '', ''),
('taxjar_debug', 'Enable debug mode. Keep this option disabled unless there is a problem with tax calculation and you need to investigate. With this option enabled the complete TaxJar request and response are saved in the cart log directory.', 'N', 'CSI_TaxJar', 80, 'checkbox', 'N', '', '', ''),
('taxjar_ship_local', 'In-house pickup shipping method', '0', 'CSI_TaxJar', 90, 'selector', '0', '0:None', '', '');
