INSERT INTO xcart_modules (module_name, module_descr, active, init_orderby, author, module_url, tags) VALUES ('TwoFactorAuth','Two-Factor Authentication','N',0,'qualiteam','','security') ON DUPLICATE KEY UPDATE author='qualiteam', tags='security';

CREATE TABLE IF NOT EXISTS `xcart_twofactor_dialing_codes` (
  `country` char(2) NOT NULL,
  `code` smallint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`country`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `xcart_twofactor_users` (
  `userid` int NOT NULL,
  `authyid` int NOT NULL,
  `data_hash` binary(32) NOT NULL COMMENT 'md5(). Use func_binary_empty',
  PRIMARY KEY (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT IGNORE INTO xcart_config SET name='twofactor_api_key', comment='Authy API key', value='', category='TwoFactorAuth', orderby='10', type='trimmed_text', defvalue='', variants='', validation='';
INSERT IGNORE INTO xcart_config SET name='twofactor_verify_A', comment='Enable two-factor authentication for administrators', value='Y', category='TwoFactorAuth', orderby='110', type='checkbox', defvalue='Y', variants='', validation='';
INSERT IGNORE INTO xcart_config SET name='twofactor_verify_P', comment='Enable two-factor authentication for providers', value='Y', category='TwoFactorAuth', orderby='120', type='checkbox', defvalue='Y', variants='', validation='';
INSERT IGNORE INTO xcart_config SET name='twofactor_verify_C', comment='Enable two-factor authentication for customers', value='validate_only', category='TwoFactorAuth', orderby='130', type='selector', defvalue='validate_only', variants='Y:Yes\nvalidate_only:Validate phone number only\nN:No', validation='';
INSERT IGNORE INTO xcart_config SET name='twofactor_force_sms', comment='Force send SMS to smartphone app users', value='N', category='TwoFactorAuth', orderby='200', type='checkbox', defvalue='N', variants='', validation='';





REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AD',376);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AE',971);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AF',93);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AG',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AI',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AL',355);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AM',374);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AO',244);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AR',54);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AS',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AT',43);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AU',61);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AW',297);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('AZ',994);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BA',387);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BB',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BD',880);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BE',32);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BF',226);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BG',359);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BH',973);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BI',257);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BJ',229);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BM',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BN',673);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BO',591);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BR',55);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BS',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BT',975);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BW',267);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BY',375);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('BZ',501);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CA',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CD',243);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CF',236);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CG',242);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CH',41);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CI',225);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CK',682);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CL',56);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CM',237);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CN',853);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CO',57);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CR',506);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CU',53);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CV',238);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CY',357);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('CZ',420);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DE',49);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DJ',253);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DK',45);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DM',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DO',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('DZ',213);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('EC',593);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('EE',372);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('EG',20);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ER',291);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ES',34);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ET',251);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FI',358);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FJ',679);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FK',500);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FM',691);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FO',298);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('FR',33);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GA',241);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GB',44);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GD',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GE',995);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GF',594);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GH',233);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GI',350);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GL',299);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GM',220);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GN',224);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GP',590);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GQ',240);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GR',30);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GT',502);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GU',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GW',245);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('GY',592);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('HK',852);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('HN',504);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('HR',385);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('HT',509);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('HU',36);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ID',62);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IE',353);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IL',972);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IN',91);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IQ',964);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IR',98);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IS',354);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('IT',39);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('JM',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('JO',962);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('JP',81);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KE',254);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KG',996);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KH',855);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KI',686);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KM',269);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KP',82);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KW',965);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KY',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('KZ',7);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LA',856);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LB',961);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LI',423);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LK',94);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LR',231);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LS',266);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LT',370);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LU',352);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LV',371);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('LY',218);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MA',212);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MC',377);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MD',373);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ME',382);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MG',261);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MH',692);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MK',389);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ML',252);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MM',95);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MN',976);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MP',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MQ',596);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MR',222);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MS',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MT',356);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MU',230);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MV',960);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MW',265);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MX',52);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MY',60);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('MZ',258);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NA',264);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NC',687);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NE',227);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NG',234);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NI',505);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NL',31);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NO',47);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NP',977);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NR',674);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NU',683);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('NZ',64);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('OM',968);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PA',507);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PE',51);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PF',689);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PG',675);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PH',63);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PK',92);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PL',48);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PR',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PT',351);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PW',680);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('PY',595);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('QA',974);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('RO',40);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('RS',381);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('RU',7);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('RW',250);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SA',966);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SB',677);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SC',248);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SD',249);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SE',46);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SG',65);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SI',386);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SK',421);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SL',232);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SM',378);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SN',221);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SR',597);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ST',239);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SV',503);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SY',963);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('SZ',268);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TC',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TD',235);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TG',228);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TH',66);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TJ',992);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TK',690);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TL',670);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TM',993);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TN',216);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TO',676);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TR',90);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TT',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TV',688);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TW',886);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('TZ',255);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('UA',380);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('UG',256);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('US',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('UY',598);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('UZ',998);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VA',39);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VE',58);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VG',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VI',1);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VN',84);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('VU',678);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('WF',681);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('WS',685);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('YE',967);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ZA',27);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ZM',260);
REPLACE INTO `xcart_twofactor_dialing_codes` VALUES ('ZW',263);
