<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>         |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: https://www.x-cart.com/license-agreement-classic.html |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 *
 * @category   Modules
 * @package    X-Cart
 * @subpackage Two-Factor authentication via Authy
 * @author     Ildar Amankulov
 * @copyright  Copyright (c) 2001-present Qualiteam software Ltd <info@x-cart.com>
 * @license    https://www.x-cart.com/license-agreement-classic.html X-Cart license agreement
 * @version    c3c5d9d66fd379f06231f8d08787bd396b9e1b82, v1 (xcart_4_7_12), 2020-02-10 11:51:41, twofactor_token.php, aim
 * @link       https://www.x-cart.com/
 * @see        ____file_see____
 */

define('OFFERS_DONT_SHOW_NEW', 1);

require './auth.php';

require $xcart_dir . '/include/common.php';

if (
    func_twofactor_is_waiting_for_token($current_area)
    || empty($show_message)
    || !isset($open_in_layer)
) {
    require $xcart_dir . '/modules/TwoFactorAuth/twofactor_token.php';
}

$location[isset($open_in_layer) ? 0 : ''] = array(func_get_langvar_by_name('lbl_twofactor_token_verification'), '');

// Assign Smarty variables and show template

$smarty->assign('main', 'twofactor_token_verify');
$smarty->assign('minicart_total_items', 0);

// Assign the current location line
$smarty->assign('location', $location);

if (!isset($open_in_layer)) {

    func_display('customer/home.tpl', $smarty);

} else {

    if (empty($show_message)) {
        $template_name = 'modules/TwoFactorAuth/customer/token_form.tpl';
    } else {
        $template_name = 'modules/TwoFactorAuth/customer/message.tpl';
    }

    $smarty->assign('template_name', $template_name);

    func_display('customer/help/popup_info.tpl', $smarty);

}
